// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: src/main/java/com/google/devtools/build/lib/starlarkdebug/proto/starlark_debugging.proto

package com.google.devtools.build.lib.starlarkdebugging;

public final class StarlarkDebuggingProtos {
  private StarlarkDebuggingProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  /**
   * <pre>
   * Describes the stepping behavior that should occur when execution of a thread
   * is continued.
   * </pre>
   *
   * Protobuf enum {@code starlark_debugging.Stepping}
   */
  public enum Stepping
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <pre>
     * Do not step; continue execution until it completes or is paused for some
     * other reason (such as hitting another breakpoint).
     * </pre>
     *
     * <code>NONE = 0;</code>
     */
    NONE(0),
    /**
     * <pre>
     * If the thread is paused on a statement that contains a function call,
     * step into that function. Otherwise, this is the same as OVER.
     * </pre>
     *
     * <code>INTO = 1;</code>
     */
    INTO(1),
    /**
     * <pre>
     * Step over the next statement and any functions that it may call.
     * </pre>
     *
     * <code>OVER = 2;</code>
     */
    OVER(2),
    /**
     * <pre>
     * Continue execution until the current function has been exited and then
     * pause.
     * </pre>
     *
     * <code>OUT = 3;</code>
     */
    OUT(3),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * Do not step; continue execution until it completes or is paused for some
     * other reason (such as hitting another breakpoint).
     * </pre>
     *
     * <code>NONE = 0;</code>
     */
    public static final int NONE_VALUE = 0;
    /**
     * <pre>
     * If the thread is paused on a statement that contains a function call,
     * step into that function. Otherwise, this is the same as OVER.
     * </pre>
     *
     * <code>INTO = 1;</code>
     */
    public static final int INTO_VALUE = 1;
    /**
     * <pre>
     * Step over the next statement and any functions that it may call.
     * </pre>
     *
     * <code>OVER = 2;</code>
     */
    public static final int OVER_VALUE = 2;
    /**
     * <pre>
     * Continue execution until the current function has been exited and then
     * pause.
     * </pre>
     *
     * <code>OUT = 3;</code>
     */
    public static final int OUT_VALUE = 3;


    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static Stepping valueOf(int value) {
      return forNumber(value);
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     */
    public static Stepping forNumber(int value) {
      switch (value) {
        case 0: return NONE;
        case 1: return INTO;
        case 2: return OVER;
        case 3: return OUT;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<Stepping>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        Stepping> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<Stepping>() {
            public Stepping findValueByNumber(int number) {
              return Stepping.forNumber(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalStateException(
            "Can't get the descriptor of an unrecognized enum value.");
      }
      return getDescriptor().getValues().get(ordinal());
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.getDescriptor().getEnumTypes().get(0);
    }

    private static final Stepping[] VALUES = values();

    public static Stepping valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      if (desc.getIndex() == -1) {
        return UNRECOGNIZED;
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private Stepping(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:starlark_debugging.Stepping)
  }

  /**
   * <pre>
   * The reason why a thread was paused.
   * </pre>
   *
   * Protobuf enum {@code starlark_debugging.PauseReason}
   */
  public enum PauseReason
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <pre>
     * The debug server hasn't set any reason.
     * </pre>
     *
     * <code>UNSET = 0;</code>
     */
    UNSET(0),
    /**
     * <pre>
     * The stepping condition in a ContinueExecutionRequest was hit.
     * </pre>
     *
     * <code>STEPPING = 1;</code>
     */
    STEPPING(1),
    /**
     * <pre>
     * A PauseThreadRequest was sent with thread_id=0.
     * </pre>
     *
     * <code>ALL_THREADS_PAUSED = 2;</code>
     */
    ALL_THREADS_PAUSED(2),
    /**
     * <pre>
     * A PauseThreadRequest was sent with thread_id matching this thread.
     * </pre>
     *
     * <code>PAUSE_THREAD_REQUEST = 3;</code>
     */
    PAUSE_THREAD_REQUEST(3),
    /**
     * <pre>
     * A breakpoint was hit.
     * </pre>
     *
     * <code>HIT_BREAKPOINT = 4;</code>
     */
    HIT_BREAKPOINT(4),
    /**
     * <pre>
     * An error occurred while evaluating a breakpoint condition.
     * </pre>
     *
     * <code>CONDITIONAL_BREAKPOINT_ERROR = 5;</code>
     */
    CONDITIONAL_BREAKPOINT_ERROR(5),
    /**
     * <pre>
     * Debugging just started, and a StartDebuggingRequest has not yet been
     * received and processed.
     * </pre>
     *
     * <code>INITIALIZING = 6;</code>
     */
    INITIALIZING(6),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * The debug server hasn't set any reason.
     * </pre>
     *
     * <code>UNSET = 0;</code>
     */
    public static final int UNSET_VALUE = 0;
    /**
     * <pre>
     * The stepping condition in a ContinueExecutionRequest was hit.
     * </pre>
     *
     * <code>STEPPING = 1;</code>
     */
    public static final int STEPPING_VALUE = 1;
    /**
     * <pre>
     * A PauseThreadRequest was sent with thread_id=0.
     * </pre>
     *
     * <code>ALL_THREADS_PAUSED = 2;</code>
     */
    public static final int ALL_THREADS_PAUSED_VALUE = 2;
    /**
     * <pre>
     * A PauseThreadRequest was sent with thread_id matching this thread.
     * </pre>
     *
     * <code>PAUSE_THREAD_REQUEST = 3;</code>
     */
    public static final int PAUSE_THREAD_REQUEST_VALUE = 3;
    /**
     * <pre>
     * A breakpoint was hit.
     * </pre>
     *
     * <code>HIT_BREAKPOINT = 4;</code>
     */
    public static final int HIT_BREAKPOINT_VALUE = 4;
    /**
     * <pre>
     * An error occurred while evaluating a breakpoint condition.
     * </pre>
     *
     * <code>CONDITIONAL_BREAKPOINT_ERROR = 5;</code>
     */
    public static final int CONDITIONAL_BREAKPOINT_ERROR_VALUE = 5;
    /**
     * <pre>
     * Debugging just started, and a StartDebuggingRequest has not yet been
     * received and processed.
     * </pre>
     *
     * <code>INITIALIZING = 6;</code>
     */
    public static final int INITIALIZING_VALUE = 6;


    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static PauseReason valueOf(int value) {
      return forNumber(value);
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     */
    public static PauseReason forNumber(int value) {
      switch (value) {
        case 0: return UNSET;
        case 1: return STEPPING;
        case 2: return ALL_THREADS_PAUSED;
        case 3: return PAUSE_THREAD_REQUEST;
        case 4: return HIT_BREAKPOINT;
        case 5: return CONDITIONAL_BREAKPOINT_ERROR;
        case 6: return INITIALIZING;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<PauseReason>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        PauseReason> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<PauseReason>() {
            public PauseReason findValueByNumber(int number) {
              return PauseReason.forNumber(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalStateException(
            "Can't get the descriptor of an unrecognized enum value.");
      }
      return getDescriptor().getValues().get(ordinal());
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.getDescriptor().getEnumTypes().get(1);
    }

    private static final PauseReason[] VALUES = values();

    public static PauseReason valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      if (desc.getIndex() == -1) {
        return UNRECOGNIZED;
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private PauseReason(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:starlark_debugging.PauseReason)
  }

  public interface DebugRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.DebugRequest)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * A number (intended to be sequentially generated by the client) that
     * identifies the request. The response sent by the server will contain the
     * same sequence number so that the client can synchronize its activity if
     * desired.
     * </pre>
     *
     * <code>int64 sequence_number = 1;</code>
     * @return The sequenceNumber.
     */
    long getSequenceNumber();

    /**
     * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
     * @return Whether the setBreakpoints field is set.
     */
    boolean hasSetBreakpoints();
    /**
     * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
     * @return The setBreakpoints.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest getSetBreakpoints();
    /**
     * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequestOrBuilder getSetBreakpointsOrBuilder();

    /**
     * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
     * @return Whether the continueExecution field is set.
     */
    boolean hasContinueExecution();
    /**
     * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
     * @return The continueExecution.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest getContinueExecution();
    /**
     * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequestOrBuilder getContinueExecutionOrBuilder();

    /**
     * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
     * @return Whether the evaluate field is set.
     */
    boolean hasEvaluate();
    /**
     * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
     * @return The evaluate.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest getEvaluate();
    /**
     * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequestOrBuilder getEvaluateOrBuilder();

    /**
     * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
     * @return Whether the listFrames field is set.
     */
    boolean hasListFrames();
    /**
     * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
     * @return The listFrames.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest getListFrames();
    /**
     * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequestOrBuilder getListFramesOrBuilder();

    /**
     * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
     * @return Whether the startDebugging field is set.
     */
    boolean hasStartDebugging();
    /**
     * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
     * @return The startDebugging.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest getStartDebugging();
    /**
     * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequestOrBuilder getStartDebuggingOrBuilder();

    /**
     * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
     * @return Whether the pauseThread field is set.
     */
    boolean hasPauseThread();
    /**
     * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
     * @return The pauseThread.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest getPauseThread();
    /**
     * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequestOrBuilder getPauseThreadOrBuilder();

    /**
     * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
     * @return Whether the getChildren field is set.
     */
    boolean hasGetChildren();
    /**
     * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
     * @return The getChildren.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest getGetChildren();
    /**
     * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequestOrBuilder getGetChildrenOrBuilder();

    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.PayloadCase getPayloadCase();
  }
  /**
   * <pre>
   * A request sent by the debug client to the debug server.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.DebugRequest}
   */
  public static final class DebugRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.DebugRequest)
      DebugRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use DebugRequest.newBuilder() to construct.
    private DebugRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private DebugRequest() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new DebugRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.Builder.class);
    }

    private int payloadCase_ = 0;
    private java.lang.Object payload_;
    public enum PayloadCase
        implements com.google.protobuf.Internal.EnumLite,
            com.google.protobuf.AbstractMessage.InternalOneOfEnum {
      SET_BREAKPOINTS(101),
      CONTINUE_EXECUTION(102),
      EVALUATE(103),
      LIST_FRAMES(104),
      START_DEBUGGING(105),
      PAUSE_THREAD(106),
      GET_CHILDREN(107),
      PAYLOAD_NOT_SET(0);
      private final int value;
      private PayloadCase(int value) {
        this.value = value;
      }
      /**
       * @param value The number of the enum to look for.
       * @return The enum associated with the given number.
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static PayloadCase valueOf(int value) {
        return forNumber(value);
      }

      public static PayloadCase forNumber(int value) {
        switch (value) {
          case 101: return SET_BREAKPOINTS;
          case 102: return CONTINUE_EXECUTION;
          case 103: return EVALUATE;
          case 104: return LIST_FRAMES;
          case 105: return START_DEBUGGING;
          case 106: return PAUSE_THREAD;
          case 107: return GET_CHILDREN;
          case 0: return PAYLOAD_NOT_SET;
          default: return null;
        }
      }
      public int getNumber() {
        return this.value;
      }
    };

    public PayloadCase
    getPayloadCase() {
      return PayloadCase.forNumber(
          payloadCase_);
    }

    public static final int SEQUENCE_NUMBER_FIELD_NUMBER = 1;
    private long sequenceNumber_;
    /**
     * <pre>
     * A number (intended to be sequentially generated by the client) that
     * identifies the request. The response sent by the server will contain the
     * same sequence number so that the client can synchronize its activity if
     * desired.
     * </pre>
     *
     * <code>int64 sequence_number = 1;</code>
     * @return The sequenceNumber.
     */
    @java.lang.Override
    public long getSequenceNumber() {
      return sequenceNumber_;
    }

    public static final int SET_BREAKPOINTS_FIELD_NUMBER = 101;
    /**
     * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
     * @return Whether the setBreakpoints field is set.
     */
    @java.lang.Override
    public boolean hasSetBreakpoints() {
      return payloadCase_ == 101;
    }
    /**
     * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
     * @return The setBreakpoints.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest getSetBreakpoints() {
      if (payloadCase_ == 101) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequestOrBuilder getSetBreakpointsOrBuilder() {
      if (payloadCase_ == 101) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance();
    }

    public static final int CONTINUE_EXECUTION_FIELD_NUMBER = 102;
    /**
     * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
     * @return Whether the continueExecution field is set.
     */
    @java.lang.Override
    public boolean hasContinueExecution() {
      return payloadCase_ == 102;
    }
    /**
     * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
     * @return The continueExecution.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest getContinueExecution() {
      if (payloadCase_ == 102) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequestOrBuilder getContinueExecutionOrBuilder() {
      if (payloadCase_ == 102) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance();
    }

    public static final int EVALUATE_FIELD_NUMBER = 103;
    /**
     * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
     * @return Whether the evaluate field is set.
     */
    @java.lang.Override
    public boolean hasEvaluate() {
      return payloadCase_ == 103;
    }
    /**
     * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
     * @return The evaluate.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest getEvaluate() {
      if (payloadCase_ == 103) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequestOrBuilder getEvaluateOrBuilder() {
      if (payloadCase_ == 103) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance();
    }

    public static final int LIST_FRAMES_FIELD_NUMBER = 104;
    /**
     * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
     * @return Whether the listFrames field is set.
     */
    @java.lang.Override
    public boolean hasListFrames() {
      return payloadCase_ == 104;
    }
    /**
     * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
     * @return The listFrames.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest getListFrames() {
      if (payloadCase_ == 104) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequestOrBuilder getListFramesOrBuilder() {
      if (payloadCase_ == 104) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance();
    }

    public static final int START_DEBUGGING_FIELD_NUMBER = 105;
    /**
     * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
     * @return Whether the startDebugging field is set.
     */
    @java.lang.Override
    public boolean hasStartDebugging() {
      return payloadCase_ == 105;
    }
    /**
     * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
     * @return The startDebugging.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest getStartDebugging() {
      if (payloadCase_ == 105) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequestOrBuilder getStartDebuggingOrBuilder() {
      if (payloadCase_ == 105) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance();
    }

    public static final int PAUSE_THREAD_FIELD_NUMBER = 106;
    /**
     * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
     * @return Whether the pauseThread field is set.
     */
    @java.lang.Override
    public boolean hasPauseThread() {
      return payloadCase_ == 106;
    }
    /**
     * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
     * @return The pauseThread.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest getPauseThread() {
      if (payloadCase_ == 106) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequestOrBuilder getPauseThreadOrBuilder() {
      if (payloadCase_ == 106) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance();
    }

    public static final int GET_CHILDREN_FIELD_NUMBER = 107;
    /**
     * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
     * @return Whether the getChildren field is set.
     */
    @java.lang.Override
    public boolean hasGetChildren() {
      return payloadCase_ == 107;
    }
    /**
     * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
     * @return The getChildren.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest getGetChildren() {
      if (payloadCase_ == 107) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequestOrBuilder getGetChildrenOrBuilder() {
      if (payloadCase_ == 107) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (sequenceNumber_ != 0L) {
        output.writeInt64(1, sequenceNumber_);
      }
      if (payloadCase_ == 101) {
        output.writeMessage(101, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_);
      }
      if (payloadCase_ == 102) {
        output.writeMessage(102, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_);
      }
      if (payloadCase_ == 103) {
        output.writeMessage(103, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_);
      }
      if (payloadCase_ == 104) {
        output.writeMessage(104, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_);
      }
      if (payloadCase_ == 105) {
        output.writeMessage(105, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_);
      }
      if (payloadCase_ == 106) {
        output.writeMessage(106, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_);
      }
      if (payloadCase_ == 107) {
        output.writeMessage(107, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (sequenceNumber_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sequenceNumber_);
      }
      if (payloadCase_ == 101) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(101, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_);
      }
      if (payloadCase_ == 102) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(102, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_);
      }
      if (payloadCase_ == 103) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(103, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_);
      }
      if (payloadCase_ == 104) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(104, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_);
      }
      if (payloadCase_ == 105) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(105, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_);
      }
      if (payloadCase_ == 106) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(106, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_);
      }
      if (payloadCase_ == 107) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(107, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest) obj;

      if (getSequenceNumber()
          != other.getSequenceNumber()) return false;
      if (!getPayloadCase().equals(other.getPayloadCase())) return false;
      switch (payloadCase_) {
        case 101:
          if (!getSetBreakpoints()
              .equals(other.getSetBreakpoints())) return false;
          break;
        case 102:
          if (!getContinueExecution()
              .equals(other.getContinueExecution())) return false;
          break;
        case 103:
          if (!getEvaluate()
              .equals(other.getEvaluate())) return false;
          break;
        case 104:
          if (!getListFrames()
              .equals(other.getListFrames())) return false;
          break;
        case 105:
          if (!getStartDebugging()
              .equals(other.getStartDebugging())) return false;
          break;
        case 106:
          if (!getPauseThread()
              .equals(other.getPauseThread())) return false;
          break;
        case 107:
          if (!getGetChildren()
              .equals(other.getGetChildren())) return false;
          break;
        case 0:
        default:
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + SEQUENCE_NUMBER_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getSequenceNumber());
      switch (payloadCase_) {
        case 101:
          hash = (37 * hash) + SET_BREAKPOINTS_FIELD_NUMBER;
          hash = (53 * hash) + getSetBreakpoints().hashCode();
          break;
        case 102:
          hash = (37 * hash) + CONTINUE_EXECUTION_FIELD_NUMBER;
          hash = (53 * hash) + getContinueExecution().hashCode();
          break;
        case 103:
          hash = (37 * hash) + EVALUATE_FIELD_NUMBER;
          hash = (53 * hash) + getEvaluate().hashCode();
          break;
        case 104:
          hash = (37 * hash) + LIST_FRAMES_FIELD_NUMBER;
          hash = (53 * hash) + getListFrames().hashCode();
          break;
        case 105:
          hash = (37 * hash) + START_DEBUGGING_FIELD_NUMBER;
          hash = (53 * hash) + getStartDebugging().hashCode();
          break;
        case 106:
          hash = (37 * hash) + PAUSE_THREAD_FIELD_NUMBER;
          hash = (53 * hash) + getPauseThread().hashCode();
          break;
        case 107:
          hash = (37 * hash) + GET_CHILDREN_FIELD_NUMBER;
          hash = (53 * hash) + getGetChildren().hashCode();
          break;
        case 0:
        default:
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request sent by the debug client to the debug server.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.DebugRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.DebugRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        sequenceNumber_ = 0L;

        if (setBreakpointsBuilder_ != null) {
          setBreakpointsBuilder_.clear();
        }
        if (continueExecutionBuilder_ != null) {
          continueExecutionBuilder_.clear();
        }
        if (evaluateBuilder_ != null) {
          evaluateBuilder_.clear();
        }
        if (listFramesBuilder_ != null) {
          listFramesBuilder_.clear();
        }
        if (startDebuggingBuilder_ != null) {
          startDebuggingBuilder_.clear();
        }
        if (pauseThreadBuilder_ != null) {
          pauseThreadBuilder_.clear();
        }
        if (getChildrenBuilder_ != null) {
          getChildrenBuilder_.clear();
        }
        payloadCase_ = 0;
        payload_ = null;
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest(this);
        result.sequenceNumber_ = sequenceNumber_;
        if (payloadCase_ == 101) {
          if (setBreakpointsBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = setBreakpointsBuilder_.build();
          }
        }
        if (payloadCase_ == 102) {
          if (continueExecutionBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = continueExecutionBuilder_.build();
          }
        }
        if (payloadCase_ == 103) {
          if (evaluateBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = evaluateBuilder_.build();
          }
        }
        if (payloadCase_ == 104) {
          if (listFramesBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = listFramesBuilder_.build();
          }
        }
        if (payloadCase_ == 105) {
          if (startDebuggingBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = startDebuggingBuilder_.build();
          }
        }
        if (payloadCase_ == 106) {
          if (pauseThreadBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = pauseThreadBuilder_.build();
          }
        }
        if (payloadCase_ == 107) {
          if (getChildrenBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = getChildrenBuilder_.build();
          }
        }
        result.payloadCase_ = payloadCase_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest.getDefaultInstance()) return this;
        if (other.getSequenceNumber() != 0L) {
          setSequenceNumber(other.getSequenceNumber());
        }
        switch (other.getPayloadCase()) {
          case SET_BREAKPOINTS: {
            mergeSetBreakpoints(other.getSetBreakpoints());
            break;
          }
          case CONTINUE_EXECUTION: {
            mergeContinueExecution(other.getContinueExecution());
            break;
          }
          case EVALUATE: {
            mergeEvaluate(other.getEvaluate());
            break;
          }
          case LIST_FRAMES: {
            mergeListFrames(other.getListFrames());
            break;
          }
          case START_DEBUGGING: {
            mergeStartDebugging(other.getStartDebugging());
            break;
          }
          case PAUSE_THREAD: {
            mergePauseThread(other.getPauseThread());
            break;
          }
          case GET_CHILDREN: {
            mergeGetChildren(other.getGetChildren());
            break;
          }
          case PAYLOAD_NOT_SET: {
            break;
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                sequenceNumber_ = input.readInt64();

                break;
              } // case 8
              case 810: {
                input.readMessage(
                    getSetBreakpointsFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 101;
                break;
              } // case 810
              case 818: {
                input.readMessage(
                    getContinueExecutionFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 102;
                break;
              } // case 818
              case 826: {
                input.readMessage(
                    getEvaluateFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 103;
                break;
              } // case 826
              case 834: {
                input.readMessage(
                    getListFramesFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 104;
                break;
              } // case 834
              case 842: {
                input.readMessage(
                    getStartDebuggingFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 105;
                break;
              } // case 842
              case 850: {
                input.readMessage(
                    getPauseThreadFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 106;
                break;
              } // case 850
              case 858: {
                input.readMessage(
                    getGetChildrenFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 107;
                break;
              } // case 858
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int payloadCase_ = 0;
      private java.lang.Object payload_;
      public PayloadCase
          getPayloadCase() {
        return PayloadCase.forNumber(
            payloadCase_);
      }

      public Builder clearPayload() {
        payloadCase_ = 0;
        payload_ = null;
        onChanged();
        return this;
      }


      private long sequenceNumber_ ;
      /**
       * <pre>
       * A number (intended to be sequentially generated by the client) that
       * identifies the request. The response sent by the server will contain the
       * same sequence number so that the client can synchronize its activity if
       * desired.
       * </pre>
       *
       * <code>int64 sequence_number = 1;</code>
       * @return The sequenceNumber.
       */
      @java.lang.Override
      public long getSequenceNumber() {
        return sequenceNumber_;
      }
      /**
       * <pre>
       * A number (intended to be sequentially generated by the client) that
       * identifies the request. The response sent by the server will contain the
       * same sequence number so that the client can synchronize its activity if
       * desired.
       * </pre>
       *
       * <code>int64 sequence_number = 1;</code>
       * @param value The sequenceNumber to set.
       * @return This builder for chaining.
       */
      public Builder setSequenceNumber(long value) {
        
        sequenceNumber_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A number (intended to be sequentially generated by the client) that
       * identifies the request. The response sent by the server will contain the
       * same sequence number so that the client can synchronize its activity if
       * desired.
       * </pre>
       *
       * <code>int64 sequence_number = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearSequenceNumber() {
        
        sequenceNumber_ = 0L;
        onChanged();
        return this;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequestOrBuilder> setBreakpointsBuilder_;
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       * @return Whether the setBreakpoints field is set.
       */
      @java.lang.Override
      public boolean hasSetBreakpoints() {
        return payloadCase_ == 101;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       * @return The setBreakpoints.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest getSetBreakpoints() {
        if (setBreakpointsBuilder_ == null) {
          if (payloadCase_ == 101) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance();
        } else {
          if (payloadCase_ == 101) {
            return setBreakpointsBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       */
      public Builder setSetBreakpoints(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest value) {
        if (setBreakpointsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          setBreakpointsBuilder_.setMessage(value);
        }
        payloadCase_ = 101;
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       */
      public Builder setSetBreakpoints(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.Builder builderForValue) {
        if (setBreakpointsBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          setBreakpointsBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 101;
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       */
      public Builder mergeSetBreakpoints(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest value) {
        if (setBreakpointsBuilder_ == null) {
          if (payloadCase_ == 101 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 101) {
            setBreakpointsBuilder_.mergeFrom(value);
          }
          setBreakpointsBuilder_.setMessage(value);
        }
        payloadCase_ = 101;
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       */
      public Builder clearSetBreakpoints() {
        if (setBreakpointsBuilder_ == null) {
          if (payloadCase_ == 101) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 101) {
            payloadCase_ = 0;
            payload_ = null;
          }
          setBreakpointsBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.Builder getSetBreakpointsBuilder() {
        return getSetBreakpointsFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequestOrBuilder getSetBreakpointsOrBuilder() {
        if ((payloadCase_ == 101) && (setBreakpointsBuilder_ != null)) {
          return setBreakpointsBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 101) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsRequest set_breakpoints = 101;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequestOrBuilder> 
          getSetBreakpointsFieldBuilder() {
        if (setBreakpointsBuilder_ == null) {
          if (!(payloadCase_ == 101)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance();
          }
          setBreakpointsBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequestOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 101;
        onChanged();;
        return setBreakpointsBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequestOrBuilder> continueExecutionBuilder_;
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       * @return Whether the continueExecution field is set.
       */
      @java.lang.Override
      public boolean hasContinueExecution() {
        return payloadCase_ == 102;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       * @return The continueExecution.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest getContinueExecution() {
        if (continueExecutionBuilder_ == null) {
          if (payloadCase_ == 102) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance();
        } else {
          if (payloadCase_ == 102) {
            return continueExecutionBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       */
      public Builder setContinueExecution(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest value) {
        if (continueExecutionBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          continueExecutionBuilder_.setMessage(value);
        }
        payloadCase_ = 102;
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       */
      public Builder setContinueExecution(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.Builder builderForValue) {
        if (continueExecutionBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          continueExecutionBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 102;
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       */
      public Builder mergeContinueExecution(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest value) {
        if (continueExecutionBuilder_ == null) {
          if (payloadCase_ == 102 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 102) {
            continueExecutionBuilder_.mergeFrom(value);
          }
          continueExecutionBuilder_.setMessage(value);
        }
        payloadCase_ = 102;
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       */
      public Builder clearContinueExecution() {
        if (continueExecutionBuilder_ == null) {
          if (payloadCase_ == 102) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 102) {
            payloadCase_ = 0;
            payload_ = null;
          }
          continueExecutionBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.Builder getContinueExecutionBuilder() {
        return getContinueExecutionFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequestOrBuilder getContinueExecutionOrBuilder() {
        if ((payloadCase_ == 102) && (continueExecutionBuilder_ != null)) {
          return continueExecutionBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 102) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionRequest continue_execution = 102;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequestOrBuilder> 
          getContinueExecutionFieldBuilder() {
        if (continueExecutionBuilder_ == null) {
          if (!(payloadCase_ == 102)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance();
          }
          continueExecutionBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequestOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 102;
        onChanged();;
        return continueExecutionBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequestOrBuilder> evaluateBuilder_;
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       * @return Whether the evaluate field is set.
       */
      @java.lang.Override
      public boolean hasEvaluate() {
        return payloadCase_ == 103;
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       * @return The evaluate.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest getEvaluate() {
        if (evaluateBuilder_ == null) {
          if (payloadCase_ == 103) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance();
        } else {
          if (payloadCase_ == 103) {
            return evaluateBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       */
      public Builder setEvaluate(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest value) {
        if (evaluateBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          evaluateBuilder_.setMessage(value);
        }
        payloadCase_ = 103;
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       */
      public Builder setEvaluate(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.Builder builderForValue) {
        if (evaluateBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          evaluateBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 103;
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       */
      public Builder mergeEvaluate(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest value) {
        if (evaluateBuilder_ == null) {
          if (payloadCase_ == 103 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 103) {
            evaluateBuilder_.mergeFrom(value);
          }
          evaluateBuilder_.setMessage(value);
        }
        payloadCase_ = 103;
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       */
      public Builder clearEvaluate() {
        if (evaluateBuilder_ == null) {
          if (payloadCase_ == 103) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 103) {
            payloadCase_ = 0;
            payload_ = null;
          }
          evaluateBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.Builder getEvaluateBuilder() {
        return getEvaluateFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequestOrBuilder getEvaluateOrBuilder() {
        if ((payloadCase_ == 103) && (evaluateBuilder_ != null)) {
          return evaluateBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 103) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.EvaluateRequest evaluate = 103;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequestOrBuilder> 
          getEvaluateFieldBuilder() {
        if (evaluateBuilder_ == null) {
          if (!(payloadCase_ == 103)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance();
          }
          evaluateBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequestOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 103;
        onChanged();;
        return evaluateBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequestOrBuilder> listFramesBuilder_;
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       * @return Whether the listFrames field is set.
       */
      @java.lang.Override
      public boolean hasListFrames() {
        return payloadCase_ == 104;
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       * @return The listFrames.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest getListFrames() {
        if (listFramesBuilder_ == null) {
          if (payloadCase_ == 104) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance();
        } else {
          if (payloadCase_ == 104) {
            return listFramesBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       */
      public Builder setListFrames(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest value) {
        if (listFramesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          listFramesBuilder_.setMessage(value);
        }
        payloadCase_ = 104;
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       */
      public Builder setListFrames(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.Builder builderForValue) {
        if (listFramesBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          listFramesBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 104;
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       */
      public Builder mergeListFrames(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest value) {
        if (listFramesBuilder_ == null) {
          if (payloadCase_ == 104 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 104) {
            listFramesBuilder_.mergeFrom(value);
          }
          listFramesBuilder_.setMessage(value);
        }
        payloadCase_ = 104;
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       */
      public Builder clearListFrames() {
        if (listFramesBuilder_ == null) {
          if (payloadCase_ == 104) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 104) {
            payloadCase_ = 0;
            payload_ = null;
          }
          listFramesBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.Builder getListFramesBuilder() {
        return getListFramesFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequestOrBuilder getListFramesOrBuilder() {
        if ((payloadCase_ == 104) && (listFramesBuilder_ != null)) {
          return listFramesBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 104) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ListFramesRequest list_frames = 104;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequestOrBuilder> 
          getListFramesFieldBuilder() {
        if (listFramesBuilder_ == null) {
          if (!(payloadCase_ == 104)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance();
          }
          listFramesBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequestOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 104;
        onChanged();;
        return listFramesBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequestOrBuilder> startDebuggingBuilder_;
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       * @return Whether the startDebugging field is set.
       */
      @java.lang.Override
      public boolean hasStartDebugging() {
        return payloadCase_ == 105;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       * @return The startDebugging.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest getStartDebugging() {
        if (startDebuggingBuilder_ == null) {
          if (payloadCase_ == 105) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance();
        } else {
          if (payloadCase_ == 105) {
            return startDebuggingBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       */
      public Builder setStartDebugging(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest value) {
        if (startDebuggingBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          startDebuggingBuilder_.setMessage(value);
        }
        payloadCase_ = 105;
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       */
      public Builder setStartDebugging(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.Builder builderForValue) {
        if (startDebuggingBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          startDebuggingBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 105;
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       */
      public Builder mergeStartDebugging(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest value) {
        if (startDebuggingBuilder_ == null) {
          if (payloadCase_ == 105 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 105) {
            startDebuggingBuilder_.mergeFrom(value);
          }
          startDebuggingBuilder_.setMessage(value);
        }
        payloadCase_ = 105;
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       */
      public Builder clearStartDebugging() {
        if (startDebuggingBuilder_ == null) {
          if (payloadCase_ == 105) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 105) {
            payloadCase_ = 0;
            payload_ = null;
          }
          startDebuggingBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.Builder getStartDebuggingBuilder() {
        return getStartDebuggingFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequestOrBuilder getStartDebuggingOrBuilder() {
        if ((payloadCase_ == 105) && (startDebuggingBuilder_ != null)) {
          return startDebuggingBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 105) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.StartDebuggingRequest start_debugging = 105;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequestOrBuilder> 
          getStartDebuggingFieldBuilder() {
        if (startDebuggingBuilder_ == null) {
          if (!(payloadCase_ == 105)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance();
          }
          startDebuggingBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequestOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 105;
        onChanged();;
        return startDebuggingBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequestOrBuilder> pauseThreadBuilder_;
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       * @return Whether the pauseThread field is set.
       */
      @java.lang.Override
      public boolean hasPauseThread() {
        return payloadCase_ == 106;
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       * @return The pauseThread.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest getPauseThread() {
        if (pauseThreadBuilder_ == null) {
          if (payloadCase_ == 106) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance();
        } else {
          if (payloadCase_ == 106) {
            return pauseThreadBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       */
      public Builder setPauseThread(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest value) {
        if (pauseThreadBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          pauseThreadBuilder_.setMessage(value);
        }
        payloadCase_ = 106;
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       */
      public Builder setPauseThread(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.Builder builderForValue) {
        if (pauseThreadBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          pauseThreadBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 106;
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       */
      public Builder mergePauseThread(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest value) {
        if (pauseThreadBuilder_ == null) {
          if (payloadCase_ == 106 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 106) {
            pauseThreadBuilder_.mergeFrom(value);
          }
          pauseThreadBuilder_.setMessage(value);
        }
        payloadCase_ = 106;
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       */
      public Builder clearPauseThread() {
        if (pauseThreadBuilder_ == null) {
          if (payloadCase_ == 106) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 106) {
            payloadCase_ = 0;
            payload_ = null;
          }
          pauseThreadBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.Builder getPauseThreadBuilder() {
        return getPauseThreadFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequestOrBuilder getPauseThreadOrBuilder() {
        if ((payloadCase_ == 106) && (pauseThreadBuilder_ != null)) {
          return pauseThreadBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 106) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.PauseThreadRequest pause_thread = 106;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequestOrBuilder> 
          getPauseThreadFieldBuilder() {
        if (pauseThreadBuilder_ == null) {
          if (!(payloadCase_ == 106)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance();
          }
          pauseThreadBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequestOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 106;
        onChanged();;
        return pauseThreadBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequestOrBuilder> getChildrenBuilder_;
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       * @return Whether the getChildren field is set.
       */
      @java.lang.Override
      public boolean hasGetChildren() {
        return payloadCase_ == 107;
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       * @return The getChildren.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest getGetChildren() {
        if (getChildrenBuilder_ == null) {
          if (payloadCase_ == 107) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance();
        } else {
          if (payloadCase_ == 107) {
            return getChildrenBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       */
      public Builder setGetChildren(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest value) {
        if (getChildrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          getChildrenBuilder_.setMessage(value);
        }
        payloadCase_ = 107;
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       */
      public Builder setGetChildren(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.Builder builderForValue) {
        if (getChildrenBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          getChildrenBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 107;
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       */
      public Builder mergeGetChildren(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest value) {
        if (getChildrenBuilder_ == null) {
          if (payloadCase_ == 107 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 107) {
            getChildrenBuilder_.mergeFrom(value);
          }
          getChildrenBuilder_.setMessage(value);
        }
        payloadCase_ = 107;
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       */
      public Builder clearGetChildren() {
        if (getChildrenBuilder_ == null) {
          if (payloadCase_ == 107) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 107) {
            payloadCase_ = 0;
            payload_ = null;
          }
          getChildrenBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.Builder getGetChildrenBuilder() {
        return getGetChildrenFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequestOrBuilder getGetChildrenOrBuilder() {
        if ((payloadCase_ == 107) && (getChildrenBuilder_ != null)) {
          return getChildrenBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 107) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.GetChildrenRequest get_children = 107;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequestOrBuilder> 
          getGetChildrenFieldBuilder() {
        if (getChildrenBuilder_ == null) {
          if (!(payloadCase_ == 107)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance();
          }
          getChildrenBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequestOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 107;
        onChanged();;
        return getChildrenBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.DebugRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.DebugRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<DebugRequest>
        PARSER = new com.google.protobuf.AbstractParser<DebugRequest>() {
      @java.lang.Override
      public DebugRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<DebugRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<DebugRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface SetBreakpointsRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.SetBreakpointsRequest)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint> 
        getBreakpointList();
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint getBreakpoint(int index);
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    int getBreakpointCount();
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder> 
        getBreakpointOrBuilderList();
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder getBreakpointOrBuilder(
        int index);
  }
  /**
   * <pre>
   * A request to update the breakpoints used by the debug server.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.SetBreakpointsRequest}
   */
  public static final class SetBreakpointsRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.SetBreakpointsRequest)
      SetBreakpointsRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use SetBreakpointsRequest.newBuilder() to construct.
    private SetBreakpointsRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private SetBreakpointsRequest() {
      breakpoint_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new SetBreakpointsRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.Builder.class);
    }

    public static final int BREAKPOINT_FIELD_NUMBER = 1;
    private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint> breakpoint_;
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint> getBreakpointList() {
      return breakpoint_;
    }
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    @java.lang.Override
    public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder> 
        getBreakpointOrBuilderList() {
      return breakpoint_;
    }
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    @java.lang.Override
    public int getBreakpointCount() {
      return breakpoint_.size();
    }
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint getBreakpoint(int index) {
      return breakpoint_.get(index);
    }
    /**
     * <pre>
     * The breakpoints that describe where the debug server should pause
     * evaluation.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder getBreakpointOrBuilder(
        int index) {
      return breakpoint_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      for (int i = 0; i < breakpoint_.size(); i++) {
        output.writeMessage(1, breakpoint_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      for (int i = 0; i < breakpoint_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, breakpoint_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) obj;

      if (!getBreakpointList()
          .equals(other.getBreakpointList())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (getBreakpointCount() > 0) {
        hash = (37 * hash) + BREAKPOINT_FIELD_NUMBER;
        hash = (53 * hash) + getBreakpointList().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request to update the breakpoints used by the debug server.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.SetBreakpointsRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.SetBreakpointsRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (breakpointBuilder_ == null) {
          breakpoint_ = java.util.Collections.emptyList();
        } else {
          breakpoint_ = null;
          breakpointBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest(this);
        int from_bitField0_ = bitField0_;
        if (breakpointBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0)) {
            breakpoint_ = java.util.Collections.unmodifiableList(breakpoint_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.breakpoint_ = breakpoint_;
        } else {
          result.breakpoint_ = breakpointBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest.getDefaultInstance()) return this;
        if (breakpointBuilder_ == null) {
          if (!other.breakpoint_.isEmpty()) {
            if (breakpoint_.isEmpty()) {
              breakpoint_ = other.breakpoint_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureBreakpointIsMutable();
              breakpoint_.addAll(other.breakpoint_);
            }
            onChanged();
          }
        } else {
          if (!other.breakpoint_.isEmpty()) {
            if (breakpointBuilder_.isEmpty()) {
              breakpointBuilder_.dispose();
              breakpointBuilder_ = null;
              breakpoint_ = other.breakpoint_;
              bitField0_ = (bitField0_ & ~0x00000001);
              breakpointBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getBreakpointFieldBuilder() : null;
            } else {
              breakpointBuilder_.addAllMessages(other.breakpoint_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint m =
                    input.readMessage(
                        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.parser(),
                        extensionRegistry);
                if (breakpointBuilder_ == null) {
                  ensureBreakpointIsMutable();
                  breakpoint_.add(m);
                } else {
                  breakpointBuilder_.addMessage(m);
                }
                break;
              } // case 10
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int bitField0_;

      private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint> breakpoint_ =
        java.util.Collections.emptyList();
      private void ensureBreakpointIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          breakpoint_ = new java.util.ArrayList<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint>(breakpoint_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder> breakpointBuilder_;

      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint> getBreakpointList() {
        if (breakpointBuilder_ == null) {
          return java.util.Collections.unmodifiableList(breakpoint_);
        } else {
          return breakpointBuilder_.getMessageList();
        }
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public int getBreakpointCount() {
        if (breakpointBuilder_ == null) {
          return breakpoint_.size();
        } else {
          return breakpointBuilder_.getCount();
        }
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint getBreakpoint(int index) {
        if (breakpointBuilder_ == null) {
          return breakpoint_.get(index);
        } else {
          return breakpointBuilder_.getMessage(index);
        }
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder setBreakpoint(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint value) {
        if (breakpointBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBreakpointIsMutable();
          breakpoint_.set(index, value);
          onChanged();
        } else {
          breakpointBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder setBreakpoint(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder builderForValue) {
        if (breakpointBuilder_ == null) {
          ensureBreakpointIsMutable();
          breakpoint_.set(index, builderForValue.build());
          onChanged();
        } else {
          breakpointBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder addBreakpoint(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint value) {
        if (breakpointBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBreakpointIsMutable();
          breakpoint_.add(value);
          onChanged();
        } else {
          breakpointBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder addBreakpoint(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint value) {
        if (breakpointBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBreakpointIsMutable();
          breakpoint_.add(index, value);
          onChanged();
        } else {
          breakpointBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder addBreakpoint(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder builderForValue) {
        if (breakpointBuilder_ == null) {
          ensureBreakpointIsMutable();
          breakpoint_.add(builderForValue.build());
          onChanged();
        } else {
          breakpointBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder addBreakpoint(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder builderForValue) {
        if (breakpointBuilder_ == null) {
          ensureBreakpointIsMutable();
          breakpoint_.add(index, builderForValue.build());
          onChanged();
        } else {
          breakpointBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder addAllBreakpoint(
          java.lang.Iterable<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint> values) {
        if (breakpointBuilder_ == null) {
          ensureBreakpointIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, breakpoint_);
          onChanged();
        } else {
          breakpointBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder clearBreakpoint() {
        if (breakpointBuilder_ == null) {
          breakpoint_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          breakpointBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public Builder removeBreakpoint(int index) {
        if (breakpointBuilder_ == null) {
          ensureBreakpointIsMutable();
          breakpoint_.remove(index);
          onChanged();
        } else {
          breakpointBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder getBreakpointBuilder(
          int index) {
        return getBreakpointFieldBuilder().getBuilder(index);
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder getBreakpointOrBuilder(
          int index) {
        if (breakpointBuilder_ == null) {
          return breakpoint_.get(index);  } else {
          return breakpointBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder> 
           getBreakpointOrBuilderList() {
        if (breakpointBuilder_ != null) {
          return breakpointBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(breakpoint_);
        }
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder addBreakpointBuilder() {
        return getBreakpointFieldBuilder().addBuilder(
            com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.getDefaultInstance());
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder addBreakpointBuilder(
          int index) {
        return getBreakpointFieldBuilder().addBuilder(
            index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.getDefaultInstance());
      }
      /**
       * <pre>
       * The breakpoints that describe where the debug server should pause
       * evaluation.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Breakpoint breakpoint = 1;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder> 
           getBreakpointBuilderList() {
        return getBreakpointFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder> 
          getBreakpointFieldBuilder() {
        if (breakpointBuilder_ == null) {
          breakpointBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder>(
                  breakpoint_,
                  ((bitField0_ & 0x00000001) != 0),
                  getParentForChildren(),
                  isClean());
          breakpoint_ = null;
        }
        return breakpointBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.SetBreakpointsRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.SetBreakpointsRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<SetBreakpointsRequest>
        PARSER = new com.google.protobuf.AbstractParser<SetBreakpointsRequest>() {
      @java.lang.Override
      public SetBreakpointsRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<SetBreakpointsRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<SetBreakpointsRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ContinueExecutionRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.ContinueExecutionRequest)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    long getThreadId();

    /**
     * <pre>
     * Describes the stepping behavior to use when continuing execution.
     * </pre>
     *
     * <code>.starlark_debugging.Stepping stepping = 2;</code>
     * @return The enum numeric value on the wire for stepping.
     */
    int getSteppingValue();
    /**
     * <pre>
     * Describes the stepping behavior to use when continuing execution.
     * </pre>
     *
     * <code>.starlark_debugging.Stepping stepping = 2;</code>
     * @return The stepping.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping getStepping();
  }
  /**
   * <pre>
   * A request to continue execution on a paused or stepping thread. (A stepping
   * thread is a thread that is running as the result of a previous
   * ContinueExecutionRequest with non-NONE stepping.)
   * A paused thread will be resumed with the given stepping, unless thread_id is
   * 0. A stepping thread will continue to run with its stepping condition
   * removed, as if it were already paused.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.ContinueExecutionRequest}
   */
  public static final class ContinueExecutionRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.ContinueExecutionRequest)
      ContinueExecutionRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ContinueExecutionRequest.newBuilder() to construct.
    private ContinueExecutionRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ContinueExecutionRequest() {
      stepping_ = 0;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new ContinueExecutionRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.Builder.class);
    }

    public static final int THREAD_ID_FIELD_NUMBER = 1;
    private long threadId_;
    /**
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    @java.lang.Override
    public long getThreadId() {
      return threadId_;
    }

    public static final int STEPPING_FIELD_NUMBER = 2;
    private int stepping_;
    /**
     * <pre>
     * Describes the stepping behavior to use when continuing execution.
     * </pre>
     *
     * <code>.starlark_debugging.Stepping stepping = 2;</code>
     * @return The enum numeric value on the wire for stepping.
     */
    @java.lang.Override public int getSteppingValue() {
      return stepping_;
    }
    /**
     * <pre>
     * Describes the stepping behavior to use when continuing execution.
     * </pre>
     *
     * <code>.starlark_debugging.Stepping stepping = 2;</code>
     * @return The stepping.
     */
    @java.lang.Override public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping getStepping() {
      @SuppressWarnings("deprecation")
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping result = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping.valueOf(stepping_);
      return result == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping.UNRECOGNIZED : result;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (threadId_ != 0L) {
        output.writeInt64(1, threadId_);
      }
      if (stepping_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping.NONE.getNumber()) {
        output.writeEnum(2, stepping_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (threadId_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, threadId_);
      }
      if (stepping_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping.NONE.getNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(2, stepping_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) obj;

      if (getThreadId()
          != other.getThreadId()) return false;
      if (stepping_ != other.stepping_) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + THREAD_ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getThreadId());
      hash = (37 * hash) + STEPPING_FIELD_NUMBER;
      hash = (53 * hash) + stepping_;
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request to continue execution on a paused or stepping thread. (A stepping
     * thread is a thread that is running as the result of a previous
     * ContinueExecutionRequest with non-NONE stepping.)
     * A paused thread will be resumed with the given stepping, unless thread_id is
     * 0. A stepping thread will continue to run with its stepping condition
     * removed, as if it were already paused.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.ContinueExecutionRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.ContinueExecutionRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        threadId_ = 0L;

        stepping_ = 0;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest(this);
        result.threadId_ = threadId_;
        result.stepping_ = stepping_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest.getDefaultInstance()) return this;
        if (other.getThreadId() != 0L) {
          setThreadId(other.getThreadId());
        }
        if (other.stepping_ != 0) {
          setSteppingValue(other.getSteppingValue());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                threadId_ = input.readInt64();

                break;
              } // case 8
              case 16: {
                stepping_ = input.readEnum();

                break;
              } // case 16
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private long threadId_ ;
      /**
       * <code>int64 thread_id = 1;</code>
       * @return The threadId.
       */
      @java.lang.Override
      public long getThreadId() {
        return threadId_;
      }
      /**
       * <code>int64 thread_id = 1;</code>
       * @param value The threadId to set.
       * @return This builder for chaining.
       */
      public Builder setThreadId(long value) {
        
        threadId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>int64 thread_id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearThreadId() {
        
        threadId_ = 0L;
        onChanged();
        return this;
      }

      private int stepping_ = 0;
      /**
       * <pre>
       * Describes the stepping behavior to use when continuing execution.
       * </pre>
       *
       * <code>.starlark_debugging.Stepping stepping = 2;</code>
       * @return The enum numeric value on the wire for stepping.
       */
      @java.lang.Override public int getSteppingValue() {
        return stepping_;
      }
      /**
       * <pre>
       * Describes the stepping behavior to use when continuing execution.
       * </pre>
       *
       * <code>.starlark_debugging.Stepping stepping = 2;</code>
       * @param value The enum numeric value on the wire for stepping to set.
       * @return This builder for chaining.
       */
      public Builder setSteppingValue(int value) {
        
        stepping_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Describes the stepping behavior to use when continuing execution.
       * </pre>
       *
       * <code>.starlark_debugging.Stepping stepping = 2;</code>
       * @return The stepping.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping getStepping() {
        @SuppressWarnings("deprecation")
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping result = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping.valueOf(stepping_);
        return result == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping.UNRECOGNIZED : result;
      }
      /**
       * <pre>
       * Describes the stepping behavior to use when continuing execution.
       * </pre>
       *
       * <code>.starlark_debugging.Stepping stepping = 2;</code>
       * @param value The stepping to set.
       * @return This builder for chaining.
       */
      public Builder setStepping(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Stepping value) {
        if (value == null) {
          throw new NullPointerException();
        }
        
        stepping_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Describes the stepping behavior to use when continuing execution.
       * </pre>
       *
       * <code>.starlark_debugging.Stepping stepping = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearStepping() {
        
        stepping_ = 0;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.ContinueExecutionRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.ContinueExecutionRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<ContinueExecutionRequest>
        PARSER = new com.google.protobuf.AbstractParser<ContinueExecutionRequest>() {
      @java.lang.Override
      public ContinueExecutionRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<ContinueExecutionRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<ContinueExecutionRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface EvaluateRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.EvaluateRequest)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The identifier of the thread in whose execution context the expression
     * should be evaluated.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    long getThreadId();

    /**
     * <pre>
     * The Starlark statement to evaluate.
     * </pre>
     *
     * <code>string statement = 2;</code>
     * @return The statement.
     */
    java.lang.String getStatement();
    /**
     * <pre>
     * The Starlark statement to evaluate.
     * </pre>
     *
     * <code>string statement = 2;</code>
     * @return The bytes for statement.
     */
    com.google.protobuf.ByteString
        getStatementBytes();
  }
  /**
   * <pre>
   * A request to evaluate a Starlark statement in a thread's current environment.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.EvaluateRequest}
   */
  public static final class EvaluateRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.EvaluateRequest)
      EvaluateRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use EvaluateRequest.newBuilder() to construct.
    private EvaluateRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private EvaluateRequest() {
      statement_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new EvaluateRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.Builder.class);
    }

    public static final int THREAD_ID_FIELD_NUMBER = 1;
    private long threadId_;
    /**
     * <pre>
     * The identifier of the thread in whose execution context the expression
     * should be evaluated.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    @java.lang.Override
    public long getThreadId() {
      return threadId_;
    }

    public static final int STATEMENT_FIELD_NUMBER = 2;
    private volatile java.lang.Object statement_;
    /**
     * <pre>
     * The Starlark statement to evaluate.
     * </pre>
     *
     * <code>string statement = 2;</code>
     * @return The statement.
     */
    @java.lang.Override
    public java.lang.String getStatement() {
      java.lang.Object ref = statement_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        statement_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * The Starlark statement to evaluate.
     * </pre>
     *
     * <code>string statement = 2;</code>
     * @return The bytes for statement.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getStatementBytes() {
      java.lang.Object ref = statement_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        statement_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (threadId_ != 0L) {
        output.writeInt64(1, threadId_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(statement_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, statement_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (threadId_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, threadId_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(statement_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, statement_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) obj;

      if (getThreadId()
          != other.getThreadId()) return false;
      if (!getStatement()
          .equals(other.getStatement())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + THREAD_ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getThreadId());
      hash = (37 * hash) + STATEMENT_FIELD_NUMBER;
      hash = (53 * hash) + getStatement().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request to evaluate a Starlark statement in a thread's current environment.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.EvaluateRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.EvaluateRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        threadId_ = 0L;

        statement_ = "";

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest(this);
        result.threadId_ = threadId_;
        result.statement_ = statement_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest.getDefaultInstance()) return this;
        if (other.getThreadId() != 0L) {
          setThreadId(other.getThreadId());
        }
        if (!other.getStatement().isEmpty()) {
          statement_ = other.statement_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                threadId_ = input.readInt64();

                break;
              } // case 8
              case 18: {
                statement_ = input.readStringRequireUtf8();

                break;
              } // case 18
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private long threadId_ ;
      /**
       * <pre>
       * The identifier of the thread in whose execution context the expression
       * should be evaluated.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return The threadId.
       */
      @java.lang.Override
      public long getThreadId() {
        return threadId_;
      }
      /**
       * <pre>
       * The identifier of the thread in whose execution context the expression
       * should be evaluated.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @param value The threadId to set.
       * @return This builder for chaining.
       */
      public Builder setThreadId(long value) {
        
        threadId_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The identifier of the thread in whose execution context the expression
       * should be evaluated.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearThreadId() {
        
        threadId_ = 0L;
        onChanged();
        return this;
      }

      private java.lang.Object statement_ = "";
      /**
       * <pre>
       * The Starlark statement to evaluate.
       * </pre>
       *
       * <code>string statement = 2;</code>
       * @return The statement.
       */
      public java.lang.String getStatement() {
        java.lang.Object ref = statement_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          statement_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * The Starlark statement to evaluate.
       * </pre>
       *
       * <code>string statement = 2;</code>
       * @return The bytes for statement.
       */
      public com.google.protobuf.ByteString
          getStatementBytes() {
        java.lang.Object ref = statement_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          statement_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * The Starlark statement to evaluate.
       * </pre>
       *
       * <code>string statement = 2;</code>
       * @param value The statement to set.
       * @return This builder for chaining.
       */
      public Builder setStatement(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        statement_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The Starlark statement to evaluate.
       * </pre>
       *
       * <code>string statement = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearStatement() {
        
        statement_ = getDefaultInstance().getStatement();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The Starlark statement to evaluate.
       * </pre>
       *
       * <code>string statement = 2;</code>
       * @param value The bytes for statement to set.
       * @return This builder for chaining.
       */
      public Builder setStatementBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        statement_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.EvaluateRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.EvaluateRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<EvaluateRequest>
        PARSER = new com.google.protobuf.AbstractParser<EvaluateRequest>() {
      @java.lang.Override
      public EvaluateRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<EvaluateRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<EvaluateRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ListFramesRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.ListFramesRequest)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The identifier of the thread whose stack frames should be listed.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    long getThreadId();
  }
  /**
   * <pre>
   * A request to list the stack frames of a thread.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.ListFramesRequest}
   */
  public static final class ListFramesRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.ListFramesRequest)
      ListFramesRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ListFramesRequest.newBuilder() to construct.
    private ListFramesRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ListFramesRequest() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new ListFramesRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.Builder.class);
    }

    public static final int THREAD_ID_FIELD_NUMBER = 1;
    private long threadId_;
    /**
     * <pre>
     * The identifier of the thread whose stack frames should be listed.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    @java.lang.Override
    public long getThreadId() {
      return threadId_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (threadId_ != 0L) {
        output.writeInt64(1, threadId_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (threadId_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, threadId_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) obj;

      if (getThreadId()
          != other.getThreadId()) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + THREAD_ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getThreadId());
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request to list the stack frames of a thread.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.ListFramesRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.ListFramesRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        threadId_ = 0L;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest(this);
        result.threadId_ = threadId_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest.getDefaultInstance()) return this;
        if (other.getThreadId() != 0L) {
          setThreadId(other.getThreadId());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                threadId_ = input.readInt64();

                break;
              } // case 8
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private long threadId_ ;
      /**
       * <pre>
       * The identifier of the thread whose stack frames should be listed.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return The threadId.
       */
      @java.lang.Override
      public long getThreadId() {
        return threadId_;
      }
      /**
       * <pre>
       * The identifier of the thread whose stack frames should be listed.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @param value The threadId to set.
       * @return This builder for chaining.
       */
      public Builder setThreadId(long value) {
        
        threadId_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The identifier of the thread whose stack frames should be listed.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearThreadId() {
        
        threadId_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.ListFramesRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.ListFramesRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<ListFramesRequest>
        PARSER = new com.google.protobuf.AbstractParser<ListFramesRequest>() {
      @java.lang.Override
      public ListFramesRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<ListFramesRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<ListFramesRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface StartDebuggingRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.StartDebuggingRequest)
      com.google.protobuf.MessageOrBuilder {
  }
  /**
   * <pre>
   * A request to begin the debugging session. Starlark execution will block until
   * this request is made, to allow initial setup after the connection is
   * established (e.g. setting breakpoints).
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.StartDebuggingRequest}
   */
  public static final class StartDebuggingRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.StartDebuggingRequest)
      StartDebuggingRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use StartDebuggingRequest.newBuilder() to construct.
    private StartDebuggingRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private StartDebuggingRequest() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new StartDebuggingRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.Builder.class);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) obj;

      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request to begin the debugging session. Starlark execution will block until
     * this request is made, to allow initial setup after the connection is
     * established (e.g. setting breakpoints).
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.StartDebuggingRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.StartDebuggingRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest(this);
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest.getDefaultInstance()) return this;
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.StartDebuggingRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.StartDebuggingRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<StartDebuggingRequest>
        PARSER = new com.google.protobuf.AbstractParser<StartDebuggingRequest>() {
      @java.lang.Override
      public StartDebuggingRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<StartDebuggingRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<StartDebuggingRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface PauseThreadRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.PauseThreadRequest)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The identifier of the thread to be paused.
     * If not set (i.e. zero), all current Starlark threads will be paused, and
     * until a ContinueExecutionRequest is sent, any future Starlark threads will
     * also start off paused.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    long getThreadId();
  }
  /**
   * <pre>
   * A request to pause execution of a thread, or all threads.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.PauseThreadRequest}
   */
  public static final class PauseThreadRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.PauseThreadRequest)
      PauseThreadRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use PauseThreadRequest.newBuilder() to construct.
    private PauseThreadRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private PauseThreadRequest() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new PauseThreadRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.Builder.class);
    }

    public static final int THREAD_ID_FIELD_NUMBER = 1;
    private long threadId_;
    /**
     * <pre>
     * The identifier of the thread to be paused.
     * If not set (i.e. zero), all current Starlark threads will be paused, and
     * until a ContinueExecutionRequest is sent, any future Starlark threads will
     * also start off paused.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    @java.lang.Override
    public long getThreadId() {
      return threadId_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (threadId_ != 0L) {
        output.writeInt64(1, threadId_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (threadId_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, threadId_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) obj;

      if (getThreadId()
          != other.getThreadId()) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + THREAD_ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getThreadId());
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request to pause execution of a thread, or all threads.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.PauseThreadRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.PauseThreadRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        threadId_ = 0L;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest(this);
        result.threadId_ = threadId_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest.getDefaultInstance()) return this;
        if (other.getThreadId() != 0L) {
          setThreadId(other.getThreadId());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                threadId_ = input.readInt64();

                break;
              } // case 8
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private long threadId_ ;
      /**
       * <pre>
       * The identifier of the thread to be paused.
       * If not set (i.e. zero), all current Starlark threads will be paused, and
       * until a ContinueExecutionRequest is sent, any future Starlark threads will
       * also start off paused.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return The threadId.
       */
      @java.lang.Override
      public long getThreadId() {
        return threadId_;
      }
      /**
       * <pre>
       * The identifier of the thread to be paused.
       * If not set (i.e. zero), all current Starlark threads will be paused, and
       * until a ContinueExecutionRequest is sent, any future Starlark threads will
       * also start off paused.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @param value The threadId to set.
       * @return This builder for chaining.
       */
      public Builder setThreadId(long value) {
        
        threadId_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The identifier of the thread to be paused.
       * If not set (i.e. zero), all current Starlark threads will be paused, and
       * until a ContinueExecutionRequest is sent, any future Starlark threads will
       * also start off paused.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearThreadId() {
        
        threadId_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.PauseThreadRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.PauseThreadRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<PauseThreadRequest>
        PARSER = new com.google.protobuf.AbstractParser<PauseThreadRequest>() {
      @java.lang.Override
      public PauseThreadRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<PauseThreadRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<PauseThreadRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface GetChildrenRequestOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.GetChildrenRequest)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The identifier of the relevant thread.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    long getThreadId();

    /**
     * <pre>
     * The identifier of the value for which children are being requested. If the
     * value has no children, an empty list will be returned in
     * GetChildrenResponse.
     * </pre>
     *
     * <code>int64 value_id = 2;</code>
     * @return The valueId.
     */
    long getValueId();
  }
  /**
   * <pre>
   * A request to list the children of a previously-communicated Value, such as
   * its elements (for a list or dictionary), its fields (for a struct), and so
   * forth.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.GetChildrenRequest}
   */
  public static final class GetChildrenRequest extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.GetChildrenRequest)
      GetChildrenRequestOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use GetChildrenRequest.newBuilder() to construct.
    private GetChildrenRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private GetChildrenRequest() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new GetChildrenRequest();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenRequest_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.Builder.class);
    }

    public static final int THREAD_ID_FIELD_NUMBER = 1;
    private long threadId_;
    /**
     * <pre>
     * The identifier of the relevant thread.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    @java.lang.Override
    public long getThreadId() {
      return threadId_;
    }

    public static final int VALUE_ID_FIELD_NUMBER = 2;
    private long valueId_;
    /**
     * <pre>
     * The identifier of the value for which children are being requested. If the
     * value has no children, an empty list will be returned in
     * GetChildrenResponse.
     * </pre>
     *
     * <code>int64 value_id = 2;</code>
     * @return The valueId.
     */
    @java.lang.Override
    public long getValueId() {
      return valueId_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (threadId_ != 0L) {
        output.writeInt64(1, threadId_);
      }
      if (valueId_ != 0L) {
        output.writeInt64(2, valueId_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (threadId_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, threadId_);
      }
      if (valueId_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, valueId_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) obj;

      if (getThreadId()
          != other.getThreadId()) return false;
      if (getValueId()
          != other.getValueId()) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + THREAD_ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getThreadId());
      hash = (37 * hash) + VALUE_ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getValueId());
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A request to list the children of a previously-communicated Value, such as
     * its elements (for a list or dictionary), its fields (for a struct), and so
     * forth.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.GetChildrenRequest}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.GetChildrenRequest)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequestOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenRequest_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenRequest_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        threadId_ = 0L;

        valueId_ = 0L;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenRequest_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest(this);
        result.threadId_ = threadId_;
        result.valueId_ = valueId_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest.getDefaultInstance()) return this;
        if (other.getThreadId() != 0L) {
          setThreadId(other.getThreadId());
        }
        if (other.getValueId() != 0L) {
          setValueId(other.getValueId());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                threadId_ = input.readInt64();

                break;
              } // case 8
              case 16: {
                valueId_ = input.readInt64();

                break;
              } // case 16
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private long threadId_ ;
      /**
       * <pre>
       * The identifier of the relevant thread.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return The threadId.
       */
      @java.lang.Override
      public long getThreadId() {
        return threadId_;
      }
      /**
       * <pre>
       * The identifier of the relevant thread.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @param value The threadId to set.
       * @return This builder for chaining.
       */
      public Builder setThreadId(long value) {
        
        threadId_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The identifier of the relevant thread.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearThreadId() {
        
        threadId_ = 0L;
        onChanged();
        return this;
      }

      private long valueId_ ;
      /**
       * <pre>
       * The identifier of the value for which children are being requested. If the
       * value has no children, an empty list will be returned in
       * GetChildrenResponse.
       * </pre>
       *
       * <code>int64 value_id = 2;</code>
       * @return The valueId.
       */
      @java.lang.Override
      public long getValueId() {
        return valueId_;
      }
      /**
       * <pre>
       * The identifier of the value for which children are being requested. If the
       * value has no children, an empty list will be returned in
       * GetChildrenResponse.
       * </pre>
       *
       * <code>int64 value_id = 2;</code>
       * @param value The valueId to set.
       * @return This builder for chaining.
       */
      public Builder setValueId(long value) {
        
        valueId_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The identifier of the value for which children are being requested. If the
       * value has no children, an empty list will be returned in
       * GetChildrenResponse.
       * </pre>
       *
       * <code>int64 value_id = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearValueId() {
        
        valueId_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.GetChildrenRequest)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.GetChildrenRequest)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<GetChildrenRequest>
        PARSER = new com.google.protobuf.AbstractParser<GetChildrenRequest>() {
      @java.lang.Override
      public GetChildrenRequest parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<GetChildrenRequest> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<GetChildrenRequest> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenRequest getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface DebugEventOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.DebugEvent)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * If non-zero, this event is a response to a DebugRequest with the same
     * sequence number.
     * </pre>
     *
     * <code>int64 sequence_number = 1;</code>
     * @return The sequenceNumber.
     */
    long getSequenceNumber();

    /**
     * <code>.starlark_debugging.Error error = 99;</code>
     * @return Whether the error field is set.
     */
    boolean hasError();
    /**
     * <code>.starlark_debugging.Error error = 99;</code>
     * @return The error.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getError();
    /**
     * <code>.starlark_debugging.Error error = 99;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder getErrorOrBuilder();

    /**
     * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
     * @return Whether the setBreakpoints field is set.
     */
    boolean hasSetBreakpoints();
    /**
     * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
     * @return The setBreakpoints.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse getSetBreakpoints();
    /**
     * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponseOrBuilder getSetBreakpointsOrBuilder();

    /**
     * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
     * @return Whether the continueExecution field is set.
     */
    boolean hasContinueExecution();
    /**
     * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
     * @return The continueExecution.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse getContinueExecution();
    /**
     * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponseOrBuilder getContinueExecutionOrBuilder();

    /**
     * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
     * @return Whether the evaluate field is set.
     */
    boolean hasEvaluate();
    /**
     * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
     * @return The evaluate.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse getEvaluate();
    /**
     * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponseOrBuilder getEvaluateOrBuilder();

    /**
     * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
     * @return Whether the listFrames field is set.
     */
    boolean hasListFrames();
    /**
     * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
     * @return The listFrames.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse getListFrames();
    /**
     * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponseOrBuilder getListFramesOrBuilder();

    /**
     * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
     * @return Whether the startDebugging field is set.
     */
    boolean hasStartDebugging();
    /**
     * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
     * @return The startDebugging.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse getStartDebugging();
    /**
     * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponseOrBuilder getStartDebuggingOrBuilder();

    /**
     * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
     * @return Whether the pauseThread field is set.
     */
    boolean hasPauseThread();
    /**
     * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
     * @return The pauseThread.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse getPauseThread();
    /**
     * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponseOrBuilder getPauseThreadOrBuilder();

    /**
     * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
     * @return Whether the getChildren field is set.
     */
    boolean hasGetChildren();
    /**
     * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
     * @return The getChildren.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse getGetChildren();
    /**
     * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponseOrBuilder getGetChildrenOrBuilder();

    /**
     * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
     * @return Whether the threadPaused field is set.
     */
    boolean hasThreadPaused();
    /**
     * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
     * @return The threadPaused.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent getThreadPaused();
    /**
     * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEventOrBuilder getThreadPausedOrBuilder();

    /**
     * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
     * @return Whether the threadContinued field is set.
     */
    boolean hasThreadContinued();
    /**
     * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
     * @return The threadContinued.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent getThreadContinued();
    /**
     * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEventOrBuilder getThreadContinuedOrBuilder();

    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.PayloadCase getPayloadCase();
  }
  /**
   * <pre>
   * There are two kinds of events: "responses", which correspond to a
   * DebugRequest sent by the client, and other asynchronous events that may be
   * sent by the server to notify the client of activity in the Starlark code
   * being debugged.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.DebugEvent}
   */
  public static final class DebugEvent extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.DebugEvent)
      DebugEventOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use DebugEvent.newBuilder() to construct.
    private DebugEvent(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private DebugEvent() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new DebugEvent();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugEvent_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugEvent_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.Builder.class);
    }

    private int payloadCase_ = 0;
    private java.lang.Object payload_;
    public enum PayloadCase
        implements com.google.protobuf.Internal.EnumLite,
            com.google.protobuf.AbstractMessage.InternalOneOfEnum {
      ERROR(99),
      SET_BREAKPOINTS(101),
      CONTINUE_EXECUTION(102),
      EVALUATE(103),
      LIST_FRAMES(104),
      START_DEBUGGING(105),
      PAUSE_THREAD(106),
      GET_CHILDREN(107),
      THREAD_PAUSED(1001),
      THREAD_CONTINUED(1002),
      PAYLOAD_NOT_SET(0);
      private final int value;
      private PayloadCase(int value) {
        this.value = value;
      }
      /**
       * @param value The number of the enum to look for.
       * @return The enum associated with the given number.
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static PayloadCase valueOf(int value) {
        return forNumber(value);
      }

      public static PayloadCase forNumber(int value) {
        switch (value) {
          case 99: return ERROR;
          case 101: return SET_BREAKPOINTS;
          case 102: return CONTINUE_EXECUTION;
          case 103: return EVALUATE;
          case 104: return LIST_FRAMES;
          case 105: return START_DEBUGGING;
          case 106: return PAUSE_THREAD;
          case 107: return GET_CHILDREN;
          case 1001: return THREAD_PAUSED;
          case 1002: return THREAD_CONTINUED;
          case 0: return PAYLOAD_NOT_SET;
          default: return null;
        }
      }
      public int getNumber() {
        return this.value;
      }
    };

    public PayloadCase
    getPayloadCase() {
      return PayloadCase.forNumber(
          payloadCase_);
    }

    public static final int SEQUENCE_NUMBER_FIELD_NUMBER = 1;
    private long sequenceNumber_;
    /**
     * <pre>
     * If non-zero, this event is a response to a DebugRequest with the same
     * sequence number.
     * </pre>
     *
     * <code>int64 sequence_number = 1;</code>
     * @return The sequenceNumber.
     */
    @java.lang.Override
    public long getSequenceNumber() {
      return sequenceNumber_;
    }

    public static final int ERROR_FIELD_NUMBER = 99;
    /**
     * <code>.starlark_debugging.Error error = 99;</code>
     * @return Whether the error field is set.
     */
    @java.lang.Override
    public boolean hasError() {
      return payloadCase_ == 99;
    }
    /**
     * <code>.starlark_debugging.Error error = 99;</code>
     * @return The error.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getError() {
      if (payloadCase_ == 99) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.Error error = 99;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder getErrorOrBuilder() {
      if (payloadCase_ == 99) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance();
    }

    public static final int SET_BREAKPOINTS_FIELD_NUMBER = 101;
    /**
     * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
     * @return Whether the setBreakpoints field is set.
     */
    @java.lang.Override
    public boolean hasSetBreakpoints() {
      return payloadCase_ == 101;
    }
    /**
     * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
     * @return The setBreakpoints.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse getSetBreakpoints() {
      if (payloadCase_ == 101) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponseOrBuilder getSetBreakpointsOrBuilder() {
      if (payloadCase_ == 101) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance();
    }

    public static final int CONTINUE_EXECUTION_FIELD_NUMBER = 102;
    /**
     * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
     * @return Whether the continueExecution field is set.
     */
    @java.lang.Override
    public boolean hasContinueExecution() {
      return payloadCase_ == 102;
    }
    /**
     * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
     * @return The continueExecution.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse getContinueExecution() {
      if (payloadCase_ == 102) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponseOrBuilder getContinueExecutionOrBuilder() {
      if (payloadCase_ == 102) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance();
    }

    public static final int EVALUATE_FIELD_NUMBER = 103;
    /**
     * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
     * @return Whether the evaluate field is set.
     */
    @java.lang.Override
    public boolean hasEvaluate() {
      return payloadCase_ == 103;
    }
    /**
     * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
     * @return The evaluate.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse getEvaluate() {
      if (payloadCase_ == 103) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponseOrBuilder getEvaluateOrBuilder() {
      if (payloadCase_ == 103) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance();
    }

    public static final int LIST_FRAMES_FIELD_NUMBER = 104;
    /**
     * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
     * @return Whether the listFrames field is set.
     */
    @java.lang.Override
    public boolean hasListFrames() {
      return payloadCase_ == 104;
    }
    /**
     * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
     * @return The listFrames.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse getListFrames() {
      if (payloadCase_ == 104) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponseOrBuilder getListFramesOrBuilder() {
      if (payloadCase_ == 104) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance();
    }

    public static final int START_DEBUGGING_FIELD_NUMBER = 105;
    /**
     * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
     * @return Whether the startDebugging field is set.
     */
    @java.lang.Override
    public boolean hasStartDebugging() {
      return payloadCase_ == 105;
    }
    /**
     * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
     * @return The startDebugging.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse getStartDebugging() {
      if (payloadCase_ == 105) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponseOrBuilder getStartDebuggingOrBuilder() {
      if (payloadCase_ == 105) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance();
    }

    public static final int PAUSE_THREAD_FIELD_NUMBER = 106;
    /**
     * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
     * @return Whether the pauseThread field is set.
     */
    @java.lang.Override
    public boolean hasPauseThread() {
      return payloadCase_ == 106;
    }
    /**
     * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
     * @return The pauseThread.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse getPauseThread() {
      if (payloadCase_ == 106) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponseOrBuilder getPauseThreadOrBuilder() {
      if (payloadCase_ == 106) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance();
    }

    public static final int GET_CHILDREN_FIELD_NUMBER = 107;
    /**
     * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
     * @return Whether the getChildren field is set.
     */
    @java.lang.Override
    public boolean hasGetChildren() {
      return payloadCase_ == 107;
    }
    /**
     * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
     * @return The getChildren.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse getGetChildren() {
      if (payloadCase_ == 107) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponseOrBuilder getGetChildrenOrBuilder() {
      if (payloadCase_ == 107) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance();
    }

    public static final int THREAD_PAUSED_FIELD_NUMBER = 1001;
    /**
     * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
     * @return Whether the threadPaused field is set.
     */
    @java.lang.Override
    public boolean hasThreadPaused() {
      return payloadCase_ == 1001;
    }
    /**
     * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
     * @return The threadPaused.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent getThreadPaused() {
      if (payloadCase_ == 1001) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEventOrBuilder getThreadPausedOrBuilder() {
      if (payloadCase_ == 1001) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance();
    }

    public static final int THREAD_CONTINUED_FIELD_NUMBER = 1002;
    /**
     * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
     * @return Whether the threadContinued field is set.
     */
    @java.lang.Override
    public boolean hasThreadContinued() {
      return payloadCase_ == 1002;
    }
    /**
     * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
     * @return The threadContinued.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent getThreadContinued() {
      if (payloadCase_ == 1002) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance();
    }
    /**
     * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEventOrBuilder getThreadContinuedOrBuilder() {
      if (payloadCase_ == 1002) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (sequenceNumber_ != 0L) {
        output.writeInt64(1, sequenceNumber_);
      }
      if (payloadCase_ == 99) {
        output.writeMessage(99, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_);
      }
      if (payloadCase_ == 101) {
        output.writeMessage(101, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_);
      }
      if (payloadCase_ == 102) {
        output.writeMessage(102, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_);
      }
      if (payloadCase_ == 103) {
        output.writeMessage(103, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_);
      }
      if (payloadCase_ == 104) {
        output.writeMessage(104, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_);
      }
      if (payloadCase_ == 105) {
        output.writeMessage(105, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_);
      }
      if (payloadCase_ == 106) {
        output.writeMessage(106, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_);
      }
      if (payloadCase_ == 107) {
        output.writeMessage(107, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_);
      }
      if (payloadCase_ == 1001) {
        output.writeMessage(1001, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_);
      }
      if (payloadCase_ == 1002) {
        output.writeMessage(1002, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (sequenceNumber_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sequenceNumber_);
      }
      if (payloadCase_ == 99) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(99, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_);
      }
      if (payloadCase_ == 101) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(101, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_);
      }
      if (payloadCase_ == 102) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(102, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_);
      }
      if (payloadCase_ == 103) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(103, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_);
      }
      if (payloadCase_ == 104) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(104, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_);
      }
      if (payloadCase_ == 105) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(105, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_);
      }
      if (payloadCase_ == 106) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(106, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_);
      }
      if (payloadCase_ == 107) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(107, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_);
      }
      if (payloadCase_ == 1001) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1001, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_);
      }
      if (payloadCase_ == 1002) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1002, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent) obj;

      if (getSequenceNumber()
          != other.getSequenceNumber()) return false;
      if (!getPayloadCase().equals(other.getPayloadCase())) return false;
      switch (payloadCase_) {
        case 99:
          if (!getError()
              .equals(other.getError())) return false;
          break;
        case 101:
          if (!getSetBreakpoints()
              .equals(other.getSetBreakpoints())) return false;
          break;
        case 102:
          if (!getContinueExecution()
              .equals(other.getContinueExecution())) return false;
          break;
        case 103:
          if (!getEvaluate()
              .equals(other.getEvaluate())) return false;
          break;
        case 104:
          if (!getListFrames()
              .equals(other.getListFrames())) return false;
          break;
        case 105:
          if (!getStartDebugging()
              .equals(other.getStartDebugging())) return false;
          break;
        case 106:
          if (!getPauseThread()
              .equals(other.getPauseThread())) return false;
          break;
        case 107:
          if (!getGetChildren()
              .equals(other.getGetChildren())) return false;
          break;
        case 1001:
          if (!getThreadPaused()
              .equals(other.getThreadPaused())) return false;
          break;
        case 1002:
          if (!getThreadContinued()
              .equals(other.getThreadContinued())) return false;
          break;
        case 0:
        default:
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + SEQUENCE_NUMBER_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getSequenceNumber());
      switch (payloadCase_) {
        case 99:
          hash = (37 * hash) + ERROR_FIELD_NUMBER;
          hash = (53 * hash) + getError().hashCode();
          break;
        case 101:
          hash = (37 * hash) + SET_BREAKPOINTS_FIELD_NUMBER;
          hash = (53 * hash) + getSetBreakpoints().hashCode();
          break;
        case 102:
          hash = (37 * hash) + CONTINUE_EXECUTION_FIELD_NUMBER;
          hash = (53 * hash) + getContinueExecution().hashCode();
          break;
        case 103:
          hash = (37 * hash) + EVALUATE_FIELD_NUMBER;
          hash = (53 * hash) + getEvaluate().hashCode();
          break;
        case 104:
          hash = (37 * hash) + LIST_FRAMES_FIELD_NUMBER;
          hash = (53 * hash) + getListFrames().hashCode();
          break;
        case 105:
          hash = (37 * hash) + START_DEBUGGING_FIELD_NUMBER;
          hash = (53 * hash) + getStartDebugging().hashCode();
          break;
        case 106:
          hash = (37 * hash) + PAUSE_THREAD_FIELD_NUMBER;
          hash = (53 * hash) + getPauseThread().hashCode();
          break;
        case 107:
          hash = (37 * hash) + GET_CHILDREN_FIELD_NUMBER;
          hash = (53 * hash) + getGetChildren().hashCode();
          break;
        case 1001:
          hash = (37 * hash) + THREAD_PAUSED_FIELD_NUMBER;
          hash = (53 * hash) + getThreadPaused().hashCode();
          break;
        case 1002:
          hash = (37 * hash) + THREAD_CONTINUED_FIELD_NUMBER;
          hash = (53 * hash) + getThreadContinued().hashCode();
          break;
        case 0:
        default:
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * There are two kinds of events: "responses", which correspond to a
     * DebugRequest sent by the client, and other asynchronous events that may be
     * sent by the server to notify the client of activity in the Starlark code
     * being debugged.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.DebugEvent}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.DebugEvent)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEventOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugEvent_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugEvent_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        sequenceNumber_ = 0L;

        if (errorBuilder_ != null) {
          errorBuilder_.clear();
        }
        if (setBreakpointsBuilder_ != null) {
          setBreakpointsBuilder_.clear();
        }
        if (continueExecutionBuilder_ != null) {
          continueExecutionBuilder_.clear();
        }
        if (evaluateBuilder_ != null) {
          evaluateBuilder_.clear();
        }
        if (listFramesBuilder_ != null) {
          listFramesBuilder_.clear();
        }
        if (startDebuggingBuilder_ != null) {
          startDebuggingBuilder_.clear();
        }
        if (pauseThreadBuilder_ != null) {
          pauseThreadBuilder_.clear();
        }
        if (getChildrenBuilder_ != null) {
          getChildrenBuilder_.clear();
        }
        if (threadPausedBuilder_ != null) {
          threadPausedBuilder_.clear();
        }
        if (threadContinuedBuilder_ != null) {
          threadContinuedBuilder_.clear();
        }
        payloadCase_ = 0;
        payload_ = null;
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_DebugEvent_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent(this);
        result.sequenceNumber_ = sequenceNumber_;
        if (payloadCase_ == 99) {
          if (errorBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = errorBuilder_.build();
          }
        }
        if (payloadCase_ == 101) {
          if (setBreakpointsBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = setBreakpointsBuilder_.build();
          }
        }
        if (payloadCase_ == 102) {
          if (continueExecutionBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = continueExecutionBuilder_.build();
          }
        }
        if (payloadCase_ == 103) {
          if (evaluateBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = evaluateBuilder_.build();
          }
        }
        if (payloadCase_ == 104) {
          if (listFramesBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = listFramesBuilder_.build();
          }
        }
        if (payloadCase_ == 105) {
          if (startDebuggingBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = startDebuggingBuilder_.build();
          }
        }
        if (payloadCase_ == 106) {
          if (pauseThreadBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = pauseThreadBuilder_.build();
          }
        }
        if (payloadCase_ == 107) {
          if (getChildrenBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = getChildrenBuilder_.build();
          }
        }
        if (payloadCase_ == 1001) {
          if (threadPausedBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = threadPausedBuilder_.build();
          }
        }
        if (payloadCase_ == 1002) {
          if (threadContinuedBuilder_ == null) {
            result.payload_ = payload_;
          } else {
            result.payload_ = threadContinuedBuilder_.build();
          }
        }
        result.payloadCase_ = payloadCase_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent.getDefaultInstance()) return this;
        if (other.getSequenceNumber() != 0L) {
          setSequenceNumber(other.getSequenceNumber());
        }
        switch (other.getPayloadCase()) {
          case ERROR: {
            mergeError(other.getError());
            break;
          }
          case SET_BREAKPOINTS: {
            mergeSetBreakpoints(other.getSetBreakpoints());
            break;
          }
          case CONTINUE_EXECUTION: {
            mergeContinueExecution(other.getContinueExecution());
            break;
          }
          case EVALUATE: {
            mergeEvaluate(other.getEvaluate());
            break;
          }
          case LIST_FRAMES: {
            mergeListFrames(other.getListFrames());
            break;
          }
          case START_DEBUGGING: {
            mergeStartDebugging(other.getStartDebugging());
            break;
          }
          case PAUSE_THREAD: {
            mergePauseThread(other.getPauseThread());
            break;
          }
          case GET_CHILDREN: {
            mergeGetChildren(other.getGetChildren());
            break;
          }
          case THREAD_PAUSED: {
            mergeThreadPaused(other.getThreadPaused());
            break;
          }
          case THREAD_CONTINUED: {
            mergeThreadContinued(other.getThreadContinued());
            break;
          }
          case PAYLOAD_NOT_SET: {
            break;
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                sequenceNumber_ = input.readInt64();

                break;
              } // case 8
              case 794: {
                input.readMessage(
                    getErrorFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 99;
                break;
              } // case 794
              case 810: {
                input.readMessage(
                    getSetBreakpointsFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 101;
                break;
              } // case 810
              case 818: {
                input.readMessage(
                    getContinueExecutionFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 102;
                break;
              } // case 818
              case 826: {
                input.readMessage(
                    getEvaluateFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 103;
                break;
              } // case 826
              case 834: {
                input.readMessage(
                    getListFramesFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 104;
                break;
              } // case 834
              case 842: {
                input.readMessage(
                    getStartDebuggingFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 105;
                break;
              } // case 842
              case 850: {
                input.readMessage(
                    getPauseThreadFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 106;
                break;
              } // case 850
              case 858: {
                input.readMessage(
                    getGetChildrenFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 107;
                break;
              } // case 858
              case 8010: {
                input.readMessage(
                    getThreadPausedFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 1001;
                break;
              } // case 8010
              case 8018: {
                input.readMessage(
                    getThreadContinuedFieldBuilder().getBuilder(),
                    extensionRegistry);
                payloadCase_ = 1002;
                break;
              } // case 8018
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int payloadCase_ = 0;
      private java.lang.Object payload_;
      public PayloadCase
          getPayloadCase() {
        return PayloadCase.forNumber(
            payloadCase_);
      }

      public Builder clearPayload() {
        payloadCase_ = 0;
        payload_ = null;
        onChanged();
        return this;
      }


      private long sequenceNumber_ ;
      /**
       * <pre>
       * If non-zero, this event is a response to a DebugRequest with the same
       * sequence number.
       * </pre>
       *
       * <code>int64 sequence_number = 1;</code>
       * @return The sequenceNumber.
       */
      @java.lang.Override
      public long getSequenceNumber() {
        return sequenceNumber_;
      }
      /**
       * <pre>
       * If non-zero, this event is a response to a DebugRequest with the same
       * sequence number.
       * </pre>
       *
       * <code>int64 sequence_number = 1;</code>
       * @param value The sequenceNumber to set.
       * @return This builder for chaining.
       */
      public Builder setSequenceNumber(long value) {
        
        sequenceNumber_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * If non-zero, this event is a response to a DebugRequest with the same
       * sequence number.
       * </pre>
       *
       * <code>int64 sequence_number = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearSequenceNumber() {
        
        sequenceNumber_ = 0L;
        onChanged();
        return this;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder> errorBuilder_;
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       * @return Whether the error field is set.
       */
      @java.lang.Override
      public boolean hasError() {
        return payloadCase_ == 99;
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       * @return The error.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getError() {
        if (errorBuilder_ == null) {
          if (payloadCase_ == 99) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance();
        } else {
          if (payloadCase_ == 99) {
            return errorBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       */
      public Builder setError(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error value) {
        if (errorBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          errorBuilder_.setMessage(value);
        }
        payloadCase_ = 99;
        return this;
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       */
      public Builder setError(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder builderForValue) {
        if (errorBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          errorBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 99;
        return this;
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       */
      public Builder mergeError(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error value) {
        if (errorBuilder_ == null) {
          if (payloadCase_ == 99 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 99) {
            errorBuilder_.mergeFrom(value);
          }
          errorBuilder_.setMessage(value);
        }
        payloadCase_ = 99;
        return this;
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       */
      public Builder clearError() {
        if (errorBuilder_ == null) {
          if (payloadCase_ == 99) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 99) {
            payloadCase_ = 0;
            payload_ = null;
          }
          errorBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder getErrorBuilder() {
        return getErrorFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder getErrorOrBuilder() {
        if ((payloadCase_ == 99) && (errorBuilder_ != null)) {
          return errorBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 99) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.Error error = 99;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder> 
          getErrorFieldBuilder() {
        if (errorBuilder_ == null) {
          if (!(payloadCase_ == 99)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance();
          }
          errorBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 99;
        onChanged();;
        return errorBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponseOrBuilder> setBreakpointsBuilder_;
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       * @return Whether the setBreakpoints field is set.
       */
      @java.lang.Override
      public boolean hasSetBreakpoints() {
        return payloadCase_ == 101;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       * @return The setBreakpoints.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse getSetBreakpoints() {
        if (setBreakpointsBuilder_ == null) {
          if (payloadCase_ == 101) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance();
        } else {
          if (payloadCase_ == 101) {
            return setBreakpointsBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       */
      public Builder setSetBreakpoints(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse value) {
        if (setBreakpointsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          setBreakpointsBuilder_.setMessage(value);
        }
        payloadCase_ = 101;
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       */
      public Builder setSetBreakpoints(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.Builder builderForValue) {
        if (setBreakpointsBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          setBreakpointsBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 101;
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       */
      public Builder mergeSetBreakpoints(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse value) {
        if (setBreakpointsBuilder_ == null) {
          if (payloadCase_ == 101 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 101) {
            setBreakpointsBuilder_.mergeFrom(value);
          }
          setBreakpointsBuilder_.setMessage(value);
        }
        payloadCase_ = 101;
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       */
      public Builder clearSetBreakpoints() {
        if (setBreakpointsBuilder_ == null) {
          if (payloadCase_ == 101) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 101) {
            payloadCase_ = 0;
            payload_ = null;
          }
          setBreakpointsBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.Builder getSetBreakpointsBuilder() {
        return getSetBreakpointsFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponseOrBuilder getSetBreakpointsOrBuilder() {
        if ((payloadCase_ == 101) && (setBreakpointsBuilder_ != null)) {
          return setBreakpointsBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 101) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.SetBreakpointsResponse set_breakpoints = 101;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponseOrBuilder> 
          getSetBreakpointsFieldBuilder() {
        if (setBreakpointsBuilder_ == null) {
          if (!(payloadCase_ == 101)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance();
          }
          setBreakpointsBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponseOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 101;
        onChanged();;
        return setBreakpointsBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponseOrBuilder> continueExecutionBuilder_;
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       * @return Whether the continueExecution field is set.
       */
      @java.lang.Override
      public boolean hasContinueExecution() {
        return payloadCase_ == 102;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       * @return The continueExecution.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse getContinueExecution() {
        if (continueExecutionBuilder_ == null) {
          if (payloadCase_ == 102) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance();
        } else {
          if (payloadCase_ == 102) {
            return continueExecutionBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       */
      public Builder setContinueExecution(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse value) {
        if (continueExecutionBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          continueExecutionBuilder_.setMessage(value);
        }
        payloadCase_ = 102;
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       */
      public Builder setContinueExecution(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.Builder builderForValue) {
        if (continueExecutionBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          continueExecutionBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 102;
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       */
      public Builder mergeContinueExecution(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse value) {
        if (continueExecutionBuilder_ == null) {
          if (payloadCase_ == 102 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 102) {
            continueExecutionBuilder_.mergeFrom(value);
          }
          continueExecutionBuilder_.setMessage(value);
        }
        payloadCase_ = 102;
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       */
      public Builder clearContinueExecution() {
        if (continueExecutionBuilder_ == null) {
          if (payloadCase_ == 102) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 102) {
            payloadCase_ = 0;
            payload_ = null;
          }
          continueExecutionBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.Builder getContinueExecutionBuilder() {
        return getContinueExecutionFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponseOrBuilder getContinueExecutionOrBuilder() {
        if ((payloadCase_ == 102) && (continueExecutionBuilder_ != null)) {
          return continueExecutionBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 102) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ContinueExecutionResponse continue_execution = 102;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponseOrBuilder> 
          getContinueExecutionFieldBuilder() {
        if (continueExecutionBuilder_ == null) {
          if (!(payloadCase_ == 102)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance();
          }
          continueExecutionBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponseOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 102;
        onChanged();;
        return continueExecutionBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponseOrBuilder> evaluateBuilder_;
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       * @return Whether the evaluate field is set.
       */
      @java.lang.Override
      public boolean hasEvaluate() {
        return payloadCase_ == 103;
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       * @return The evaluate.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse getEvaluate() {
        if (evaluateBuilder_ == null) {
          if (payloadCase_ == 103) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance();
        } else {
          if (payloadCase_ == 103) {
            return evaluateBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       */
      public Builder setEvaluate(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse value) {
        if (evaluateBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          evaluateBuilder_.setMessage(value);
        }
        payloadCase_ = 103;
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       */
      public Builder setEvaluate(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.Builder builderForValue) {
        if (evaluateBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          evaluateBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 103;
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       */
      public Builder mergeEvaluate(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse value) {
        if (evaluateBuilder_ == null) {
          if (payloadCase_ == 103 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 103) {
            evaluateBuilder_.mergeFrom(value);
          }
          evaluateBuilder_.setMessage(value);
        }
        payloadCase_ = 103;
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       */
      public Builder clearEvaluate() {
        if (evaluateBuilder_ == null) {
          if (payloadCase_ == 103) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 103) {
            payloadCase_ = 0;
            payload_ = null;
          }
          evaluateBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.Builder getEvaluateBuilder() {
        return getEvaluateFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponseOrBuilder getEvaluateOrBuilder() {
        if ((payloadCase_ == 103) && (evaluateBuilder_ != null)) {
          return evaluateBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 103) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.EvaluateResponse evaluate = 103;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponseOrBuilder> 
          getEvaluateFieldBuilder() {
        if (evaluateBuilder_ == null) {
          if (!(payloadCase_ == 103)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance();
          }
          evaluateBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponseOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 103;
        onChanged();;
        return evaluateBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponseOrBuilder> listFramesBuilder_;
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       * @return Whether the listFrames field is set.
       */
      @java.lang.Override
      public boolean hasListFrames() {
        return payloadCase_ == 104;
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       * @return The listFrames.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse getListFrames() {
        if (listFramesBuilder_ == null) {
          if (payloadCase_ == 104) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance();
        } else {
          if (payloadCase_ == 104) {
            return listFramesBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       */
      public Builder setListFrames(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse value) {
        if (listFramesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          listFramesBuilder_.setMessage(value);
        }
        payloadCase_ = 104;
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       */
      public Builder setListFrames(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.Builder builderForValue) {
        if (listFramesBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          listFramesBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 104;
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       */
      public Builder mergeListFrames(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse value) {
        if (listFramesBuilder_ == null) {
          if (payloadCase_ == 104 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 104) {
            listFramesBuilder_.mergeFrom(value);
          }
          listFramesBuilder_.setMessage(value);
        }
        payloadCase_ = 104;
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       */
      public Builder clearListFrames() {
        if (listFramesBuilder_ == null) {
          if (payloadCase_ == 104) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 104) {
            payloadCase_ = 0;
            payload_ = null;
          }
          listFramesBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.Builder getListFramesBuilder() {
        return getListFramesFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponseOrBuilder getListFramesOrBuilder() {
        if ((payloadCase_ == 104) && (listFramesBuilder_ != null)) {
          return listFramesBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 104) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ListFramesResponse list_frames = 104;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponseOrBuilder> 
          getListFramesFieldBuilder() {
        if (listFramesBuilder_ == null) {
          if (!(payloadCase_ == 104)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance();
          }
          listFramesBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponseOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 104;
        onChanged();;
        return listFramesBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponseOrBuilder> startDebuggingBuilder_;
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       * @return Whether the startDebugging field is set.
       */
      @java.lang.Override
      public boolean hasStartDebugging() {
        return payloadCase_ == 105;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       * @return The startDebugging.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse getStartDebugging() {
        if (startDebuggingBuilder_ == null) {
          if (payloadCase_ == 105) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance();
        } else {
          if (payloadCase_ == 105) {
            return startDebuggingBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       */
      public Builder setStartDebugging(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse value) {
        if (startDebuggingBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          startDebuggingBuilder_.setMessage(value);
        }
        payloadCase_ = 105;
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       */
      public Builder setStartDebugging(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.Builder builderForValue) {
        if (startDebuggingBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          startDebuggingBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 105;
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       */
      public Builder mergeStartDebugging(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse value) {
        if (startDebuggingBuilder_ == null) {
          if (payloadCase_ == 105 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 105) {
            startDebuggingBuilder_.mergeFrom(value);
          }
          startDebuggingBuilder_.setMessage(value);
        }
        payloadCase_ = 105;
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       */
      public Builder clearStartDebugging() {
        if (startDebuggingBuilder_ == null) {
          if (payloadCase_ == 105) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 105) {
            payloadCase_ = 0;
            payload_ = null;
          }
          startDebuggingBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.Builder getStartDebuggingBuilder() {
        return getStartDebuggingFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponseOrBuilder getStartDebuggingOrBuilder() {
        if ((payloadCase_ == 105) && (startDebuggingBuilder_ != null)) {
          return startDebuggingBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 105) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.StartDebuggingResponse start_debugging = 105;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponseOrBuilder> 
          getStartDebuggingFieldBuilder() {
        if (startDebuggingBuilder_ == null) {
          if (!(payloadCase_ == 105)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance();
          }
          startDebuggingBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponseOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 105;
        onChanged();;
        return startDebuggingBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponseOrBuilder> pauseThreadBuilder_;
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       * @return Whether the pauseThread field is set.
       */
      @java.lang.Override
      public boolean hasPauseThread() {
        return payloadCase_ == 106;
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       * @return The pauseThread.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse getPauseThread() {
        if (pauseThreadBuilder_ == null) {
          if (payloadCase_ == 106) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance();
        } else {
          if (payloadCase_ == 106) {
            return pauseThreadBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       */
      public Builder setPauseThread(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse value) {
        if (pauseThreadBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          pauseThreadBuilder_.setMessage(value);
        }
        payloadCase_ = 106;
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       */
      public Builder setPauseThread(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.Builder builderForValue) {
        if (pauseThreadBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          pauseThreadBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 106;
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       */
      public Builder mergePauseThread(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse value) {
        if (pauseThreadBuilder_ == null) {
          if (payloadCase_ == 106 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 106) {
            pauseThreadBuilder_.mergeFrom(value);
          }
          pauseThreadBuilder_.setMessage(value);
        }
        payloadCase_ = 106;
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       */
      public Builder clearPauseThread() {
        if (pauseThreadBuilder_ == null) {
          if (payloadCase_ == 106) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 106) {
            payloadCase_ = 0;
            payload_ = null;
          }
          pauseThreadBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.Builder getPauseThreadBuilder() {
        return getPauseThreadFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponseOrBuilder getPauseThreadOrBuilder() {
        if ((payloadCase_ == 106) && (pauseThreadBuilder_ != null)) {
          return pauseThreadBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 106) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.PauseThreadResponse pause_thread = 106;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponseOrBuilder> 
          getPauseThreadFieldBuilder() {
        if (pauseThreadBuilder_ == null) {
          if (!(payloadCase_ == 106)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance();
          }
          pauseThreadBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponseOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 106;
        onChanged();;
        return pauseThreadBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponseOrBuilder> getChildrenBuilder_;
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       * @return Whether the getChildren field is set.
       */
      @java.lang.Override
      public boolean hasGetChildren() {
        return payloadCase_ == 107;
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       * @return The getChildren.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse getGetChildren() {
        if (getChildrenBuilder_ == null) {
          if (payloadCase_ == 107) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance();
        } else {
          if (payloadCase_ == 107) {
            return getChildrenBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       */
      public Builder setGetChildren(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse value) {
        if (getChildrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          getChildrenBuilder_.setMessage(value);
        }
        payloadCase_ = 107;
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       */
      public Builder setGetChildren(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.Builder builderForValue) {
        if (getChildrenBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          getChildrenBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 107;
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       */
      public Builder mergeGetChildren(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse value) {
        if (getChildrenBuilder_ == null) {
          if (payloadCase_ == 107 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 107) {
            getChildrenBuilder_.mergeFrom(value);
          }
          getChildrenBuilder_.setMessage(value);
        }
        payloadCase_ = 107;
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       */
      public Builder clearGetChildren() {
        if (getChildrenBuilder_ == null) {
          if (payloadCase_ == 107) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 107) {
            payloadCase_ = 0;
            payload_ = null;
          }
          getChildrenBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.Builder getGetChildrenBuilder() {
        return getGetChildrenFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponseOrBuilder getGetChildrenOrBuilder() {
        if ((payloadCase_ == 107) && (getChildrenBuilder_ != null)) {
          return getChildrenBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 107) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.GetChildrenResponse get_children = 107;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponseOrBuilder> 
          getGetChildrenFieldBuilder() {
        if (getChildrenBuilder_ == null) {
          if (!(payloadCase_ == 107)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance();
          }
          getChildrenBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponseOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 107;
        onChanged();;
        return getChildrenBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEventOrBuilder> threadPausedBuilder_;
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       * @return Whether the threadPaused field is set.
       */
      @java.lang.Override
      public boolean hasThreadPaused() {
        return payloadCase_ == 1001;
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       * @return The threadPaused.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent getThreadPaused() {
        if (threadPausedBuilder_ == null) {
          if (payloadCase_ == 1001) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance();
        } else {
          if (payloadCase_ == 1001) {
            return threadPausedBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       */
      public Builder setThreadPaused(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent value) {
        if (threadPausedBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          threadPausedBuilder_.setMessage(value);
        }
        payloadCase_ = 1001;
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       */
      public Builder setThreadPaused(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.Builder builderForValue) {
        if (threadPausedBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          threadPausedBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 1001;
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       */
      public Builder mergeThreadPaused(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent value) {
        if (threadPausedBuilder_ == null) {
          if (payloadCase_ == 1001 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 1001) {
            threadPausedBuilder_.mergeFrom(value);
          }
          threadPausedBuilder_.setMessage(value);
        }
        payloadCase_ = 1001;
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       */
      public Builder clearThreadPaused() {
        if (threadPausedBuilder_ == null) {
          if (payloadCase_ == 1001) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 1001) {
            payloadCase_ = 0;
            payload_ = null;
          }
          threadPausedBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.Builder getThreadPausedBuilder() {
        return getThreadPausedFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEventOrBuilder getThreadPausedOrBuilder() {
        if ((payloadCase_ == 1001) && (threadPausedBuilder_ != null)) {
          return threadPausedBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 1001) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ThreadPausedEvent thread_paused = 1001;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEventOrBuilder> 
          getThreadPausedFieldBuilder() {
        if (threadPausedBuilder_ == null) {
          if (!(payloadCase_ == 1001)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance();
          }
          threadPausedBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEventOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 1001;
        onChanged();;
        return threadPausedBuilder_;
      }

      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEventOrBuilder> threadContinuedBuilder_;
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       * @return Whether the threadContinued field is set.
       */
      @java.lang.Override
      public boolean hasThreadContinued() {
        return payloadCase_ == 1002;
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       * @return The threadContinued.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent getThreadContinued() {
        if (threadContinuedBuilder_ == null) {
          if (payloadCase_ == 1002) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance();
        } else {
          if (payloadCase_ == 1002) {
            return threadContinuedBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       */
      public Builder setThreadContinued(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent value) {
        if (threadContinuedBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          payload_ = value;
          onChanged();
        } else {
          threadContinuedBuilder_.setMessage(value);
        }
        payloadCase_ = 1002;
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       */
      public Builder setThreadContinued(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.Builder builderForValue) {
        if (threadContinuedBuilder_ == null) {
          payload_ = builderForValue.build();
          onChanged();
        } else {
          threadContinuedBuilder_.setMessage(builderForValue.build());
        }
        payloadCase_ = 1002;
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       */
      public Builder mergeThreadContinued(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent value) {
        if (threadContinuedBuilder_ == null) {
          if (payloadCase_ == 1002 &&
              payload_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance()) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_)
                .mergeFrom(value).buildPartial();
          } else {
            payload_ = value;
          }
          onChanged();
        } else {
          if (payloadCase_ == 1002) {
            threadContinuedBuilder_.mergeFrom(value);
          }
          threadContinuedBuilder_.setMessage(value);
        }
        payloadCase_ = 1002;
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       */
      public Builder clearThreadContinued() {
        if (threadContinuedBuilder_ == null) {
          if (payloadCase_ == 1002) {
            payloadCase_ = 0;
            payload_ = null;
            onChanged();
          }
        } else {
          if (payloadCase_ == 1002) {
            payloadCase_ = 0;
            payload_ = null;
          }
          threadContinuedBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.Builder getThreadContinuedBuilder() {
        return getThreadContinuedFieldBuilder().getBuilder();
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEventOrBuilder getThreadContinuedOrBuilder() {
        if ((payloadCase_ == 1002) && (threadContinuedBuilder_ != null)) {
          return threadContinuedBuilder_.getMessageOrBuilder();
        } else {
          if (payloadCase_ == 1002) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance();
        }
      }
      /**
       * <code>.starlark_debugging.ThreadContinuedEvent thread_continued = 1002;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEventOrBuilder> 
          getThreadContinuedFieldBuilder() {
        if (threadContinuedBuilder_ == null) {
          if (!(payloadCase_ == 1002)) {
            payload_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance();
          }
          threadContinuedBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEventOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) payload_,
                  getParentForChildren(),
                  isClean());
          payload_ = null;
        }
        payloadCase_ = 1002;
        onChanged();;
        return threadContinuedBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.DebugEvent)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.DebugEvent)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<DebugEvent>
        PARSER = new com.google.protobuf.AbstractParser<DebugEvent>() {
      @java.lang.Override
      public DebugEvent parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<DebugEvent> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<DebugEvent> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.DebugEvent getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ErrorOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.Error)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * A message describing the error that occurred.
     * </pre>
     *
     * <code>string message = 1;</code>
     * @return The message.
     */
    java.lang.String getMessage();
    /**
     * <pre>
     * A message describing the error that occurred.
     * </pre>
     *
     * <code>string message = 1;</code>
     * @return The bytes for message.
     */
    com.google.protobuf.ByteString
        getMessageBytes();
  }
  /**
   * <pre>
   * A response that indicates that an error occurred while handling a debugging
   * request.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.Error}
   */
  public static final class Error extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.Error)
      ErrorOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Error.newBuilder() to construct.
    private Error(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Error() {
      message_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Error();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Error_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Error_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder.class);
    }

    public static final int MESSAGE_FIELD_NUMBER = 1;
    private volatile java.lang.Object message_;
    /**
     * <pre>
     * A message describing the error that occurred.
     * </pre>
     *
     * <code>string message = 1;</code>
     * @return The message.
     */
    @java.lang.Override
    public java.lang.String getMessage() {
      java.lang.Object ref = message_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        message_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * A message describing the error that occurred.
     * </pre>
     *
     * <code>string message = 1;</code>
     * @return The bytes for message.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getMessageBytes() {
      java.lang.Object ref = message_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        message_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(message_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, message_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(message_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, message_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) obj;

      if (!getMessage()
          .equals(other.getMessage())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + MESSAGE_FIELD_NUMBER;
      hash = (53 * hash) + getMessage().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A response that indicates that an error occurred while handling a debugging
     * request.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.Error}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.Error)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Error_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Error_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        message_ = "";

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Error_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error(this);
        result.message_ = message_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance()) return this;
        if (!other.getMessage().isEmpty()) {
          message_ = other.message_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                message_ = input.readStringRequireUtf8();

                break;
              } // case 10
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private java.lang.Object message_ = "";
      /**
       * <pre>
       * A message describing the error that occurred.
       * </pre>
       *
       * <code>string message = 1;</code>
       * @return The message.
       */
      public java.lang.String getMessage() {
        java.lang.Object ref = message_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          message_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * A message describing the error that occurred.
       * </pre>
       *
       * <code>string message = 1;</code>
       * @return The bytes for message.
       */
      public com.google.protobuf.ByteString
          getMessageBytes() {
        java.lang.Object ref = message_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          message_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * A message describing the error that occurred.
       * </pre>
       *
       * <code>string message = 1;</code>
       * @param value The message to set.
       * @return This builder for chaining.
       */
      public Builder setMessage(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        message_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A message describing the error that occurred.
       * </pre>
       *
       * <code>string message = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearMessage() {
        
        message_ = getDefaultInstance().getMessage();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A message describing the error that occurred.
       * </pre>
       *
       * <code>string message = 1;</code>
       * @param value The bytes for message to set.
       * @return This builder for chaining.
       */
      public Builder setMessageBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        message_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.Error)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.Error)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Error>
        PARSER = new com.google.protobuf.AbstractParser<Error>() {
      @java.lang.Override
      public Error parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<Error> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Error> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface SetBreakpointsResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.SetBreakpointsResponse)
      com.google.protobuf.MessageOrBuilder {
  }
  /**
   * <pre>
   * The response to a SetBreakpointsRequest.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.SetBreakpointsResponse}
   */
  public static final class SetBreakpointsResponse extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.SetBreakpointsResponse)
      SetBreakpointsResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use SetBreakpointsResponse.newBuilder() to construct.
    private SetBreakpointsResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private SetBreakpointsResponse() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new SetBreakpointsResponse();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.Builder.class);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) obj;

      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The response to a SetBreakpointsRequest.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.SetBreakpointsResponse}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.SetBreakpointsResponse)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponseOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsResponse_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_SetBreakpointsResponse_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse(this);
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse.getDefaultInstance()) return this;
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.SetBreakpointsResponse)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.SetBreakpointsResponse)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<SetBreakpointsResponse>
        PARSER = new com.google.protobuf.AbstractParser<SetBreakpointsResponse>() {
      @java.lang.Override
      public SetBreakpointsResponse parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<SetBreakpointsResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<SetBreakpointsResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.SetBreakpointsResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ContinueExecutionResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.ContinueExecutionResponse)
      com.google.protobuf.MessageOrBuilder {
  }
  /**
   * <pre>
   * The response to a ContinueExecutionRequest.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.ContinueExecutionResponse}
   */
  public static final class ContinueExecutionResponse extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.ContinueExecutionResponse)
      ContinueExecutionResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ContinueExecutionResponse.newBuilder() to construct.
    private ContinueExecutionResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ContinueExecutionResponse() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new ContinueExecutionResponse();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.Builder.class);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) obj;

      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The response to a ContinueExecutionRequest.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.ContinueExecutionResponse}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.ContinueExecutionResponse)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponseOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionResponse_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ContinueExecutionResponse_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse(this);
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse.getDefaultInstance()) return this;
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.ContinueExecutionResponse)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.ContinueExecutionResponse)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<ContinueExecutionResponse>
        PARSER = new com.google.protobuf.AbstractParser<ContinueExecutionResponse>() {
      @java.lang.Override
      public ContinueExecutionResponse parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<ContinueExecutionResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<ContinueExecutionResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ContinueExecutionResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface EvaluateResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.EvaluateResponse)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The result of evaluating a statement.
     * </pre>
     *
     * <code>.starlark_debugging.Value result = 1;</code>
     * @return Whether the result field is set.
     */
    boolean hasResult();
    /**
     * <pre>
     * The result of evaluating a statement.
     * </pre>
     *
     * <code>.starlark_debugging.Value result = 1;</code>
     * @return The result.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getResult();
    /**
     * <pre>
     * The result of evaluating a statement.
     * </pre>
     *
     * <code>.starlark_debugging.Value result = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getResultOrBuilder();
  }
  /**
   * <pre>
   * The response to an EvaluateRequest.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.EvaluateResponse}
   */
  public static final class EvaluateResponse extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.EvaluateResponse)
      EvaluateResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use EvaluateResponse.newBuilder() to construct.
    private EvaluateResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private EvaluateResponse() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new EvaluateResponse();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.Builder.class);
    }

    public static final int RESULT_FIELD_NUMBER = 1;
    private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value result_;
    /**
     * <pre>
     * The result of evaluating a statement.
     * </pre>
     *
     * <code>.starlark_debugging.Value result = 1;</code>
     * @return Whether the result field is set.
     */
    @java.lang.Override
    public boolean hasResult() {
      return result_ != null;
    }
    /**
     * <pre>
     * The result of evaluating a statement.
     * </pre>
     *
     * <code>.starlark_debugging.Value result = 1;</code>
     * @return The result.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getResult() {
      return result_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance() : result_;
    }
    /**
     * <pre>
     * The result of evaluating a statement.
     * </pre>
     *
     * <code>.starlark_debugging.Value result = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getResultOrBuilder() {
      return getResult();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (result_ != null) {
        output.writeMessage(1, getResult());
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (result_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, getResult());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) obj;

      if (hasResult() != other.hasResult()) return false;
      if (hasResult()) {
        if (!getResult()
            .equals(other.getResult())) return false;
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasResult()) {
        hash = (37 * hash) + RESULT_FIELD_NUMBER;
        hash = (53 * hash) + getResult().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The response to an EvaluateRequest.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.EvaluateResponse}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.EvaluateResponse)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponseOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateResponse_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (resultBuilder_ == null) {
          result_ = null;
        } else {
          result_ = null;
          resultBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_EvaluateResponse_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse(this);
        if (resultBuilder_ == null) {
          result.result_ = result_;
        } else {
          result.result_ = resultBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse.getDefaultInstance()) return this;
        if (other.hasResult()) {
          mergeResult(other.getResult());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                input.readMessage(
                    getResultFieldBuilder().getBuilder(),
                    extensionRegistry);

                break;
              } // case 10
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value result_;
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> resultBuilder_;
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       * @return Whether the result field is set.
       */
      public boolean hasResult() {
        return resultBuilder_ != null || result_ != null;
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       * @return The result.
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getResult() {
        if (resultBuilder_ == null) {
          return result_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance() : result_;
        } else {
          return resultBuilder_.getMessage();
        }
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       */
      public Builder setResult(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (resultBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          result_ = value;
          onChanged();
        } else {
          resultBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       */
      public Builder setResult(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder builderForValue) {
        if (resultBuilder_ == null) {
          result_ = builderForValue.build();
          onChanged();
        } else {
          resultBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       */
      public Builder mergeResult(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (resultBuilder_ == null) {
          if (result_ != null) {
            result_ =
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.newBuilder(result_).mergeFrom(value).buildPartial();
          } else {
            result_ = value;
          }
          onChanged();
        } else {
          resultBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       */
      public Builder clearResult() {
        if (resultBuilder_ == null) {
          result_ = null;
          onChanged();
        } else {
          result_ = null;
          resultBuilder_ = null;
        }

        return this;
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder getResultBuilder() {
        
        onChanged();
        return getResultFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getResultOrBuilder() {
        if (resultBuilder_ != null) {
          return resultBuilder_.getMessageOrBuilder();
        } else {
          return result_ == null ?
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance() : result_;
        }
      }
      /**
       * <pre>
       * The result of evaluating a statement.
       * </pre>
       *
       * <code>.starlark_debugging.Value result = 1;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
          getResultFieldBuilder() {
        if (resultBuilder_ == null) {
          resultBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder>(
                  getResult(),
                  getParentForChildren(),
                  isClean());
          result_ = null;
        }
        return resultBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.EvaluateResponse)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.EvaluateResponse)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<EvaluateResponse>
        PARSER = new com.google.protobuf.AbstractParser<EvaluateResponse>() {
      @java.lang.Override
      public EvaluateResponse parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<EvaluateResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<EvaluateResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.EvaluateResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ListFramesResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.ListFramesResponse)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame> 
        getFrameList();
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame getFrame(int index);
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    int getFrameCount();
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder> 
        getFrameOrBuilderList();
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder getFrameOrBuilder(
        int index);
  }
  /**
   * <pre>
   * The response to a ListFramesRequest.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.ListFramesResponse}
   */
  public static final class ListFramesResponse extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.ListFramesResponse)
      ListFramesResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ListFramesResponse.newBuilder() to construct.
    private ListFramesResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ListFramesResponse() {
      frame_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new ListFramesResponse();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.Builder.class);
    }

    public static final int FRAME_FIELD_NUMBER = 1;
    private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame> frame_;
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame> getFrameList() {
      return frame_;
    }
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    @java.lang.Override
    public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder> 
        getFrameOrBuilderList() {
      return frame_;
    }
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    @java.lang.Override
    public int getFrameCount() {
      return frame_.size();
    }
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame getFrame(int index) {
      return frame_.get(index);
    }
    /**
     * <pre>
     * The list of stack frames. The first element in the list represents the
     * topmost frame (that is, the current innermost function).
     * </pre>
     *
     * <code>repeated .starlark_debugging.Frame frame = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder getFrameOrBuilder(
        int index) {
      return frame_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      for (int i = 0; i < frame_.size(); i++) {
        output.writeMessage(1, frame_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      for (int i = 0; i < frame_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, frame_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) obj;

      if (!getFrameList()
          .equals(other.getFrameList())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (getFrameCount() > 0) {
        hash = (37 * hash) + FRAME_FIELD_NUMBER;
        hash = (53 * hash) + getFrameList().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The response to a ListFramesRequest.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.ListFramesResponse}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.ListFramesResponse)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponseOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesResponse_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (frameBuilder_ == null) {
          frame_ = java.util.Collections.emptyList();
        } else {
          frame_ = null;
          frameBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ListFramesResponse_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse(this);
        int from_bitField0_ = bitField0_;
        if (frameBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0)) {
            frame_ = java.util.Collections.unmodifiableList(frame_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.frame_ = frame_;
        } else {
          result.frame_ = frameBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse.getDefaultInstance()) return this;
        if (frameBuilder_ == null) {
          if (!other.frame_.isEmpty()) {
            if (frame_.isEmpty()) {
              frame_ = other.frame_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureFrameIsMutable();
              frame_.addAll(other.frame_);
            }
            onChanged();
          }
        } else {
          if (!other.frame_.isEmpty()) {
            if (frameBuilder_.isEmpty()) {
              frameBuilder_.dispose();
              frameBuilder_ = null;
              frame_ = other.frame_;
              bitField0_ = (bitField0_ & ~0x00000001);
              frameBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getFrameFieldBuilder() : null;
            } else {
              frameBuilder_.addAllMessages(other.frame_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame m =
                    input.readMessage(
                        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.parser(),
                        extensionRegistry);
                if (frameBuilder_ == null) {
                  ensureFrameIsMutable();
                  frame_.add(m);
                } else {
                  frameBuilder_.addMessage(m);
                }
                break;
              } // case 10
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int bitField0_;

      private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame> frame_ =
        java.util.Collections.emptyList();
      private void ensureFrameIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          frame_ = new java.util.ArrayList<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame>(frame_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder> frameBuilder_;

      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame> getFrameList() {
        if (frameBuilder_ == null) {
          return java.util.Collections.unmodifiableList(frame_);
        } else {
          return frameBuilder_.getMessageList();
        }
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public int getFrameCount() {
        if (frameBuilder_ == null) {
          return frame_.size();
        } else {
          return frameBuilder_.getCount();
        }
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame getFrame(int index) {
        if (frameBuilder_ == null) {
          return frame_.get(index);
        } else {
          return frameBuilder_.getMessage(index);
        }
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder setFrame(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame value) {
        if (frameBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureFrameIsMutable();
          frame_.set(index, value);
          onChanged();
        } else {
          frameBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder setFrame(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder builderForValue) {
        if (frameBuilder_ == null) {
          ensureFrameIsMutable();
          frame_.set(index, builderForValue.build());
          onChanged();
        } else {
          frameBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder addFrame(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame value) {
        if (frameBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureFrameIsMutable();
          frame_.add(value);
          onChanged();
        } else {
          frameBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder addFrame(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame value) {
        if (frameBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureFrameIsMutable();
          frame_.add(index, value);
          onChanged();
        } else {
          frameBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder addFrame(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder builderForValue) {
        if (frameBuilder_ == null) {
          ensureFrameIsMutable();
          frame_.add(builderForValue.build());
          onChanged();
        } else {
          frameBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder addFrame(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder builderForValue) {
        if (frameBuilder_ == null) {
          ensureFrameIsMutable();
          frame_.add(index, builderForValue.build());
          onChanged();
        } else {
          frameBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder addAllFrame(
          java.lang.Iterable<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame> values) {
        if (frameBuilder_ == null) {
          ensureFrameIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, frame_);
          onChanged();
        } else {
          frameBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder clearFrame() {
        if (frameBuilder_ == null) {
          frame_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          frameBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public Builder removeFrame(int index) {
        if (frameBuilder_ == null) {
          ensureFrameIsMutable();
          frame_.remove(index);
          onChanged();
        } else {
          frameBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder getFrameBuilder(
          int index) {
        return getFrameFieldBuilder().getBuilder(index);
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder getFrameOrBuilder(
          int index) {
        if (frameBuilder_ == null) {
          return frame_.get(index);  } else {
          return frameBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder> 
           getFrameOrBuilderList() {
        if (frameBuilder_ != null) {
          return frameBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(frame_);
        }
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder addFrameBuilder() {
        return getFrameFieldBuilder().addBuilder(
            com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.getDefaultInstance());
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder addFrameBuilder(
          int index) {
        return getFrameFieldBuilder().addBuilder(
            index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.getDefaultInstance());
      }
      /**
       * <pre>
       * The list of stack frames. The first element in the list represents the
       * topmost frame (that is, the current innermost function).
       * </pre>
       *
       * <code>repeated .starlark_debugging.Frame frame = 1;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder> 
           getFrameBuilderList() {
        return getFrameFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder> 
          getFrameFieldBuilder() {
        if (frameBuilder_ == null) {
          frameBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder>(
                  frame_,
                  ((bitField0_ & 0x00000001) != 0),
                  getParentForChildren(),
                  isClean());
          frame_ = null;
        }
        return frameBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.ListFramesResponse)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.ListFramesResponse)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<ListFramesResponse>
        PARSER = new com.google.protobuf.AbstractParser<ListFramesResponse>() {
      @java.lang.Override
      public ListFramesResponse parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<ListFramesResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<ListFramesResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ListFramesResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface StartDebuggingResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.StartDebuggingResponse)
      com.google.protobuf.MessageOrBuilder {
  }
  /**
   * <pre>
   * The response to a StartDebuggingRequest.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.StartDebuggingResponse}
   */
  public static final class StartDebuggingResponse extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.StartDebuggingResponse)
      StartDebuggingResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use StartDebuggingResponse.newBuilder() to construct.
    private StartDebuggingResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private StartDebuggingResponse() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new StartDebuggingResponse();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.Builder.class);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) obj;

      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The response to a StartDebuggingRequest.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.StartDebuggingResponse}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.StartDebuggingResponse)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponseOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingResponse_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_StartDebuggingResponse_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse(this);
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse.getDefaultInstance()) return this;
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.StartDebuggingResponse)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.StartDebuggingResponse)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<StartDebuggingResponse>
        PARSER = new com.google.protobuf.AbstractParser<StartDebuggingResponse>() {
      @java.lang.Override
      public StartDebuggingResponse parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<StartDebuggingResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<StartDebuggingResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.StartDebuggingResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface PauseThreadResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.PauseThreadResponse)
      com.google.protobuf.MessageOrBuilder {
  }
  /**
   * <pre>
   * The response to a PauseThreadRequest. This is an acknowledgement that the
   * request was received. Actual pausing of individual threads happens
   * asynchronously, and will be communicated via ThreadPausedEvent(s).
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.PauseThreadResponse}
   */
  public static final class PauseThreadResponse extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.PauseThreadResponse)
      PauseThreadResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use PauseThreadResponse.newBuilder() to construct.
    private PauseThreadResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private PauseThreadResponse() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new PauseThreadResponse();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.Builder.class);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) obj;

      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The response to a PauseThreadRequest. This is an acknowledgement that the
     * request was received. Actual pausing of individual threads happens
     * asynchronously, and will be communicated via ThreadPausedEvent(s).
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.PauseThreadResponse}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.PauseThreadResponse)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponseOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadResponse_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PauseThreadResponse_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse(this);
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse.getDefaultInstance()) return this;
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.PauseThreadResponse)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.PauseThreadResponse)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<PauseThreadResponse>
        PARSER = new com.google.protobuf.AbstractParser<PauseThreadResponse>() {
      @java.lang.Override
      public PauseThreadResponse parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<PauseThreadResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<PauseThreadResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseThreadResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface GetChildrenResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.GetChildrenResponse)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> 
        getChildrenList();
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getChildren(int index);
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    int getChildrenCount();
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
        getChildrenOrBuilderList();
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getChildrenOrBuilder(
        int index);
  }
  /**
   * <pre>
   * The response to a GetChildrenRequest.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.GetChildrenResponse}
   */
  public static final class GetChildrenResponse extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.GetChildrenResponse)
      GetChildrenResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use GetChildrenResponse.newBuilder() to construct.
    private GetChildrenResponse(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private GetChildrenResponse() {
      children_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new GetChildrenResponse();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenResponse_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.Builder.class);
    }

    public static final int CHILDREN_FIELD_NUMBER = 1;
    private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> children_;
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> getChildrenList() {
      return children_;
    }
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    @java.lang.Override
    public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
        getChildrenOrBuilderList() {
      return children_;
    }
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    @java.lang.Override
    public int getChildrenCount() {
      return children_.size();
    }
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getChildren(int index) {
      return children_.get(index);
    }
    /**
     * <code>repeated .starlark_debugging.Value children = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getChildrenOrBuilder(
        int index) {
      return children_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      for (int i = 0; i < children_.size(); i++) {
        output.writeMessage(1, children_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      for (int i = 0; i < children_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, children_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) obj;

      if (!getChildrenList()
          .equals(other.getChildrenList())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (getChildrenCount() > 0) {
        hash = (37 * hash) + CHILDREN_FIELD_NUMBER;
        hash = (53 * hash) + getChildrenList().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The response to a GetChildrenRequest.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.GetChildrenResponse}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.GetChildrenResponse)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponseOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenResponse_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (childrenBuilder_ == null) {
          children_ = java.util.Collections.emptyList();
        } else {
          children_ = null;
          childrenBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_GetChildrenResponse_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse(this);
        int from_bitField0_ = bitField0_;
        if (childrenBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0)) {
            children_ = java.util.Collections.unmodifiableList(children_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.children_ = children_;
        } else {
          result.children_ = childrenBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse.getDefaultInstance()) return this;
        if (childrenBuilder_ == null) {
          if (!other.children_.isEmpty()) {
            if (children_.isEmpty()) {
              children_ = other.children_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureChildrenIsMutable();
              children_.addAll(other.children_);
            }
            onChanged();
          }
        } else {
          if (!other.children_.isEmpty()) {
            if (childrenBuilder_.isEmpty()) {
              childrenBuilder_.dispose();
              childrenBuilder_ = null;
              children_ = other.children_;
              bitField0_ = (bitField0_ & ~0x00000001);
              childrenBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getChildrenFieldBuilder() : null;
            } else {
              childrenBuilder_.addAllMessages(other.children_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value m =
                    input.readMessage(
                        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.parser(),
                        extensionRegistry);
                if (childrenBuilder_ == null) {
                  ensureChildrenIsMutable();
                  children_.add(m);
                } else {
                  childrenBuilder_.addMessage(m);
                }
                break;
              } // case 10
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int bitField0_;

      private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> children_ =
        java.util.Collections.emptyList();
      private void ensureChildrenIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          children_ = new java.util.ArrayList<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value>(children_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> childrenBuilder_;

      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> getChildrenList() {
        if (childrenBuilder_ == null) {
          return java.util.Collections.unmodifiableList(children_);
        } else {
          return childrenBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public int getChildrenCount() {
        if (childrenBuilder_ == null) {
          return children_.size();
        } else {
          return childrenBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getChildren(int index) {
        if (childrenBuilder_ == null) {
          return children_.get(index);
        } else {
          return childrenBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder setChildren(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (childrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureChildrenIsMutable();
          children_.set(index, value);
          onChanged();
        } else {
          childrenBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder setChildren(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder builderForValue) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.set(index, builderForValue.build());
          onChanged();
        } else {
          childrenBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder addChildren(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (childrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureChildrenIsMutable();
          children_.add(value);
          onChanged();
        } else {
          childrenBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder addChildren(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (childrenBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureChildrenIsMutable();
          children_.add(index, value);
          onChanged();
        } else {
          childrenBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder addChildren(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder builderForValue) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.add(builderForValue.build());
          onChanged();
        } else {
          childrenBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder addChildren(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder builderForValue) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.add(index, builderForValue.build());
          onChanged();
        } else {
          childrenBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder addAllChildren(
          java.lang.Iterable<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> values) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, children_);
          onChanged();
        } else {
          childrenBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder clearChildren() {
        if (childrenBuilder_ == null) {
          children_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          childrenBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public Builder removeChildren(int index) {
        if (childrenBuilder_ == null) {
          ensureChildrenIsMutable();
          children_.remove(index);
          onChanged();
        } else {
          childrenBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder getChildrenBuilder(
          int index) {
        return getChildrenFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getChildrenOrBuilder(
          int index) {
        if (childrenBuilder_ == null) {
          return children_.get(index);  } else {
          return childrenBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
           getChildrenOrBuilderList() {
        if (childrenBuilder_ != null) {
          return childrenBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(children_);
        }
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder addChildrenBuilder() {
        return getChildrenFieldBuilder().addBuilder(
            com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance());
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder addChildrenBuilder(
          int index) {
        return getChildrenFieldBuilder().addBuilder(
            index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance());
      }
      /**
       * <code>repeated .starlark_debugging.Value children = 1;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder> 
           getChildrenBuilderList() {
        return getChildrenFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
          getChildrenFieldBuilder() {
        if (childrenBuilder_ == null) {
          childrenBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder>(
                  children_,
                  ((bitField0_ & 0x00000001) != 0),
                  getParentForChildren(),
                  isClean());
          children_ = null;
        }
        return childrenBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.GetChildrenResponse)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.GetChildrenResponse)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<GetChildrenResponse>
        PARSER = new com.google.protobuf.AbstractParser<GetChildrenResponse>() {
      @java.lang.Override
      public GetChildrenResponse parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<GetChildrenResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<GetChildrenResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.GetChildrenResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ThreadPausedEventOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.ThreadPausedEvent)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The thread that was paused.
     * </pre>
     *
     * <code>.starlark_debugging.PausedThread thread = 1;</code>
     * @return Whether the thread field is set.
     */
    boolean hasThread();
    /**
     * <pre>
     * The thread that was paused.
     * </pre>
     *
     * <code>.starlark_debugging.PausedThread thread = 1;</code>
     * @return The thread.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread getThread();
    /**
     * <pre>
     * The thread that was paused.
     * </pre>
     *
     * <code>.starlark_debugging.PausedThread thread = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThreadOrBuilder getThreadOrBuilder();
  }
  /**
   * <pre>
   * An event indicating that a thread was paused during execution.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.ThreadPausedEvent}
   */
  public static final class ThreadPausedEvent extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.ThreadPausedEvent)
      ThreadPausedEventOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ThreadPausedEvent.newBuilder() to construct.
    private ThreadPausedEvent(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ThreadPausedEvent() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new ThreadPausedEvent();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadPausedEvent_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadPausedEvent_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.Builder.class);
    }

    public static final int THREAD_FIELD_NUMBER = 1;
    private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread thread_;
    /**
     * <pre>
     * The thread that was paused.
     * </pre>
     *
     * <code>.starlark_debugging.PausedThread thread = 1;</code>
     * @return Whether the thread field is set.
     */
    @java.lang.Override
    public boolean hasThread() {
      return thread_ != null;
    }
    /**
     * <pre>
     * The thread that was paused.
     * </pre>
     *
     * <code>.starlark_debugging.PausedThread thread = 1;</code>
     * @return The thread.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread getThread() {
      return thread_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.getDefaultInstance() : thread_;
    }
    /**
     * <pre>
     * The thread that was paused.
     * </pre>
     *
     * <code>.starlark_debugging.PausedThread thread = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThreadOrBuilder getThreadOrBuilder() {
      return getThread();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (thread_ != null) {
        output.writeMessage(1, getThread());
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (thread_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, getThread());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) obj;

      if (hasThread() != other.hasThread()) return false;
      if (hasThread()) {
        if (!getThread()
            .equals(other.getThread())) return false;
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasThread()) {
        hash = (37 * hash) + THREAD_FIELD_NUMBER;
        hash = (53 * hash) + getThread().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * An event indicating that a thread was paused during execution.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.ThreadPausedEvent}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.ThreadPausedEvent)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEventOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadPausedEvent_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadPausedEvent_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (threadBuilder_ == null) {
          thread_ = null;
        } else {
          thread_ = null;
          threadBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadPausedEvent_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent(this);
        if (threadBuilder_ == null) {
          result.thread_ = thread_;
        } else {
          result.thread_ = threadBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent.getDefaultInstance()) return this;
        if (other.hasThread()) {
          mergeThread(other.getThread());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                input.readMessage(
                    getThreadFieldBuilder().getBuilder(),
                    extensionRegistry);

                break;
              } // case 10
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread thread_;
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThreadOrBuilder> threadBuilder_;
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       * @return Whether the thread field is set.
       */
      public boolean hasThread() {
        return threadBuilder_ != null || thread_ != null;
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       * @return The thread.
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread getThread() {
        if (threadBuilder_ == null) {
          return thread_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.getDefaultInstance() : thread_;
        } else {
          return threadBuilder_.getMessage();
        }
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       */
      public Builder setThread(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread value) {
        if (threadBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          thread_ = value;
          onChanged();
        } else {
          threadBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       */
      public Builder setThread(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.Builder builderForValue) {
        if (threadBuilder_ == null) {
          thread_ = builderForValue.build();
          onChanged();
        } else {
          threadBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       */
      public Builder mergeThread(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread value) {
        if (threadBuilder_ == null) {
          if (thread_ != null) {
            thread_ =
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.newBuilder(thread_).mergeFrom(value).buildPartial();
          } else {
            thread_ = value;
          }
          onChanged();
        } else {
          threadBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       */
      public Builder clearThread() {
        if (threadBuilder_ == null) {
          thread_ = null;
          onChanged();
        } else {
          thread_ = null;
          threadBuilder_ = null;
        }

        return this;
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.Builder getThreadBuilder() {
        
        onChanged();
        return getThreadFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThreadOrBuilder getThreadOrBuilder() {
        if (threadBuilder_ != null) {
          return threadBuilder_.getMessageOrBuilder();
        } else {
          return thread_ == null ?
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.getDefaultInstance() : thread_;
        }
      }
      /**
       * <pre>
       * The thread that was paused.
       * </pre>
       *
       * <code>.starlark_debugging.PausedThread thread = 1;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThreadOrBuilder> 
          getThreadFieldBuilder() {
        if (threadBuilder_ == null) {
          threadBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThreadOrBuilder>(
                  getThread(),
                  getParentForChildren(),
                  isClean());
          thread_ = null;
        }
        return threadBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.ThreadPausedEvent)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.ThreadPausedEvent)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<ThreadPausedEvent>
        PARSER = new com.google.protobuf.AbstractParser<ThreadPausedEvent>() {
      @java.lang.Override
      public ThreadPausedEvent parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<ThreadPausedEvent> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<ThreadPausedEvent> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadPausedEvent getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ThreadContinuedEventOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.ThreadContinuedEvent)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The identifier of the thread that continued executing.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    long getThreadId();
  }
  /**
   * <pre>
   * An event indicating that a thread has continued execution after being paused.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.ThreadContinuedEvent}
   */
  public static final class ThreadContinuedEvent extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.ThreadContinuedEvent)
      ThreadContinuedEventOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ThreadContinuedEvent.newBuilder() to construct.
    private ThreadContinuedEvent(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ThreadContinuedEvent() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new ThreadContinuedEvent();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadContinuedEvent_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadContinuedEvent_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.Builder.class);
    }

    public static final int THREAD_ID_FIELD_NUMBER = 1;
    private long threadId_;
    /**
     * <pre>
     * The identifier of the thread that continued executing.
     * </pre>
     *
     * <code>int64 thread_id = 1;</code>
     * @return The threadId.
     */
    @java.lang.Override
    public long getThreadId() {
      return threadId_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (threadId_ != 0L) {
        output.writeInt64(1, threadId_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (threadId_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, threadId_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) obj;

      if (getThreadId()
          != other.getThreadId()) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + THREAD_ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getThreadId());
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * An event indicating that a thread has continued execution after being paused.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.ThreadContinuedEvent}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.ThreadContinuedEvent)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEventOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadContinuedEvent_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadContinuedEvent_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        threadId_ = 0L;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_ThreadContinuedEvent_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent(this);
        result.threadId_ = threadId_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent.getDefaultInstance()) return this;
        if (other.getThreadId() != 0L) {
          setThreadId(other.getThreadId());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                threadId_ = input.readInt64();

                break;
              } // case 8
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private long threadId_ ;
      /**
       * <pre>
       * The identifier of the thread that continued executing.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return The threadId.
       */
      @java.lang.Override
      public long getThreadId() {
        return threadId_;
      }
      /**
       * <pre>
       * The identifier of the thread that continued executing.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @param value The threadId to set.
       * @return This builder for chaining.
       */
      public Builder setThreadId(long value) {
        
        threadId_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The identifier of the thread that continued executing.
       * </pre>
       *
       * <code>int64 thread_id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearThreadId() {
        
        threadId_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.ThreadContinuedEvent)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.ThreadContinuedEvent)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<ThreadContinuedEvent>
        PARSER = new com.google.protobuf.AbstractParser<ThreadContinuedEvent>() {
      @java.lang.Override
      public ThreadContinuedEvent parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<ThreadContinuedEvent> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<ThreadContinuedEvent> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ThreadContinuedEvent getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface BreakpointOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.Breakpoint)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * A breakpoint that is triggered when a particular line is reached.
     * Column index will be ignored for breakpoints. The debugger only supports
     * one breakpoint per line. If multiple breakpoints are supplied for a
     * single line, only the last such breakpoint is accepted.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 1;</code>
     * @return Whether the location field is set.
     */
    boolean hasLocation();
    /**
     * <pre>
     * A breakpoint that is triggered when a particular line is reached.
     * Column index will be ignored for breakpoints. The debugger only supports
     * one breakpoint per line. If multiple breakpoints are supplied for a
     * single line, only the last such breakpoint is accepted.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 1;</code>
     * @return The location.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation();
    /**
     * <pre>
     * A breakpoint that is triggered when a particular line is reached.
     * Column index will be ignored for breakpoints. The debugger only supports
     * one breakpoint per line. If multiple breakpoints are supplied for a
     * single line, only the last such breakpoint is accepted.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 1;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder();

    /**
     * <pre>
     * An optional condition for the breakpoint. When present, the breakpoint will
     * be triggered iff both the primary condition holds and this expression
     * evaluates to True. It is unspecified how many times this expression will be
     * evaluated, so it should be free of side-effects.
     * </pre>
     *
     * <code>string expression = 2;</code>
     * @return The expression.
     */
    java.lang.String getExpression();
    /**
     * <pre>
     * An optional condition for the breakpoint. When present, the breakpoint will
     * be triggered iff both the primary condition holds and this expression
     * evaluates to True. It is unspecified how many times this expression will be
     * evaluated, so it should be free of side-effects.
     * </pre>
     *
     * <code>string expression = 2;</code>
     * @return The bytes for expression.
     */
    com.google.protobuf.ByteString
        getExpressionBytes();

    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.ConditionCase getConditionCase();
  }
  /**
   * <pre>
   * A location where the debug server will pause execution.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.Breakpoint}
   */
  public static final class Breakpoint extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.Breakpoint)
      BreakpointOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Breakpoint.newBuilder() to construct.
    private Breakpoint(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Breakpoint() {
      expression_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Breakpoint();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Breakpoint_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Breakpoint_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder.class);
    }

    private int conditionCase_ = 0;
    private java.lang.Object condition_;
    public enum ConditionCase
        implements com.google.protobuf.Internal.EnumLite,
            com.google.protobuf.AbstractMessage.InternalOneOfEnum {
      LOCATION(1),
      CONDITION_NOT_SET(0);
      private final int value;
      private ConditionCase(int value) {
        this.value = value;
      }
      /**
       * @param value The number of the enum to look for.
       * @return The enum associated with the given number.
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static ConditionCase valueOf(int value) {
        return forNumber(value);
      }

      public static ConditionCase forNumber(int value) {
        switch (value) {
          case 1: return LOCATION;
          case 0: return CONDITION_NOT_SET;
          default: return null;
        }
      }
      public int getNumber() {
        return this.value;
      }
    };

    public ConditionCase
    getConditionCase() {
      return ConditionCase.forNumber(
          conditionCase_);
    }

    public static final int LOCATION_FIELD_NUMBER = 1;
    /**
     * <pre>
     * A breakpoint that is triggered when a particular line is reached.
     * Column index will be ignored for breakpoints. The debugger only supports
     * one breakpoint per line. If multiple breakpoints are supplied for a
     * single line, only the last such breakpoint is accepted.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 1;</code>
     * @return Whether the location field is set.
     */
    @java.lang.Override
    public boolean hasLocation() {
      return conditionCase_ == 1;
    }
    /**
     * <pre>
     * A breakpoint that is triggered when a particular line is reached.
     * Column index will be ignored for breakpoints. The debugger only supports
     * one breakpoint per line. If multiple breakpoints are supplied for a
     * single line, only the last such breakpoint is accepted.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 1;</code>
     * @return The location.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation() {
      if (conditionCase_ == 1) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance();
    }
    /**
     * <pre>
     * A breakpoint that is triggered when a particular line is reached.
     * Column index will be ignored for breakpoints. The debugger only supports
     * one breakpoint per line. If multiple breakpoints are supplied for a
     * single line, only the last such breakpoint is accepted.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 1;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder() {
      if (conditionCase_ == 1) {
         return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_;
      }
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance();
    }

    public static final int EXPRESSION_FIELD_NUMBER = 2;
    private volatile java.lang.Object expression_;
    /**
     * <pre>
     * An optional condition for the breakpoint. When present, the breakpoint will
     * be triggered iff both the primary condition holds and this expression
     * evaluates to True. It is unspecified how many times this expression will be
     * evaluated, so it should be free of side-effects.
     * </pre>
     *
     * <code>string expression = 2;</code>
     * @return The expression.
     */
    @java.lang.Override
    public java.lang.String getExpression() {
      java.lang.Object ref = expression_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        expression_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * An optional condition for the breakpoint. When present, the breakpoint will
     * be triggered iff both the primary condition holds and this expression
     * evaluates to True. It is unspecified how many times this expression will be
     * evaluated, so it should be free of side-effects.
     * </pre>
     *
     * <code>string expression = 2;</code>
     * @return The bytes for expression.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getExpressionBytes() {
      java.lang.Object ref = expression_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        expression_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (conditionCase_ == 1) {
        output.writeMessage(1, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(expression_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, expression_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (conditionCase_ == 1) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(expression_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, expression_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint) obj;

      if (!getExpression()
          .equals(other.getExpression())) return false;
      if (!getConditionCase().equals(other.getConditionCase())) return false;
      switch (conditionCase_) {
        case 1:
          if (!getLocation()
              .equals(other.getLocation())) return false;
          break;
        case 0:
        default:
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + EXPRESSION_FIELD_NUMBER;
      hash = (53 * hash) + getExpression().hashCode();
      switch (conditionCase_) {
        case 1:
          hash = (37 * hash) + LOCATION_FIELD_NUMBER;
          hash = (53 * hash) + getLocation().hashCode();
          break;
        case 0:
        default:
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A location where the debug server will pause execution.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.Breakpoint}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.Breakpoint)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.BreakpointOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Breakpoint_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Breakpoint_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (locationBuilder_ != null) {
          locationBuilder_.clear();
        }
        expression_ = "";

        conditionCase_ = 0;
        condition_ = null;
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Breakpoint_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint(this);
        if (conditionCase_ == 1) {
          if (locationBuilder_ == null) {
            result.condition_ = condition_;
          } else {
            result.condition_ = locationBuilder_.build();
          }
        }
        result.expression_ = expression_;
        result.conditionCase_ = conditionCase_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint.getDefaultInstance()) return this;
        if (!other.getExpression().isEmpty()) {
          expression_ = other.expression_;
          onChanged();
        }
        switch (other.getConditionCase()) {
          case LOCATION: {
            mergeLocation(other.getLocation());
            break;
          }
          case CONDITION_NOT_SET: {
            break;
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                input.readMessage(
                    getLocationFieldBuilder().getBuilder(),
                    extensionRegistry);
                conditionCase_ = 1;
                break;
              } // case 10
              case 18: {
                expression_ = input.readStringRequireUtf8();

                break;
              } // case 18
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int conditionCase_ = 0;
      private java.lang.Object condition_;
      public ConditionCase
          getConditionCase() {
        return ConditionCase.forNumber(
            conditionCase_);
      }

      public Builder clearCondition() {
        conditionCase_ = 0;
        condition_ = null;
        onChanged();
        return this;
      }


      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder> locationBuilder_;
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       * @return Whether the location field is set.
       */
      @java.lang.Override
      public boolean hasLocation() {
        return conditionCase_ == 1;
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       * @return The location.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation() {
        if (locationBuilder_ == null) {
          if (conditionCase_ == 1) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance();
        } else {
          if (conditionCase_ == 1) {
            return locationBuilder_.getMessage();
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance();
        }
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       */
      public Builder setLocation(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location value) {
        if (locationBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          condition_ = value;
          onChanged();
        } else {
          locationBuilder_.setMessage(value);
        }
        conditionCase_ = 1;
        return this;
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       */
      public Builder setLocation(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder builderForValue) {
        if (locationBuilder_ == null) {
          condition_ = builderForValue.build();
          onChanged();
        } else {
          locationBuilder_.setMessage(builderForValue.build());
        }
        conditionCase_ = 1;
        return this;
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       */
      public Builder mergeLocation(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location value) {
        if (locationBuilder_ == null) {
          if (conditionCase_ == 1 &&
              condition_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance()) {
            condition_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.newBuilder((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_)
                .mergeFrom(value).buildPartial();
          } else {
            condition_ = value;
          }
          onChanged();
        } else {
          if (conditionCase_ == 1) {
            locationBuilder_.mergeFrom(value);
          }
          locationBuilder_.setMessage(value);
        }
        conditionCase_ = 1;
        return this;
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       */
      public Builder clearLocation() {
        if (locationBuilder_ == null) {
          if (conditionCase_ == 1) {
            conditionCase_ = 0;
            condition_ = null;
            onChanged();
          }
        } else {
          if (conditionCase_ == 1) {
            conditionCase_ = 0;
            condition_ = null;
          }
          locationBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder getLocationBuilder() {
        return getLocationFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder() {
        if ((conditionCase_ == 1) && (locationBuilder_ != null)) {
          return locationBuilder_.getMessageOrBuilder();
        } else {
          if (conditionCase_ == 1) {
            return (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_;
          }
          return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance();
        }
      }
      /**
       * <pre>
       * A breakpoint that is triggered when a particular line is reached.
       * Column index will be ignored for breakpoints. The debugger only supports
       * one breakpoint per line. If multiple breakpoints are supplied for a
       * single line, only the last such breakpoint is accepted.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 1;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder> 
          getLocationFieldBuilder() {
        if (locationBuilder_ == null) {
          if (!(conditionCase_ == 1)) {
            condition_ = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance();
          }
          locationBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder>(
                  (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) condition_,
                  getParentForChildren(),
                  isClean());
          condition_ = null;
        }
        conditionCase_ = 1;
        onChanged();;
        return locationBuilder_;
      }

      private java.lang.Object expression_ = "";
      /**
       * <pre>
       * An optional condition for the breakpoint. When present, the breakpoint will
       * be triggered iff both the primary condition holds and this expression
       * evaluates to True. It is unspecified how many times this expression will be
       * evaluated, so it should be free of side-effects.
       * </pre>
       *
       * <code>string expression = 2;</code>
       * @return The expression.
       */
      public java.lang.String getExpression() {
        java.lang.Object ref = expression_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          expression_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * An optional condition for the breakpoint. When present, the breakpoint will
       * be triggered iff both the primary condition holds and this expression
       * evaluates to True. It is unspecified how many times this expression will be
       * evaluated, so it should be free of side-effects.
       * </pre>
       *
       * <code>string expression = 2;</code>
       * @return The bytes for expression.
       */
      public com.google.protobuf.ByteString
          getExpressionBytes() {
        java.lang.Object ref = expression_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          expression_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * An optional condition for the breakpoint. When present, the breakpoint will
       * be triggered iff both the primary condition holds and this expression
       * evaluates to True. It is unspecified how many times this expression will be
       * evaluated, so it should be free of side-effects.
       * </pre>
       *
       * <code>string expression = 2;</code>
       * @param value The expression to set.
       * @return This builder for chaining.
       */
      public Builder setExpression(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        expression_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * An optional condition for the breakpoint. When present, the breakpoint will
       * be triggered iff both the primary condition holds and this expression
       * evaluates to True. It is unspecified how many times this expression will be
       * evaluated, so it should be free of side-effects.
       * </pre>
       *
       * <code>string expression = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearExpression() {
        
        expression_ = getDefaultInstance().getExpression();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * An optional condition for the breakpoint. When present, the breakpoint will
       * be triggered iff both the primary condition holds and this expression
       * evaluates to True. It is unspecified how many times this expression will be
       * evaluated, so it should be free of side-effects.
       * </pre>
       *
       * <code>string expression = 2;</code>
       * @param value The bytes for expression to set.
       * @return This builder for chaining.
       */
      public Builder setExpressionBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        expression_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.Breakpoint)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.Breakpoint)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Breakpoint>
        PARSER = new com.google.protobuf.AbstractParser<Breakpoint>() {
      @java.lang.Override
      public Breakpoint parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<Breakpoint> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Breakpoint> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Breakpoint getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface FrameOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.Frame)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The name of the function that this frame represents.
     * </pre>
     *
     * <code>string function_name = 1;</code>
     * @return The functionName.
     */
    java.lang.String getFunctionName();
    /**
     * <pre>
     * The name of the function that this frame represents.
     * </pre>
     *
     * <code>string function_name = 1;</code>
     * @return The bytes for functionName.
     */
    com.google.protobuf.ByteString
        getFunctionNameBytes();

    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope> 
        getScopeList();
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope getScope(int index);
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    int getScopeCount();
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder> 
        getScopeOrBuilderList();
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder getScopeOrBuilder(
        int index);

    /**
     * <pre>
     * The source location where the frame is currently paused. May not be set in
     * some situations.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 3;</code>
     * @return Whether the location field is set.
     */
    boolean hasLocation();
    /**
     * <pre>
     * The source location where the frame is currently paused. May not be set in
     * some situations.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 3;</code>
     * @return The location.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation();
    /**
     * <pre>
     * The source location where the frame is currently paused. May not be set in
     * some situations.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 3;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder();
  }
  /**
   * <pre>
   * A single frame in a thread's stack trace.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.Frame}
   */
  public static final class Frame extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.Frame)
      FrameOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Frame.newBuilder() to construct.
    private Frame(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Frame() {
      functionName_ = "";
      scope_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Frame();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Frame_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Frame_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder.class);
    }

    public static final int FUNCTION_NAME_FIELD_NUMBER = 1;
    private volatile java.lang.Object functionName_;
    /**
     * <pre>
     * The name of the function that this frame represents.
     * </pre>
     *
     * <code>string function_name = 1;</code>
     * @return The functionName.
     */
    @java.lang.Override
    public java.lang.String getFunctionName() {
      java.lang.Object ref = functionName_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        functionName_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * The name of the function that this frame represents.
     * </pre>
     *
     * <code>string function_name = 1;</code>
     * @return The bytes for functionName.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getFunctionNameBytes() {
      java.lang.Object ref = functionName_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        functionName_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int SCOPE_FIELD_NUMBER = 2;
    private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope> scope_;
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope> getScopeList() {
      return scope_;
    }
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    @java.lang.Override
    public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder> 
        getScopeOrBuilderList() {
      return scope_;
    }
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    @java.lang.Override
    public int getScopeCount() {
      return scope_.size();
    }
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope getScope(int index) {
      return scope_.get(index);
    }
    /**
     * <pre>
     * The scopes that contain value bindings accessible in this frame.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Scope scope = 2;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder getScopeOrBuilder(
        int index) {
      return scope_.get(index);
    }

    public static final int LOCATION_FIELD_NUMBER = 3;
    private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location location_;
    /**
     * <pre>
     * The source location where the frame is currently paused. May not be set in
     * some situations.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 3;</code>
     * @return Whether the location field is set.
     */
    @java.lang.Override
    public boolean hasLocation() {
      return location_ != null;
    }
    /**
     * <pre>
     * The source location where the frame is currently paused. May not be set in
     * some situations.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 3;</code>
     * @return The location.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation() {
      return location_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance() : location_;
    }
    /**
     * <pre>
     * The source location where the frame is currently paused. May not be set in
     * some situations.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 3;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder() {
      return getLocation();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(functionName_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, functionName_);
      }
      for (int i = 0; i < scope_.size(); i++) {
        output.writeMessage(2, scope_.get(i));
      }
      if (location_ != null) {
        output.writeMessage(3, getLocation());
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(functionName_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, functionName_);
      }
      for (int i = 0; i < scope_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, scope_.get(i));
      }
      if (location_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(3, getLocation());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame) obj;

      if (!getFunctionName()
          .equals(other.getFunctionName())) return false;
      if (!getScopeList()
          .equals(other.getScopeList())) return false;
      if (hasLocation() != other.hasLocation()) return false;
      if (hasLocation()) {
        if (!getLocation()
            .equals(other.getLocation())) return false;
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + FUNCTION_NAME_FIELD_NUMBER;
      hash = (53 * hash) + getFunctionName().hashCode();
      if (getScopeCount() > 0) {
        hash = (37 * hash) + SCOPE_FIELD_NUMBER;
        hash = (53 * hash) + getScopeList().hashCode();
      }
      if (hasLocation()) {
        hash = (37 * hash) + LOCATION_FIELD_NUMBER;
        hash = (53 * hash) + getLocation().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A single frame in a thread's stack trace.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.Frame}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.Frame)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.FrameOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Frame_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Frame_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        functionName_ = "";

        if (scopeBuilder_ == null) {
          scope_ = java.util.Collections.emptyList();
        } else {
          scope_ = null;
          scopeBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        if (locationBuilder_ == null) {
          location_ = null;
        } else {
          location_ = null;
          locationBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Frame_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame(this);
        int from_bitField0_ = bitField0_;
        result.functionName_ = functionName_;
        if (scopeBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0)) {
            scope_ = java.util.Collections.unmodifiableList(scope_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.scope_ = scope_;
        } else {
          result.scope_ = scopeBuilder_.build();
        }
        if (locationBuilder_ == null) {
          result.location_ = location_;
        } else {
          result.location_ = locationBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame.getDefaultInstance()) return this;
        if (!other.getFunctionName().isEmpty()) {
          functionName_ = other.functionName_;
          onChanged();
        }
        if (scopeBuilder_ == null) {
          if (!other.scope_.isEmpty()) {
            if (scope_.isEmpty()) {
              scope_ = other.scope_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureScopeIsMutable();
              scope_.addAll(other.scope_);
            }
            onChanged();
          }
        } else {
          if (!other.scope_.isEmpty()) {
            if (scopeBuilder_.isEmpty()) {
              scopeBuilder_.dispose();
              scopeBuilder_ = null;
              scope_ = other.scope_;
              bitField0_ = (bitField0_ & ~0x00000001);
              scopeBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getScopeFieldBuilder() : null;
            } else {
              scopeBuilder_.addAllMessages(other.scope_);
            }
          }
        }
        if (other.hasLocation()) {
          mergeLocation(other.getLocation());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                functionName_ = input.readStringRequireUtf8();

                break;
              } // case 10
              case 18: {
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope m =
                    input.readMessage(
                        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.parser(),
                        extensionRegistry);
                if (scopeBuilder_ == null) {
                  ensureScopeIsMutable();
                  scope_.add(m);
                } else {
                  scopeBuilder_.addMessage(m);
                }
                break;
              } // case 18
              case 26: {
                input.readMessage(
                    getLocationFieldBuilder().getBuilder(),
                    extensionRegistry);

                break;
              } // case 26
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int bitField0_;

      private java.lang.Object functionName_ = "";
      /**
       * <pre>
       * The name of the function that this frame represents.
       * </pre>
       *
       * <code>string function_name = 1;</code>
       * @return The functionName.
       */
      public java.lang.String getFunctionName() {
        java.lang.Object ref = functionName_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          functionName_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * The name of the function that this frame represents.
       * </pre>
       *
       * <code>string function_name = 1;</code>
       * @return The bytes for functionName.
       */
      public com.google.protobuf.ByteString
          getFunctionNameBytes() {
        java.lang.Object ref = functionName_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          functionName_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * The name of the function that this frame represents.
       * </pre>
       *
       * <code>string function_name = 1;</code>
       * @param value The functionName to set.
       * @return This builder for chaining.
       */
      public Builder setFunctionName(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        functionName_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The name of the function that this frame represents.
       * </pre>
       *
       * <code>string function_name = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearFunctionName() {
        
        functionName_ = getDefaultInstance().getFunctionName();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The name of the function that this frame represents.
       * </pre>
       *
       * <code>string function_name = 1;</code>
       * @param value The bytes for functionName to set.
       * @return This builder for chaining.
       */
      public Builder setFunctionNameBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        functionName_ = value;
        onChanged();
        return this;
      }

      private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope> scope_ =
        java.util.Collections.emptyList();
      private void ensureScopeIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          scope_ = new java.util.ArrayList<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope>(scope_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder> scopeBuilder_;

      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope> getScopeList() {
        if (scopeBuilder_ == null) {
          return java.util.Collections.unmodifiableList(scope_);
        } else {
          return scopeBuilder_.getMessageList();
        }
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public int getScopeCount() {
        if (scopeBuilder_ == null) {
          return scope_.size();
        } else {
          return scopeBuilder_.getCount();
        }
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope getScope(int index) {
        if (scopeBuilder_ == null) {
          return scope_.get(index);
        } else {
          return scopeBuilder_.getMessage(index);
        }
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder setScope(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope value) {
        if (scopeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureScopeIsMutable();
          scope_.set(index, value);
          onChanged();
        } else {
          scopeBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder setScope(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder builderForValue) {
        if (scopeBuilder_ == null) {
          ensureScopeIsMutable();
          scope_.set(index, builderForValue.build());
          onChanged();
        } else {
          scopeBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder addScope(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope value) {
        if (scopeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureScopeIsMutable();
          scope_.add(value);
          onChanged();
        } else {
          scopeBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder addScope(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope value) {
        if (scopeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureScopeIsMutable();
          scope_.add(index, value);
          onChanged();
        } else {
          scopeBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder addScope(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder builderForValue) {
        if (scopeBuilder_ == null) {
          ensureScopeIsMutable();
          scope_.add(builderForValue.build());
          onChanged();
        } else {
          scopeBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder addScope(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder builderForValue) {
        if (scopeBuilder_ == null) {
          ensureScopeIsMutable();
          scope_.add(index, builderForValue.build());
          onChanged();
        } else {
          scopeBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder addAllScope(
          java.lang.Iterable<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope> values) {
        if (scopeBuilder_ == null) {
          ensureScopeIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, scope_);
          onChanged();
        } else {
          scopeBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder clearScope() {
        if (scopeBuilder_ == null) {
          scope_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          scopeBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public Builder removeScope(int index) {
        if (scopeBuilder_ == null) {
          ensureScopeIsMutable();
          scope_.remove(index);
          onChanged();
        } else {
          scopeBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder getScopeBuilder(
          int index) {
        return getScopeFieldBuilder().getBuilder(index);
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder getScopeOrBuilder(
          int index) {
        if (scopeBuilder_ == null) {
          return scope_.get(index);  } else {
          return scopeBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder> 
           getScopeOrBuilderList() {
        if (scopeBuilder_ != null) {
          return scopeBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(scope_);
        }
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder addScopeBuilder() {
        return getScopeFieldBuilder().addBuilder(
            com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.getDefaultInstance());
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder addScopeBuilder(
          int index) {
        return getScopeFieldBuilder().addBuilder(
            index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.getDefaultInstance());
      }
      /**
       * <pre>
       * The scopes that contain value bindings accessible in this frame.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Scope scope = 2;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder> 
           getScopeBuilderList() {
        return getScopeFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder> 
          getScopeFieldBuilder() {
        if (scopeBuilder_ == null) {
          scopeBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder>(
                  scope_,
                  ((bitField0_ & 0x00000001) != 0),
                  getParentForChildren(),
                  isClean());
          scope_ = null;
        }
        return scopeBuilder_;
      }

      private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location location_;
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder> locationBuilder_;
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       * @return Whether the location field is set.
       */
      public boolean hasLocation() {
        return locationBuilder_ != null || location_ != null;
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       * @return The location.
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation() {
        if (locationBuilder_ == null) {
          return location_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance() : location_;
        } else {
          return locationBuilder_.getMessage();
        }
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       */
      public Builder setLocation(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location value) {
        if (locationBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          location_ = value;
          onChanged();
        } else {
          locationBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       */
      public Builder setLocation(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder builderForValue) {
        if (locationBuilder_ == null) {
          location_ = builderForValue.build();
          onChanged();
        } else {
          locationBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       */
      public Builder mergeLocation(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location value) {
        if (locationBuilder_ == null) {
          if (location_ != null) {
            location_ =
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.newBuilder(location_).mergeFrom(value).buildPartial();
          } else {
            location_ = value;
          }
          onChanged();
        } else {
          locationBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       */
      public Builder clearLocation() {
        if (locationBuilder_ == null) {
          location_ = null;
          onChanged();
        } else {
          location_ = null;
          locationBuilder_ = null;
        }

        return this;
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder getLocationBuilder() {
        
        onChanged();
        return getLocationFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder() {
        if (locationBuilder_ != null) {
          return locationBuilder_.getMessageOrBuilder();
        } else {
          return location_ == null ?
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance() : location_;
        }
      }
      /**
       * <pre>
       * The source location where the frame is currently paused. May not be set in
       * some situations.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 3;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder> 
          getLocationFieldBuilder() {
        if (locationBuilder_ == null) {
          locationBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder>(
                  getLocation(),
                  getParentForChildren(),
                  isClean());
          location_ = null;
        }
        return locationBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.Frame)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.Frame)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Frame>
        PARSER = new com.google.protobuf.AbstractParser<Frame>() {
      @java.lang.Override
      public Frame parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<Frame> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Frame> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Frame getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface LocationOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.Location)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The path of the Starlark source file.
     * </pre>
     *
     * <code>string path = 1;</code>
     * @return The path.
     */
    java.lang.String getPath();
    /**
     * <pre>
     * The path of the Starlark source file.
     * </pre>
     *
     * <code>string path = 1;</code>
     * @return The bytes for path.
     */
    com.google.protobuf.ByteString
        getPathBytes();

    /**
     * <pre>
     * A 1-indexed line number in the file denoted by path.
     * </pre>
     *
     * <code>uint32 line_number = 2;</code>
     * @return The lineNumber.
     */
    int getLineNumber();

    /**
     * <pre>
     * A 1-indexed column number in the file denoted by path. 0 (/unset) indicates
     * column number is unknown or irrelevant.
     * </pre>
     *
     * <code>uint32 column_number = 3;</code>
     * @return The columnNumber.
     */
    int getColumnNumber();
  }
  /**
   * <pre>
   * A location in Starlark source code.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.Location}
   */
  public static final class Location extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.Location)
      LocationOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Location.newBuilder() to construct.
    private Location(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Location() {
      path_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Location();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Location_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Location_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder.class);
    }

    public static final int PATH_FIELD_NUMBER = 1;
    private volatile java.lang.Object path_;
    /**
     * <pre>
     * The path of the Starlark source file.
     * </pre>
     *
     * <code>string path = 1;</code>
     * @return The path.
     */
    @java.lang.Override
    public java.lang.String getPath() {
      java.lang.Object ref = path_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        path_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * The path of the Starlark source file.
     * </pre>
     *
     * <code>string path = 1;</code>
     * @return The bytes for path.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getPathBytes() {
      java.lang.Object ref = path_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        path_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int LINE_NUMBER_FIELD_NUMBER = 2;
    private int lineNumber_;
    /**
     * <pre>
     * A 1-indexed line number in the file denoted by path.
     * </pre>
     *
     * <code>uint32 line_number = 2;</code>
     * @return The lineNumber.
     */
    @java.lang.Override
    public int getLineNumber() {
      return lineNumber_;
    }

    public static final int COLUMN_NUMBER_FIELD_NUMBER = 3;
    private int columnNumber_;
    /**
     * <pre>
     * A 1-indexed column number in the file denoted by path. 0 (/unset) indicates
     * column number is unknown or irrelevant.
     * </pre>
     *
     * <code>uint32 column_number = 3;</code>
     * @return The columnNumber.
     */
    @java.lang.Override
    public int getColumnNumber() {
      return columnNumber_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(path_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, path_);
      }
      if (lineNumber_ != 0) {
        output.writeUInt32(2, lineNumber_);
      }
      if (columnNumber_ != 0) {
        output.writeUInt32(3, columnNumber_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(path_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, path_);
      }
      if (lineNumber_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeUInt32Size(2, lineNumber_);
      }
      if (columnNumber_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeUInt32Size(3, columnNumber_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) obj;

      if (!getPath()
          .equals(other.getPath())) return false;
      if (getLineNumber()
          != other.getLineNumber()) return false;
      if (getColumnNumber()
          != other.getColumnNumber()) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + PATH_FIELD_NUMBER;
      hash = (53 * hash) + getPath().hashCode();
      hash = (37 * hash) + LINE_NUMBER_FIELD_NUMBER;
      hash = (53 * hash) + getLineNumber();
      hash = (37 * hash) + COLUMN_NUMBER_FIELD_NUMBER;
      hash = (53 * hash) + getColumnNumber();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A location in Starlark source code.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.Location}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.Location)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Location_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Location_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        path_ = "";

        lineNumber_ = 0;

        columnNumber_ = 0;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Location_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location(this);
        result.path_ = path_;
        result.lineNumber_ = lineNumber_;
        result.columnNumber_ = columnNumber_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance()) return this;
        if (!other.getPath().isEmpty()) {
          path_ = other.path_;
          onChanged();
        }
        if (other.getLineNumber() != 0) {
          setLineNumber(other.getLineNumber());
        }
        if (other.getColumnNumber() != 0) {
          setColumnNumber(other.getColumnNumber());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                path_ = input.readStringRequireUtf8();

                break;
              } // case 10
              case 16: {
                lineNumber_ = input.readUInt32();

                break;
              } // case 16
              case 24: {
                columnNumber_ = input.readUInt32();

                break;
              } // case 24
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private java.lang.Object path_ = "";
      /**
       * <pre>
       * The path of the Starlark source file.
       * </pre>
       *
       * <code>string path = 1;</code>
       * @return The path.
       */
      public java.lang.String getPath() {
        java.lang.Object ref = path_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          path_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * The path of the Starlark source file.
       * </pre>
       *
       * <code>string path = 1;</code>
       * @return The bytes for path.
       */
      public com.google.protobuf.ByteString
          getPathBytes() {
        java.lang.Object ref = path_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          path_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * The path of the Starlark source file.
       * </pre>
       *
       * <code>string path = 1;</code>
       * @param value The path to set.
       * @return This builder for chaining.
       */
      public Builder setPath(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        path_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The path of the Starlark source file.
       * </pre>
       *
       * <code>string path = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearPath() {
        
        path_ = getDefaultInstance().getPath();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The path of the Starlark source file.
       * </pre>
       *
       * <code>string path = 1;</code>
       * @param value The bytes for path to set.
       * @return This builder for chaining.
       */
      public Builder setPathBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        path_ = value;
        onChanged();
        return this;
      }

      private int lineNumber_ ;
      /**
       * <pre>
       * A 1-indexed line number in the file denoted by path.
       * </pre>
       *
       * <code>uint32 line_number = 2;</code>
       * @return The lineNumber.
       */
      @java.lang.Override
      public int getLineNumber() {
        return lineNumber_;
      }
      /**
       * <pre>
       * A 1-indexed line number in the file denoted by path.
       * </pre>
       *
       * <code>uint32 line_number = 2;</code>
       * @param value The lineNumber to set.
       * @return This builder for chaining.
       */
      public Builder setLineNumber(int value) {
        
        lineNumber_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A 1-indexed line number in the file denoted by path.
       * </pre>
       *
       * <code>uint32 line_number = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearLineNumber() {
        
        lineNumber_ = 0;
        onChanged();
        return this;
      }

      private int columnNumber_ ;
      /**
       * <pre>
       * A 1-indexed column number in the file denoted by path. 0 (/unset) indicates
       * column number is unknown or irrelevant.
       * </pre>
       *
       * <code>uint32 column_number = 3;</code>
       * @return The columnNumber.
       */
      @java.lang.Override
      public int getColumnNumber() {
        return columnNumber_;
      }
      /**
       * <pre>
       * A 1-indexed column number in the file denoted by path. 0 (/unset) indicates
       * column number is unknown or irrelevant.
       * </pre>
       *
       * <code>uint32 column_number = 3;</code>
       * @param value The columnNumber to set.
       * @return This builder for chaining.
       */
      public Builder setColumnNumber(int value) {
        
        columnNumber_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A 1-indexed column number in the file denoted by path. 0 (/unset) indicates
       * column number is unknown or irrelevant.
       * </pre>
       *
       * <code>uint32 column_number = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearColumnNumber() {
        
        columnNumber_ = 0;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.Location)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.Location)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Location>
        PARSER = new com.google.protobuf.AbstractParser<Location>() {
      @java.lang.Override
      public Location parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<Location> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Location> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ScopeOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.Scope)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * A human-readable name of the scope, such as "global" or "local".
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The name.
     */
    java.lang.String getName();
    /**
     * <pre>
     * A human-readable name of the scope, such as "global" or "local".
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The bytes for name.
     */
    com.google.protobuf.ByteString
        getNameBytes();

    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> 
        getBindingList();
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getBinding(int index);
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    int getBindingCount();
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
        getBindingOrBuilderList();
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getBindingOrBuilder(
        int index);
  }
  /**
   * <pre>
   * A scope that contains value bindings accessible in a frame.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.Scope}
   */
  public static final class Scope extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.Scope)
      ScopeOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Scope.newBuilder() to construct.
    private Scope(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Scope() {
      name_ = "";
      binding_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Scope();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Scope_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Scope_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder.class);
    }

    public static final int NAME_FIELD_NUMBER = 1;
    private volatile java.lang.Object name_;
    /**
     * <pre>
     * A human-readable name of the scope, such as "global" or "local".
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The name.
     */
    @java.lang.Override
    public java.lang.String getName() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        name_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * A human-readable name of the scope, such as "global" or "local".
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The bytes for name.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getNameBytes() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        name_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int BINDING_FIELD_NUMBER = 2;
    private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> binding_;
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> getBindingList() {
      return binding_;
    }
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    @java.lang.Override
    public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
        getBindingOrBuilderList() {
      return binding_;
    }
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    @java.lang.Override
    public int getBindingCount() {
      return binding_.size();
    }
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getBinding(int index) {
      return binding_.get(index);
    }
    /**
     * <pre>
     * The variable bindings that are defined in this scope.
     * </pre>
     *
     * <code>repeated .starlark_debugging.Value binding = 2;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getBindingOrBuilder(
        int index) {
      return binding_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, name_);
      }
      for (int i = 0; i < binding_.size(); i++) {
        output.writeMessage(2, binding_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, name_);
      }
      for (int i = 0; i < binding_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, binding_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope) obj;

      if (!getName()
          .equals(other.getName())) return false;
      if (!getBindingList()
          .equals(other.getBindingList())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + NAME_FIELD_NUMBER;
      hash = (53 * hash) + getName().hashCode();
      if (getBindingCount() > 0) {
        hash = (37 * hash) + BINDING_FIELD_NUMBER;
        hash = (53 * hash) + getBindingList().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * A scope that contains value bindings accessible in a frame.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.Scope}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.Scope)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ScopeOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Scope_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Scope_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        name_ = "";

        if (bindingBuilder_ == null) {
          binding_ = java.util.Collections.emptyList();
        } else {
          binding_ = null;
          bindingBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Scope_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope(this);
        int from_bitField0_ = bitField0_;
        result.name_ = name_;
        if (bindingBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0)) {
            binding_ = java.util.Collections.unmodifiableList(binding_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.binding_ = binding_;
        } else {
          result.binding_ = bindingBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope.getDefaultInstance()) return this;
        if (!other.getName().isEmpty()) {
          name_ = other.name_;
          onChanged();
        }
        if (bindingBuilder_ == null) {
          if (!other.binding_.isEmpty()) {
            if (binding_.isEmpty()) {
              binding_ = other.binding_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureBindingIsMutable();
              binding_.addAll(other.binding_);
            }
            onChanged();
          }
        } else {
          if (!other.binding_.isEmpty()) {
            if (bindingBuilder_.isEmpty()) {
              bindingBuilder_.dispose();
              bindingBuilder_ = null;
              binding_ = other.binding_;
              bitField0_ = (bitField0_ & ~0x00000001);
              bindingBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getBindingFieldBuilder() : null;
            } else {
              bindingBuilder_.addAllMessages(other.binding_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                name_ = input.readStringRequireUtf8();

                break;
              } // case 10
              case 18: {
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value m =
                    input.readMessage(
                        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.parser(),
                        extensionRegistry);
                if (bindingBuilder_ == null) {
                  ensureBindingIsMutable();
                  binding_.add(m);
                } else {
                  bindingBuilder_.addMessage(m);
                }
                break;
              } // case 18
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }
      private int bitField0_;

      private java.lang.Object name_ = "";
      /**
       * <pre>
       * A human-readable name of the scope, such as "global" or "local".
       * </pre>
       *
       * <code>string name = 1;</code>
       * @return The name.
       */
      public java.lang.String getName() {
        java.lang.Object ref = name_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          name_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * A human-readable name of the scope, such as "global" or "local".
       * </pre>
       *
       * <code>string name = 1;</code>
       * @return The bytes for name.
       */
      public com.google.protobuf.ByteString
          getNameBytes() {
        java.lang.Object ref = name_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          name_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * A human-readable name of the scope, such as "global" or "local".
       * </pre>
       *
       * <code>string name = 1;</code>
       * @param value The name to set.
       * @return This builder for chaining.
       */
      public Builder setName(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        name_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A human-readable name of the scope, such as "global" or "local".
       * </pre>
       *
       * <code>string name = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearName() {
        
        name_ = getDefaultInstance().getName();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A human-readable name of the scope, such as "global" or "local".
       * </pre>
       *
       * <code>string name = 1;</code>
       * @param value The bytes for name to set.
       * @return This builder for chaining.
       */
      public Builder setNameBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        name_ = value;
        onChanged();
        return this;
      }

      private java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> binding_ =
        java.util.Collections.emptyList();
      private void ensureBindingIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          binding_ = new java.util.ArrayList<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value>(binding_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> bindingBuilder_;

      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> getBindingList() {
        if (bindingBuilder_ == null) {
          return java.util.Collections.unmodifiableList(binding_);
        } else {
          return bindingBuilder_.getMessageList();
        }
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public int getBindingCount() {
        if (bindingBuilder_ == null) {
          return binding_.size();
        } else {
          return bindingBuilder_.getCount();
        }
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getBinding(int index) {
        if (bindingBuilder_ == null) {
          return binding_.get(index);
        } else {
          return bindingBuilder_.getMessage(index);
        }
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder setBinding(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (bindingBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBindingIsMutable();
          binding_.set(index, value);
          onChanged();
        } else {
          bindingBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder setBinding(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder builderForValue) {
        if (bindingBuilder_ == null) {
          ensureBindingIsMutable();
          binding_.set(index, builderForValue.build());
          onChanged();
        } else {
          bindingBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder addBinding(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (bindingBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBindingIsMutable();
          binding_.add(value);
          onChanged();
        } else {
          bindingBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder addBinding(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value value) {
        if (bindingBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBindingIsMutable();
          binding_.add(index, value);
          onChanged();
        } else {
          bindingBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder addBinding(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder builderForValue) {
        if (bindingBuilder_ == null) {
          ensureBindingIsMutable();
          binding_.add(builderForValue.build());
          onChanged();
        } else {
          bindingBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder addBinding(
          int index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder builderForValue) {
        if (bindingBuilder_ == null) {
          ensureBindingIsMutable();
          binding_.add(index, builderForValue.build());
          onChanged();
        } else {
          bindingBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder addAllBinding(
          java.lang.Iterable<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value> values) {
        if (bindingBuilder_ == null) {
          ensureBindingIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, binding_);
          onChanged();
        } else {
          bindingBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder clearBinding() {
        if (bindingBuilder_ == null) {
          binding_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          bindingBuilder_.clear();
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public Builder removeBinding(int index) {
        if (bindingBuilder_ == null) {
          ensureBindingIsMutable();
          binding_.remove(index);
          onChanged();
        } else {
          bindingBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder getBindingBuilder(
          int index) {
        return getBindingFieldBuilder().getBuilder(index);
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder getBindingOrBuilder(
          int index) {
        if (bindingBuilder_ == null) {
          return binding_.get(index);  } else {
          return bindingBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public java.util.List<? extends com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
           getBindingOrBuilderList() {
        if (bindingBuilder_ != null) {
          return bindingBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(binding_);
        }
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder addBindingBuilder() {
        return getBindingFieldBuilder().addBuilder(
            com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance());
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder addBindingBuilder(
          int index) {
        return getBindingFieldBuilder().addBuilder(
            index, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance());
      }
      /**
       * <pre>
       * The variable bindings that are defined in this scope.
       * </pre>
       *
       * <code>repeated .starlark_debugging.Value binding = 2;</code>
       */
      public java.util.List<com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder> 
           getBindingBuilderList() {
        return getBindingFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder> 
          getBindingFieldBuilder() {
        if (bindingBuilder_ == null) {
          bindingBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder>(
                  binding_,
                  ((bitField0_ & 0x00000001) != 0),
                  getParentForChildren(),
                  isClean());
          binding_ = null;
        }
        return bindingBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.Scope)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.Scope)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Scope>
        PARSER = new com.google.protobuf.AbstractParser<Scope>() {
      @java.lang.Override
      public Scope parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<Scope> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Scope> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Scope getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface PausedThreadOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.PausedThread)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The identifier of the thread.
     * </pre>
     *
     * <code>int64 id = 1;</code>
     * @return The id.
     */
    long getId();

    /**
     * <pre>
     * A descriptive name for the thread that can be displayed in the debugger's
     * UI.
     * </pre>
     *
     * <code>string name = 2;</code>
     * @return The name.
     */
    java.lang.String getName();
    /**
     * <pre>
     * A descriptive name for the thread that can be displayed in the debugger's
     * UI.
     * </pre>
     *
     * <code>string name = 2;</code>
     * @return The bytes for name.
     */
    com.google.protobuf.ByteString
        getNameBytes();

    /**
     * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
     * @return The enum numeric value on the wire for pauseReason.
     */
    int getPauseReasonValue();
    /**
     * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
     * @return The pauseReason.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason getPauseReason();

    /**
     * <pre>
     * The location in Starlark code of the next statement or expression that will
     * be executed.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 4;</code>
     * @return Whether the location field is set.
     */
    boolean hasLocation();
    /**
     * <pre>
     * The location in Starlark code of the next statement or expression that will
     * be executed.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 4;</code>
     * @return The location.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation();
    /**
     * <pre>
     * The location in Starlark code of the next statement or expression that will
     * be executed.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 4;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder();

    /**
     * <pre>
     * An error that occurred while evaluating a breakpoint condition. Present if
     * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
     * </pre>
     *
     * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
     * @return Whether the conditionalBreakpointError field is set.
     */
    boolean hasConditionalBreakpointError();
    /**
     * <pre>
     * An error that occurred while evaluating a breakpoint condition. Present if
     * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
     * </pre>
     *
     * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
     * @return The conditionalBreakpointError.
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getConditionalBreakpointError();
    /**
     * <pre>
     * An error that occurred while evaluating a breakpoint condition. Present if
     * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
     * </pre>
     *
     * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
     */
    com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder getConditionalBreakpointErrorOrBuilder();
  }
  /**
   * <pre>
   * Information about a paused Starlark thread.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.PausedThread}
   */
  public static final class PausedThread extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.PausedThread)
      PausedThreadOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use PausedThread.newBuilder() to construct.
    private PausedThread(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private PausedThread() {
      name_ = "";
      pauseReason_ = 0;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new PausedThread();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PausedThread_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PausedThread_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.Builder.class);
    }

    public static final int ID_FIELD_NUMBER = 1;
    private long id_;
    /**
     * <pre>
     * The identifier of the thread.
     * </pre>
     *
     * <code>int64 id = 1;</code>
     * @return The id.
     */
    @java.lang.Override
    public long getId() {
      return id_;
    }

    public static final int NAME_FIELD_NUMBER = 2;
    private volatile java.lang.Object name_;
    /**
     * <pre>
     * A descriptive name for the thread that can be displayed in the debugger's
     * UI.
     * </pre>
     *
     * <code>string name = 2;</code>
     * @return The name.
     */
    @java.lang.Override
    public java.lang.String getName() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        name_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * A descriptive name for the thread that can be displayed in the debugger's
     * UI.
     * </pre>
     *
     * <code>string name = 2;</code>
     * @return The bytes for name.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getNameBytes() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        name_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int PAUSE_REASON_FIELD_NUMBER = 3;
    private int pauseReason_;
    /**
     * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
     * @return The enum numeric value on the wire for pauseReason.
     */
    @java.lang.Override public int getPauseReasonValue() {
      return pauseReason_;
    }
    /**
     * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
     * @return The pauseReason.
     */
    @java.lang.Override public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason getPauseReason() {
      @SuppressWarnings("deprecation")
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason result = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason.valueOf(pauseReason_);
      return result == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason.UNRECOGNIZED : result;
    }

    public static final int LOCATION_FIELD_NUMBER = 4;
    private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location location_;
    /**
     * <pre>
     * The location in Starlark code of the next statement or expression that will
     * be executed.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 4;</code>
     * @return Whether the location field is set.
     */
    @java.lang.Override
    public boolean hasLocation() {
      return location_ != null;
    }
    /**
     * <pre>
     * The location in Starlark code of the next statement or expression that will
     * be executed.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 4;</code>
     * @return The location.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation() {
      return location_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance() : location_;
    }
    /**
     * <pre>
     * The location in Starlark code of the next statement or expression that will
     * be executed.
     * </pre>
     *
     * <code>.starlark_debugging.Location location = 4;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder() {
      return getLocation();
    }

    public static final int CONDITIONAL_BREAKPOINT_ERROR_FIELD_NUMBER = 5;
    private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error conditionalBreakpointError_;
    /**
     * <pre>
     * An error that occurred while evaluating a breakpoint condition. Present if
     * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
     * </pre>
     *
     * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
     * @return Whether the conditionalBreakpointError field is set.
     */
    @java.lang.Override
    public boolean hasConditionalBreakpointError() {
      return conditionalBreakpointError_ != null;
    }
    /**
     * <pre>
     * An error that occurred while evaluating a breakpoint condition. Present if
     * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
     * </pre>
     *
     * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
     * @return The conditionalBreakpointError.
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getConditionalBreakpointError() {
      return conditionalBreakpointError_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance() : conditionalBreakpointError_;
    }
    /**
     * <pre>
     * An error that occurred while evaluating a breakpoint condition. Present if
     * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
     * </pre>
     *
     * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
     */
    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder getConditionalBreakpointErrorOrBuilder() {
      return getConditionalBreakpointError();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (id_ != 0L) {
        output.writeInt64(1, id_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, name_);
      }
      if (pauseReason_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason.UNSET.getNumber()) {
        output.writeEnum(3, pauseReason_);
      }
      if (location_ != null) {
        output.writeMessage(4, getLocation());
      }
      if (conditionalBreakpointError_ != null) {
        output.writeMessage(5, getConditionalBreakpointError());
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (id_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, id_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, name_);
      }
      if (pauseReason_ != com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason.UNSET.getNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(3, pauseReason_);
      }
      if (location_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(4, getLocation());
      }
      if (conditionalBreakpointError_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(5, getConditionalBreakpointError());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread) obj;

      if (getId()
          != other.getId()) return false;
      if (!getName()
          .equals(other.getName())) return false;
      if (pauseReason_ != other.pauseReason_) return false;
      if (hasLocation() != other.hasLocation()) return false;
      if (hasLocation()) {
        if (!getLocation()
            .equals(other.getLocation())) return false;
      }
      if (hasConditionalBreakpointError() != other.hasConditionalBreakpointError()) return false;
      if (hasConditionalBreakpointError()) {
        if (!getConditionalBreakpointError()
            .equals(other.getConditionalBreakpointError())) return false;
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getId());
      hash = (37 * hash) + NAME_FIELD_NUMBER;
      hash = (53 * hash) + getName().hashCode();
      hash = (37 * hash) + PAUSE_REASON_FIELD_NUMBER;
      hash = (53 * hash) + pauseReason_;
      if (hasLocation()) {
        hash = (37 * hash) + LOCATION_FIELD_NUMBER;
        hash = (53 * hash) + getLocation().hashCode();
      }
      if (hasConditionalBreakpointError()) {
        hash = (37 * hash) + CONDITIONAL_BREAKPOINT_ERROR_FIELD_NUMBER;
        hash = (53 * hash) + getConditionalBreakpointError().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * Information about a paused Starlark thread.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.PausedThread}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.PausedThread)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThreadOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PausedThread_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PausedThread_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        id_ = 0L;

        name_ = "";

        pauseReason_ = 0;

        if (locationBuilder_ == null) {
          location_ = null;
        } else {
          location_ = null;
          locationBuilder_ = null;
        }
        if (conditionalBreakpointErrorBuilder_ == null) {
          conditionalBreakpointError_ = null;
        } else {
          conditionalBreakpointError_ = null;
          conditionalBreakpointErrorBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_PausedThread_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread(this);
        result.id_ = id_;
        result.name_ = name_;
        result.pauseReason_ = pauseReason_;
        if (locationBuilder_ == null) {
          result.location_ = location_;
        } else {
          result.location_ = locationBuilder_.build();
        }
        if (conditionalBreakpointErrorBuilder_ == null) {
          result.conditionalBreakpointError_ = conditionalBreakpointError_;
        } else {
          result.conditionalBreakpointError_ = conditionalBreakpointErrorBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread.getDefaultInstance()) return this;
        if (other.getId() != 0L) {
          setId(other.getId());
        }
        if (!other.getName().isEmpty()) {
          name_ = other.name_;
          onChanged();
        }
        if (other.pauseReason_ != 0) {
          setPauseReasonValue(other.getPauseReasonValue());
        }
        if (other.hasLocation()) {
          mergeLocation(other.getLocation());
        }
        if (other.hasConditionalBreakpointError()) {
          mergeConditionalBreakpointError(other.getConditionalBreakpointError());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                id_ = input.readInt64();

                break;
              } // case 8
              case 18: {
                name_ = input.readStringRequireUtf8();

                break;
              } // case 18
              case 24: {
                pauseReason_ = input.readEnum();

                break;
              } // case 24
              case 34: {
                input.readMessage(
                    getLocationFieldBuilder().getBuilder(),
                    extensionRegistry);

                break;
              } // case 34
              case 42: {
                input.readMessage(
                    getConditionalBreakpointErrorFieldBuilder().getBuilder(),
                    extensionRegistry);

                break;
              } // case 42
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private long id_ ;
      /**
       * <pre>
       * The identifier of the thread.
       * </pre>
       *
       * <code>int64 id = 1;</code>
       * @return The id.
       */
      @java.lang.Override
      public long getId() {
        return id_;
      }
      /**
       * <pre>
       * The identifier of the thread.
       * </pre>
       *
       * <code>int64 id = 1;</code>
       * @param value The id to set.
       * @return This builder for chaining.
       */
      public Builder setId(long value) {
        
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The identifier of the thread.
       * </pre>
       *
       * <code>int64 id = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearId() {
        
        id_ = 0L;
        onChanged();
        return this;
      }

      private java.lang.Object name_ = "";
      /**
       * <pre>
       * A descriptive name for the thread that can be displayed in the debugger's
       * UI.
       * </pre>
       *
       * <code>string name = 2;</code>
       * @return The name.
       */
      public java.lang.String getName() {
        java.lang.Object ref = name_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          name_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * A descriptive name for the thread that can be displayed in the debugger's
       * UI.
       * </pre>
       *
       * <code>string name = 2;</code>
       * @return The bytes for name.
       */
      public com.google.protobuf.ByteString
          getNameBytes() {
        java.lang.Object ref = name_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          name_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * A descriptive name for the thread that can be displayed in the debugger's
       * UI.
       * </pre>
       *
       * <code>string name = 2;</code>
       * @param value The name to set.
       * @return This builder for chaining.
       */
      public Builder setName(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        name_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A descriptive name for the thread that can be displayed in the debugger's
       * UI.
       * </pre>
       *
       * <code>string name = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearName() {
        
        name_ = getDefaultInstance().getName();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A descriptive name for the thread that can be displayed in the debugger's
       * UI.
       * </pre>
       *
       * <code>string name = 2;</code>
       * @param value The bytes for name to set.
       * @return This builder for chaining.
       */
      public Builder setNameBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        name_ = value;
        onChanged();
        return this;
      }

      private int pauseReason_ = 0;
      /**
       * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
       * @return The enum numeric value on the wire for pauseReason.
       */
      @java.lang.Override public int getPauseReasonValue() {
        return pauseReason_;
      }
      /**
       * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
       * @param value The enum numeric value on the wire for pauseReason to set.
       * @return This builder for chaining.
       */
      public Builder setPauseReasonValue(int value) {
        
        pauseReason_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
       * @return The pauseReason.
       */
      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason getPauseReason() {
        @SuppressWarnings("deprecation")
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason result = com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason.valueOf(pauseReason_);
        return result == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason.UNRECOGNIZED : result;
      }
      /**
       * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
       * @param value The pauseReason to set.
       * @return This builder for chaining.
       */
      public Builder setPauseReason(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PauseReason value) {
        if (value == null) {
          throw new NullPointerException();
        }
        
        pauseReason_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <code>.starlark_debugging.PauseReason pause_reason = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearPauseReason() {
        
        pauseReason_ = 0;
        onChanged();
        return this;
      }

      private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location location_;
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder> locationBuilder_;
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       * @return Whether the location field is set.
       */
      public boolean hasLocation() {
        return locationBuilder_ != null || location_ != null;
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       * @return The location.
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location getLocation() {
        if (locationBuilder_ == null) {
          return location_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance() : location_;
        } else {
          return locationBuilder_.getMessage();
        }
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       */
      public Builder setLocation(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location value) {
        if (locationBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          location_ = value;
          onChanged();
        } else {
          locationBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       */
      public Builder setLocation(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder builderForValue) {
        if (locationBuilder_ == null) {
          location_ = builderForValue.build();
          onChanged();
        } else {
          locationBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       */
      public Builder mergeLocation(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location value) {
        if (locationBuilder_ == null) {
          if (location_ != null) {
            location_ =
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.newBuilder(location_).mergeFrom(value).buildPartial();
          } else {
            location_ = value;
          }
          onChanged();
        } else {
          locationBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       */
      public Builder clearLocation() {
        if (locationBuilder_ == null) {
          location_ = null;
          onChanged();
        } else {
          location_ = null;
          locationBuilder_ = null;
        }

        return this;
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder getLocationBuilder() {
        
        onChanged();
        return getLocationFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder getLocationOrBuilder() {
        if (locationBuilder_ != null) {
          return locationBuilder_.getMessageOrBuilder();
        } else {
          return location_ == null ?
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.getDefaultInstance() : location_;
        }
      }
      /**
       * <pre>
       * The location in Starlark code of the next statement or expression that will
       * be executed.
       * </pre>
       *
       * <code>.starlark_debugging.Location location = 4;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder> 
          getLocationFieldBuilder() {
        if (locationBuilder_ == null) {
          locationBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Location.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.LocationOrBuilder>(
                  getLocation(),
                  getParentForChildren(),
                  isClean());
          location_ = null;
        }
        return locationBuilder_;
      }

      private com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error conditionalBreakpointError_;
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder> conditionalBreakpointErrorBuilder_;
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       * @return Whether the conditionalBreakpointError field is set.
       */
      public boolean hasConditionalBreakpointError() {
        return conditionalBreakpointErrorBuilder_ != null || conditionalBreakpointError_ != null;
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       * @return The conditionalBreakpointError.
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error getConditionalBreakpointError() {
        if (conditionalBreakpointErrorBuilder_ == null) {
          return conditionalBreakpointError_ == null ? com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance() : conditionalBreakpointError_;
        } else {
          return conditionalBreakpointErrorBuilder_.getMessage();
        }
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       */
      public Builder setConditionalBreakpointError(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error value) {
        if (conditionalBreakpointErrorBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          conditionalBreakpointError_ = value;
          onChanged();
        } else {
          conditionalBreakpointErrorBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       */
      public Builder setConditionalBreakpointError(
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder builderForValue) {
        if (conditionalBreakpointErrorBuilder_ == null) {
          conditionalBreakpointError_ = builderForValue.build();
          onChanged();
        } else {
          conditionalBreakpointErrorBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       */
      public Builder mergeConditionalBreakpointError(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error value) {
        if (conditionalBreakpointErrorBuilder_ == null) {
          if (conditionalBreakpointError_ != null) {
            conditionalBreakpointError_ =
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.newBuilder(conditionalBreakpointError_).mergeFrom(value).buildPartial();
          } else {
            conditionalBreakpointError_ = value;
          }
          onChanged();
        } else {
          conditionalBreakpointErrorBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       */
      public Builder clearConditionalBreakpointError() {
        if (conditionalBreakpointErrorBuilder_ == null) {
          conditionalBreakpointError_ = null;
          onChanged();
        } else {
          conditionalBreakpointError_ = null;
          conditionalBreakpointErrorBuilder_ = null;
        }

        return this;
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder getConditionalBreakpointErrorBuilder() {
        
        onChanged();
        return getConditionalBreakpointErrorFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       */
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder getConditionalBreakpointErrorOrBuilder() {
        if (conditionalBreakpointErrorBuilder_ != null) {
          return conditionalBreakpointErrorBuilder_.getMessageOrBuilder();
        } else {
          return conditionalBreakpointError_ == null ?
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.getDefaultInstance() : conditionalBreakpointError_;
        }
      }
      /**
       * <pre>
       * An error that occurred while evaluating a breakpoint condition. Present if
       * and only if pause_reason is CONDITIONAL_BREAKPOINT_ERROR.
       * </pre>
       *
       * <code>.starlark_debugging.Error conditional_breakpoint_error = 5;</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder> 
          getConditionalBreakpointErrorFieldBuilder() {
        if (conditionalBreakpointErrorBuilder_ == null) {
          conditionalBreakpointErrorBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Error.Builder, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ErrorOrBuilder>(
                  getConditionalBreakpointError(),
                  getParentForChildren(),
                  isClean());
          conditionalBreakpointError_ = null;
        }
        return conditionalBreakpointErrorBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.PausedThread)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.PausedThread)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<PausedThread>
        PARSER = new com.google.protobuf.AbstractParser<PausedThread>() {
      @java.lang.Override
      public PausedThread parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<PausedThread> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<PausedThread> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.PausedThread getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ValueOrBuilder extends
      // @@protoc_insertion_point(interface_extends:starlark_debugging.Value)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * A label that describes this value's location or source in a value
     * hierarchy.
     * For example, in a stack frame, the label would be the name of the variable
     * to which the value is bound. For a value that is an element of a list, its
     * its label would be its subscript, such as "[4]". A value that is a field in
     * a struct would use the field's name as its label, and so forth.
     * </pre>
     *
     * <code>string label = 1;</code>
     * @return The label.
     */
    java.lang.String getLabel();
    /**
     * <pre>
     * A label that describes this value's location or source in a value
     * hierarchy.
     * For example, in a stack frame, the label would be the name of the variable
     * to which the value is bound. For a value that is an element of a list, its
     * its label would be its subscript, such as "[4]". A value that is a field in
     * a struct would use the field's name as its label, and so forth.
     * </pre>
     *
     * <code>string label = 1;</code>
     * @return The bytes for label.
     */
    com.google.protobuf.ByteString
        getLabelBytes();

    /**
     * <pre>
     * A string description of the value.
     * </pre>
     *
     * <code>string description = 2;</code>
     * @return The description.
     */
    java.lang.String getDescription();
    /**
     * <pre>
     * A string description of the value.
     * </pre>
     *
     * <code>string description = 2;</code>
     * @return The bytes for description.
     */
    com.google.protobuf.ByteString
        getDescriptionBytes();

    /**
     * <pre>
     * A string describing the type of the value.
     * This field may be omitted if the value does not correspond to a "real" type
     * as far as the debugging view is concerned; for example, dictionaries will
     * be rendered as sequences of key/value pairs ("entries") but the entries
     * themselves do not have a meaningful type with respect to our rendering.
     * </pre>
     *
     * <code>string type = 3;</code>
     * @return The type.
     */
    java.lang.String getType();
    /**
     * <pre>
     * A string describing the type of the value.
     * This field may be omitted if the value does not correspond to a "real" type
     * as far as the debugging view is concerned; for example, dictionaries will
     * be rendered as sequences of key/value pairs ("entries") but the entries
     * themselves do not have a meaningful type with respect to our rendering.
     * </pre>
     *
     * <code>string type = 3;</code>
     * @return The bytes for type.
     */
    com.google.protobuf.ByteString
        getTypeBytes();

    /**
     * <pre>
     * Will be false if the value is known to have no children. May sometimes be
     * true if this isn't yet known, in which case GetChildrenResponse#children
     * will be empty.
     * </pre>
     *
     * <code>bool has_children = 4;</code>
     * @return The hasChildren.
     */
    boolean getHasChildren();

    /**
     * <pre>
     * An identifier for this value, used to request its children. The same value
     * may be known by multiple ids. Not set for values without children.
     * </pre>
     *
     * <code>int64 id = 5;</code>
     * @return The id.
     */
    long getId();
  }
  /**
   * <pre>
   * The debugger representation of a Starlark value.
   * </pre>
   *
   * Protobuf type {@code starlark_debugging.Value}
   */
  public static final class Value extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:starlark_debugging.Value)
      ValueOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Value.newBuilder() to construct.
    private Value(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Value() {
      label_ = "";
      description_ = "";
      type_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Value();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Value_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Value_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder.class);
    }

    public static final int LABEL_FIELD_NUMBER = 1;
    private volatile java.lang.Object label_;
    /**
     * <pre>
     * A label that describes this value's location or source in a value
     * hierarchy.
     * For example, in a stack frame, the label would be the name of the variable
     * to which the value is bound. For a value that is an element of a list, its
     * its label would be its subscript, such as "[4]". A value that is a field in
     * a struct would use the field's name as its label, and so forth.
     * </pre>
     *
     * <code>string label = 1;</code>
     * @return The label.
     */
    @java.lang.Override
    public java.lang.String getLabel() {
      java.lang.Object ref = label_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        label_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * A label that describes this value's location or source in a value
     * hierarchy.
     * For example, in a stack frame, the label would be the name of the variable
     * to which the value is bound. For a value that is an element of a list, its
     * its label would be its subscript, such as "[4]". A value that is a field in
     * a struct would use the field's name as its label, and so forth.
     * </pre>
     *
     * <code>string label = 1;</code>
     * @return The bytes for label.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getLabelBytes() {
      java.lang.Object ref = label_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        label_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int DESCRIPTION_FIELD_NUMBER = 2;
    private volatile java.lang.Object description_;
    /**
     * <pre>
     * A string description of the value.
     * </pre>
     *
     * <code>string description = 2;</code>
     * @return The description.
     */
    @java.lang.Override
    public java.lang.String getDescription() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        description_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * A string description of the value.
     * </pre>
     *
     * <code>string description = 2;</code>
     * @return The bytes for description.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getDescriptionBytes() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        description_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int TYPE_FIELD_NUMBER = 3;
    private volatile java.lang.Object type_;
    /**
     * <pre>
     * A string describing the type of the value.
     * This field may be omitted if the value does not correspond to a "real" type
     * as far as the debugging view is concerned; for example, dictionaries will
     * be rendered as sequences of key/value pairs ("entries") but the entries
     * themselves do not have a meaningful type with respect to our rendering.
     * </pre>
     *
     * <code>string type = 3;</code>
     * @return The type.
     */
    @java.lang.Override
    public java.lang.String getType() {
      java.lang.Object ref = type_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        type_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * A string describing the type of the value.
     * This field may be omitted if the value does not correspond to a "real" type
     * as far as the debugging view is concerned; for example, dictionaries will
     * be rendered as sequences of key/value pairs ("entries") but the entries
     * themselves do not have a meaningful type with respect to our rendering.
     * </pre>
     *
     * <code>string type = 3;</code>
     * @return The bytes for type.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getTypeBytes() {
      java.lang.Object ref = type_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        type_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int HAS_CHILDREN_FIELD_NUMBER = 4;
    private boolean hasChildren_;
    /**
     * <pre>
     * Will be false if the value is known to have no children. May sometimes be
     * true if this isn't yet known, in which case GetChildrenResponse#children
     * will be empty.
     * </pre>
     *
     * <code>bool has_children = 4;</code>
     * @return The hasChildren.
     */
    @java.lang.Override
    public boolean getHasChildren() {
      return hasChildren_;
    }

    public static final int ID_FIELD_NUMBER = 5;
    private long id_;
    /**
     * <pre>
     * An identifier for this value, used to request its children. The same value
     * may be known by multiple ids. Not set for values without children.
     * </pre>
     *
     * <code>int64 id = 5;</code>
     * @return The id.
     */
    @java.lang.Override
    public long getId() {
      return id_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(label_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, label_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(description_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, description_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(type_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 3, type_);
      }
      if (hasChildren_ != false) {
        output.writeBool(4, hasChildren_);
      }
      if (id_ != 0L) {
        output.writeInt64(5, id_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(label_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, label_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(description_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, description_);
      }
      if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(type_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(3, type_);
      }
      if (hasChildren_ != false) {
        size += com.google.protobuf.CodedOutputStream
          .computeBoolSize(4, hasChildren_);
      }
      if (id_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, id_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value)) {
        return super.equals(obj);
      }
      com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value other = (com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value) obj;

      if (!getLabel()
          .equals(other.getLabel())) return false;
      if (!getDescription()
          .equals(other.getDescription())) return false;
      if (!getType()
          .equals(other.getType())) return false;
      if (getHasChildren()
          != other.getHasChildren()) return false;
      if (getId()
          != other.getId()) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + LABEL_FIELD_NUMBER;
      hash = (53 * hash) + getLabel().hashCode();
      hash = (37 * hash) + DESCRIPTION_FIELD_NUMBER;
      hash = (53 * hash) + getDescription().hashCode();
      hash = (37 * hash) + TYPE_FIELD_NUMBER;
      hash = (53 * hash) + getType().hashCode();
      hash = (37 * hash) + HAS_CHILDREN_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(
          getHasChildren());
      hash = (37 * hash) + ID_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getId());
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * The debugger representation of a Starlark value.
     * </pre>
     *
     * Protobuf type {@code starlark_debugging.Value}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:starlark_debugging.Value)
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.ValueOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Value_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Value_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.class, com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.Builder.class);
      }

      // Construct using com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.newBuilder()
      private Builder() {

      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);

      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        label_ = "";

        description_ = "";

        type_ = "";

        hasChildren_ = false;

        id_ = 0L;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.internal_static_starlark_debugging_Value_descriptor;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getDefaultInstanceForType() {
        return com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance();
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value build() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value buildPartial() {
        com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value result = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value(this);
        result.label_ = label_;
        result.description_ = description_;
        result.type_ = type_;
        result.hasChildren_ = hasChildren_;
        result.id_ = id_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value) {
          return mergeFrom((com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value other) {
        if (other == com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value.getDefaultInstance()) return this;
        if (!other.getLabel().isEmpty()) {
          label_ = other.label_;
          onChanged();
        }
        if (!other.getDescription().isEmpty()) {
          description_ = other.description_;
          onChanged();
        }
        if (!other.getType().isEmpty()) {
          type_ = other.type_;
          onChanged();
        }
        if (other.getHasChildren() != false) {
          setHasChildren(other.getHasChildren());
        }
        if (other.getId() != 0L) {
          setId(other.getId());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10: {
                label_ = input.readStringRequireUtf8();

                break;
              } // case 10
              case 18: {
                description_ = input.readStringRequireUtf8();

                break;
              } // case 18
              case 26: {
                type_ = input.readStringRequireUtf8();

                break;
              } // case 26
              case 32: {
                hasChildren_ = input.readBool();

                break;
              } // case 32
              case 40: {
                id_ = input.readInt64();

                break;
              } // case 40
              default: {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private java.lang.Object label_ = "";
      /**
       * <pre>
       * A label that describes this value's location or source in a value
       * hierarchy.
       * For example, in a stack frame, the label would be the name of the variable
       * to which the value is bound. For a value that is an element of a list, its
       * its label would be its subscript, such as "[4]". A value that is a field in
       * a struct would use the field's name as its label, and so forth.
       * </pre>
       *
       * <code>string label = 1;</code>
       * @return The label.
       */
      public java.lang.String getLabel() {
        java.lang.Object ref = label_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          label_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * A label that describes this value's location or source in a value
       * hierarchy.
       * For example, in a stack frame, the label would be the name of the variable
       * to which the value is bound. For a value that is an element of a list, its
       * its label would be its subscript, such as "[4]". A value that is a field in
       * a struct would use the field's name as its label, and so forth.
       * </pre>
       *
       * <code>string label = 1;</code>
       * @return The bytes for label.
       */
      public com.google.protobuf.ByteString
          getLabelBytes() {
        java.lang.Object ref = label_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          label_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * A label that describes this value's location or source in a value
       * hierarchy.
       * For example, in a stack frame, the label would be the name of the variable
       * to which the value is bound. For a value that is an element of a list, its
       * its label would be its subscript, such as "[4]". A value that is a field in
       * a struct would use the field's name as its label, and so forth.
       * </pre>
       *
       * <code>string label = 1;</code>
       * @param value The label to set.
       * @return This builder for chaining.
       */
      public Builder setLabel(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        label_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A label that describes this value's location or source in a value
       * hierarchy.
       * For example, in a stack frame, the label would be the name of the variable
       * to which the value is bound. For a value that is an element of a list, its
       * its label would be its subscript, such as "[4]". A value that is a field in
       * a struct would use the field's name as its label, and so forth.
       * </pre>
       *
       * <code>string label = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearLabel() {
        
        label_ = getDefaultInstance().getLabel();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A label that describes this value's location or source in a value
       * hierarchy.
       * For example, in a stack frame, the label would be the name of the variable
       * to which the value is bound. For a value that is an element of a list, its
       * its label would be its subscript, such as "[4]". A value that is a field in
       * a struct would use the field's name as its label, and so forth.
       * </pre>
       *
       * <code>string label = 1;</code>
       * @param value The bytes for label to set.
       * @return This builder for chaining.
       */
      public Builder setLabelBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        label_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object description_ = "";
      /**
       * <pre>
       * A string description of the value.
       * </pre>
       *
       * <code>string description = 2;</code>
       * @return The description.
       */
      public java.lang.String getDescription() {
        java.lang.Object ref = description_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          description_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * A string description of the value.
       * </pre>
       *
       * <code>string description = 2;</code>
       * @return The bytes for description.
       */
      public com.google.protobuf.ByteString
          getDescriptionBytes() {
        java.lang.Object ref = description_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          description_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * A string description of the value.
       * </pre>
       *
       * <code>string description = 2;</code>
       * @param value The description to set.
       * @return This builder for chaining.
       */
      public Builder setDescription(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        description_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A string description of the value.
       * </pre>
       *
       * <code>string description = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearDescription() {
        
        description_ = getDefaultInstance().getDescription();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A string description of the value.
       * </pre>
       *
       * <code>string description = 2;</code>
       * @param value The bytes for description to set.
       * @return This builder for chaining.
       */
      public Builder setDescriptionBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        description_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object type_ = "";
      /**
       * <pre>
       * A string describing the type of the value.
       * This field may be omitted if the value does not correspond to a "real" type
       * as far as the debugging view is concerned; for example, dictionaries will
       * be rendered as sequences of key/value pairs ("entries") but the entries
       * themselves do not have a meaningful type with respect to our rendering.
       * </pre>
       *
       * <code>string type = 3;</code>
       * @return The type.
       */
      public java.lang.String getType() {
        java.lang.Object ref = type_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          type_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * A string describing the type of the value.
       * This field may be omitted if the value does not correspond to a "real" type
       * as far as the debugging view is concerned; for example, dictionaries will
       * be rendered as sequences of key/value pairs ("entries") but the entries
       * themselves do not have a meaningful type with respect to our rendering.
       * </pre>
       *
       * <code>string type = 3;</code>
       * @return The bytes for type.
       */
      public com.google.protobuf.ByteString
          getTypeBytes() {
        java.lang.Object ref = type_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          type_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * A string describing the type of the value.
       * This field may be omitted if the value does not correspond to a "real" type
       * as far as the debugging view is concerned; for example, dictionaries will
       * be rendered as sequences of key/value pairs ("entries") but the entries
       * themselves do not have a meaningful type with respect to our rendering.
       * </pre>
       *
       * <code>string type = 3;</code>
       * @param value The type to set.
       * @return This builder for chaining.
       */
      public Builder setType(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        type_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A string describing the type of the value.
       * This field may be omitted if the value does not correspond to a "real" type
       * as far as the debugging view is concerned; for example, dictionaries will
       * be rendered as sequences of key/value pairs ("entries") but the entries
       * themselves do not have a meaningful type with respect to our rendering.
       * </pre>
       *
       * <code>string type = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearType() {
        
        type_ = getDefaultInstance().getType();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * A string describing the type of the value.
       * This field may be omitted if the value does not correspond to a "real" type
       * as far as the debugging view is concerned; for example, dictionaries will
       * be rendered as sequences of key/value pairs ("entries") but the entries
       * themselves do not have a meaningful type with respect to our rendering.
       * </pre>
       *
       * <code>string type = 3;</code>
       * @param value The bytes for type to set.
       * @return This builder for chaining.
       */
      public Builder setTypeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        type_ = value;
        onChanged();
        return this;
      }

      private boolean hasChildren_ ;
      /**
       * <pre>
       * Will be false if the value is known to have no children. May sometimes be
       * true if this isn't yet known, in which case GetChildrenResponse#children
       * will be empty.
       * </pre>
       *
       * <code>bool has_children = 4;</code>
       * @return The hasChildren.
       */
      @java.lang.Override
      public boolean getHasChildren() {
        return hasChildren_;
      }
      /**
       * <pre>
       * Will be false if the value is known to have no children. May sometimes be
       * true if this isn't yet known, in which case GetChildrenResponse#children
       * will be empty.
       * </pre>
       *
       * <code>bool has_children = 4;</code>
       * @param value The hasChildren to set.
       * @return This builder for chaining.
       */
      public Builder setHasChildren(boolean value) {
        
        hasChildren_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Will be false if the value is known to have no children. May sometimes be
       * true if this isn't yet known, in which case GetChildrenResponse#children
       * will be empty.
       * </pre>
       *
       * <code>bool has_children = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearHasChildren() {
        
        hasChildren_ = false;
        onChanged();
        return this;
      }

      private long id_ ;
      /**
       * <pre>
       * An identifier for this value, used to request its children. The same value
       * may be known by multiple ids. Not set for values without children.
       * </pre>
       *
       * <code>int64 id = 5;</code>
       * @return The id.
       */
      @java.lang.Override
      public long getId() {
        return id_;
      }
      /**
       * <pre>
       * An identifier for this value, used to request its children. The same value
       * may be known by multiple ids. Not set for values without children.
       * </pre>
       *
       * <code>int64 id = 5;</code>
       * @param value The id to set.
       * @return This builder for chaining.
       */
      public Builder setId(long value) {
        
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * An identifier for this value, used to request its children. The same value
       * may be known by multiple ids. Not set for values without children.
       * </pre>
       *
       * <code>int64 id = 5;</code>
       * @return This builder for chaining.
       */
      public Builder clearId() {
        
        id_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:starlark_debugging.Value)
    }

    // @@protoc_insertion_point(class_scope:starlark_debugging.Value)
    private static final com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value();
    }

    public static com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Value>
        PARSER = new com.google.protobuf.AbstractParser<Value>() {
      @java.lang.Override
      public Value parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        Builder builder = newBuilder();
        try {
          builder.mergeFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(builder.buildPartial());
        } catch (com.google.protobuf.UninitializedMessageException e) {
          throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(e)
              .setUnfinishedMessage(builder.buildPartial());
        }
        return builder.buildPartial();
      }
    };

    public static com.google.protobuf.Parser<Value> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Value> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.starlarkdebugging.StarlarkDebuggingProtos.Value getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_DebugRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_DebugRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_SetBreakpointsRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_SetBreakpointsRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_ContinueExecutionRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_ContinueExecutionRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_EvaluateRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_EvaluateRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_ListFramesRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_ListFramesRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_StartDebuggingRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_StartDebuggingRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_PauseThreadRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_PauseThreadRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_GetChildrenRequest_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_GetChildrenRequest_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_DebugEvent_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_DebugEvent_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_Error_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_Error_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_SetBreakpointsResponse_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_SetBreakpointsResponse_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_ContinueExecutionResponse_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_ContinueExecutionResponse_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_EvaluateResponse_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_EvaluateResponse_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_ListFramesResponse_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_ListFramesResponse_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_StartDebuggingResponse_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_StartDebuggingResponse_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_PauseThreadResponse_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_PauseThreadResponse_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_GetChildrenResponse_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_GetChildrenResponse_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_ThreadPausedEvent_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_ThreadPausedEvent_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_ThreadContinuedEvent_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_ThreadContinuedEvent_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_Breakpoint_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_Breakpoint_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_Frame_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_Frame_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_Location_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_Location_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_Scope_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_Scope_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_PausedThread_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_PausedThread_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_starlark_debugging_Value_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_starlark_debugging_Value_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\nXsrc/main/java/com/google/devtools/buil" +
      "d/lib/starlarkdebug/proto/starlark_debug" +
      "ging.proto\022\022starlark_debugging\"\201\004\n\014Debug" +
      "Request\022\027\n\017sequence_number\030\001 \001(\003\022D\n\017set_" +
      "breakpoints\030e \001(\0132).starlark_debugging.S" +
      "etBreakpointsRequestH\000\022J\n\022continue_execu" +
      "tion\030f \001(\0132,.starlark_debugging.Continue" +
      "ExecutionRequestH\000\0227\n\010evaluate\030g \001(\0132#.s" +
      "tarlark_debugging.EvaluateRequestH\000\022<\n\013l" +
      "ist_frames\030h \001(\0132%.starlark_debugging.Li" +
      "stFramesRequestH\000\022D\n\017start_debugging\030i \001" +
      "(\0132).starlark_debugging.StartDebuggingRe" +
      "questH\000\022>\n\014pause_thread\030j \001(\0132&.starlark" +
      "_debugging.PauseThreadRequestH\000\022>\n\014get_c" +
      "hildren\030k \001(\0132&.starlark_debugging.GetCh" +
      "ildrenRequestH\000B\t\n\007payload\"K\n\025SetBreakpo" +
      "intsRequest\0222\n\nbreakpoint\030\001 \003(\0132\036.starla" +
      "rk_debugging.Breakpoint\"]\n\030ContinueExecu" +
      "tionRequest\022\021\n\tthread_id\030\001 \001(\003\022.\n\010steppi" +
      "ng\030\002 \001(\0162\034.starlark_debugging.Stepping\"7" +
      "\n\017EvaluateRequest\022\021\n\tthread_id\030\001 \001(\003\022\021\n\t" +
      "statement\030\002 \001(\t\"&\n\021ListFramesRequest\022\021\n\t" +
      "thread_id\030\001 \001(\003\"\027\n\025StartDebuggingRequest" +
      "\"\'\n\022PauseThreadRequest\022\021\n\tthread_id\030\001 \001(" +
      "\003\"9\n\022GetChildrenRequest\022\021\n\tthread_id\030\001 \001" +
      "(\003\022\020\n\010value_id\030\002 \001(\003\"\272\005\n\nDebugEvent\022\027\n\017s" +
      "equence_number\030\001 \001(\003\022*\n\005error\030c \001(\0132\031.st" +
      "arlark_debugging.ErrorH\000\022E\n\017set_breakpoi" +
      "nts\030e \001(\0132*.starlark_debugging.SetBreakp" +
      "ointsResponseH\000\022K\n\022continue_execution\030f " +
      "\001(\0132-.starlark_debugging.ContinueExecuti" +
      "onResponseH\000\0228\n\010evaluate\030g \001(\0132$.starlar" +
      "k_debugging.EvaluateResponseH\000\022=\n\013list_f" +
      "rames\030h \001(\0132&.starlark_debugging.ListFra" +
      "mesResponseH\000\022E\n\017start_debugging\030i \001(\0132*" +
      ".starlark_debugging.StartDebuggingRespon" +
      "seH\000\022?\n\014pause_thread\030j \001(\0132\'.starlark_de" +
      "bugging.PauseThreadResponseH\000\022?\n\014get_chi" +
      "ldren\030k \001(\0132\'.starlark_debugging.GetChil" +
      "drenResponseH\000\022?\n\rthread_paused\030\351\007 \001(\0132%" +
      ".starlark_debugging.ThreadPausedEventH\000\022" +
      "E\n\020thread_continued\030\352\007 \001(\0132(.starlark_de" +
      "bugging.ThreadContinuedEventH\000B\t\n\007payloa" +
      "d\"\030\n\005Error\022\017\n\007message\030\001 \001(\t\"\030\n\026SetBreakp" +
      "ointsResponse\"\033\n\031ContinueExecutionRespon" +
      "se\"=\n\020EvaluateResponse\022)\n\006result\030\001 \001(\0132\031" +
      ".starlark_debugging.Value\">\n\022ListFramesR" +
      "esponse\022(\n\005frame\030\001 \003(\0132\031.starlark_debugg" +
      "ing.Frame\"\030\n\026StartDebuggingResponse\"\025\n\023P" +
      "auseThreadResponse\"B\n\023GetChildrenRespons" +
      "e\022+\n\010children\030\001 \003(\0132\031.starlark_debugging" +
      ".Value\"E\n\021ThreadPausedEvent\0220\n\006thread\030\001 " +
      "\001(\0132 .starlark_debugging.PausedThread\")\n" +
      "\024ThreadContinuedEvent\022\021\n\tthread_id\030\001 \001(\003" +
      "\"_\n\nBreakpoint\0220\n\010location\030\001 \001(\0132\034.starl" +
      "ark_debugging.LocationH\000\022\022\n\nexpression\030\002" +
      " \001(\tB\013\n\tcondition\"x\n\005Frame\022\025\n\rfunction_n" +
      "ame\030\001 \001(\t\022(\n\005scope\030\002 \003(\0132\031.starlark_debu" +
      "gging.Scope\022.\n\010location\030\003 \001(\0132\034.starlark" +
      "_debugging.Location\"D\n\010Location\022\014\n\004path\030" +
      "\001 \001(\t\022\023\n\013line_number\030\002 \001(\r\022\025\n\rcolumn_num" +
      "ber\030\003 \001(\r\"A\n\005Scope\022\014\n\004name\030\001 \001(\t\022*\n\007bind" +
      "ing\030\002 \003(\0132\031.starlark_debugging.Value\"\320\001\n" +
      "\014PausedThread\022\n\n\002id\030\001 \001(\003\022\014\n\004name\030\002 \001(\t\022" +
      "5\n\014pause_reason\030\003 \001(\0162\037.starlark_debuggi" +
      "ng.PauseReason\022.\n\010location\030\004 \001(\0132\034.starl" +
      "ark_debugging.Location\022?\n\034conditional_br" +
      "eakpoint_error\030\005 \001(\0132\031.starlark_debuggin" +
      "g.Error\"[\n\005Value\022\r\n\005label\030\001 \001(\t\022\023\n\013descr" +
      "iption\030\002 \001(\t\022\014\n\004type\030\003 \001(\t\022\024\n\014has_childr" +
      "en\030\004 \001(\010\022\n\n\002id\030\005 \001(\003*1\n\010Stepping\022\010\n\004NONE" +
      "\020\000\022\010\n\004INTO\020\001\022\010\n\004OVER\020\002\022\007\n\003OUT\020\003*\240\001\n\013Paus" +
      "eReason\022\t\n\005UNSET\020\000\022\014\n\010STEPPING\020\001\022\026\n\022ALL_" +
      "THREADS_PAUSED\020\002\022\030\n\024PAUSE_THREAD_REQUEST" +
      "\020\003\022\022\n\016HIT_BREAKPOINT\020\004\022 \n\034CONDITIONAL_BR" +
      "EAKPOINT_ERROR\020\005\022\020\n\014INITIALIZING\020\006BJ\n/co" +
      "m.google.devtools.build.lib.starlarkdebu" +
      "ggingB\027StarlarkDebuggingProtosb\006proto3"
    };
    descriptor = com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        });
    internal_static_starlark_debugging_DebugRequest_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_starlark_debugging_DebugRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_DebugRequest_descriptor,
        new java.lang.String[] { "SequenceNumber", "SetBreakpoints", "ContinueExecution", "Evaluate", "ListFrames", "StartDebugging", "PauseThread", "GetChildren", "Payload", });
    internal_static_starlark_debugging_SetBreakpointsRequest_descriptor =
      getDescriptor().getMessageTypes().get(1);
    internal_static_starlark_debugging_SetBreakpointsRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_SetBreakpointsRequest_descriptor,
        new java.lang.String[] { "Breakpoint", });
    internal_static_starlark_debugging_ContinueExecutionRequest_descriptor =
      getDescriptor().getMessageTypes().get(2);
    internal_static_starlark_debugging_ContinueExecutionRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_ContinueExecutionRequest_descriptor,
        new java.lang.String[] { "ThreadId", "Stepping", });
    internal_static_starlark_debugging_EvaluateRequest_descriptor =
      getDescriptor().getMessageTypes().get(3);
    internal_static_starlark_debugging_EvaluateRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_EvaluateRequest_descriptor,
        new java.lang.String[] { "ThreadId", "Statement", });
    internal_static_starlark_debugging_ListFramesRequest_descriptor =
      getDescriptor().getMessageTypes().get(4);
    internal_static_starlark_debugging_ListFramesRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_ListFramesRequest_descriptor,
        new java.lang.String[] { "ThreadId", });
    internal_static_starlark_debugging_StartDebuggingRequest_descriptor =
      getDescriptor().getMessageTypes().get(5);
    internal_static_starlark_debugging_StartDebuggingRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_StartDebuggingRequest_descriptor,
        new java.lang.String[] { });
    internal_static_starlark_debugging_PauseThreadRequest_descriptor =
      getDescriptor().getMessageTypes().get(6);
    internal_static_starlark_debugging_PauseThreadRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_PauseThreadRequest_descriptor,
        new java.lang.String[] { "ThreadId", });
    internal_static_starlark_debugging_GetChildrenRequest_descriptor =
      getDescriptor().getMessageTypes().get(7);
    internal_static_starlark_debugging_GetChildrenRequest_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_GetChildrenRequest_descriptor,
        new java.lang.String[] { "ThreadId", "ValueId", });
    internal_static_starlark_debugging_DebugEvent_descriptor =
      getDescriptor().getMessageTypes().get(8);
    internal_static_starlark_debugging_DebugEvent_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_DebugEvent_descriptor,
        new java.lang.String[] { "SequenceNumber", "Error", "SetBreakpoints", "ContinueExecution", "Evaluate", "ListFrames", "StartDebugging", "PauseThread", "GetChildren", "ThreadPaused", "ThreadContinued", "Payload", });
    internal_static_starlark_debugging_Error_descriptor =
      getDescriptor().getMessageTypes().get(9);
    internal_static_starlark_debugging_Error_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_Error_descriptor,
        new java.lang.String[] { "Message", });
    internal_static_starlark_debugging_SetBreakpointsResponse_descriptor =
      getDescriptor().getMessageTypes().get(10);
    internal_static_starlark_debugging_SetBreakpointsResponse_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_SetBreakpointsResponse_descriptor,
        new java.lang.String[] { });
    internal_static_starlark_debugging_ContinueExecutionResponse_descriptor =
      getDescriptor().getMessageTypes().get(11);
    internal_static_starlark_debugging_ContinueExecutionResponse_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_ContinueExecutionResponse_descriptor,
        new java.lang.String[] { });
    internal_static_starlark_debugging_EvaluateResponse_descriptor =
      getDescriptor().getMessageTypes().get(12);
    internal_static_starlark_debugging_EvaluateResponse_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_EvaluateResponse_descriptor,
        new java.lang.String[] { "Result", });
    internal_static_starlark_debugging_ListFramesResponse_descriptor =
      getDescriptor().getMessageTypes().get(13);
    internal_static_starlark_debugging_ListFramesResponse_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_ListFramesResponse_descriptor,
        new java.lang.String[] { "Frame", });
    internal_static_starlark_debugging_StartDebuggingResponse_descriptor =
      getDescriptor().getMessageTypes().get(14);
    internal_static_starlark_debugging_StartDebuggingResponse_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_StartDebuggingResponse_descriptor,
        new java.lang.String[] { });
    internal_static_starlark_debugging_PauseThreadResponse_descriptor =
      getDescriptor().getMessageTypes().get(15);
    internal_static_starlark_debugging_PauseThreadResponse_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_PauseThreadResponse_descriptor,
        new java.lang.String[] { });
    internal_static_starlark_debugging_GetChildrenResponse_descriptor =
      getDescriptor().getMessageTypes().get(16);
    internal_static_starlark_debugging_GetChildrenResponse_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_GetChildrenResponse_descriptor,
        new java.lang.String[] { "Children", });
    internal_static_starlark_debugging_ThreadPausedEvent_descriptor =
      getDescriptor().getMessageTypes().get(17);
    internal_static_starlark_debugging_ThreadPausedEvent_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_ThreadPausedEvent_descriptor,
        new java.lang.String[] { "Thread", });
    internal_static_starlark_debugging_ThreadContinuedEvent_descriptor =
      getDescriptor().getMessageTypes().get(18);
    internal_static_starlark_debugging_ThreadContinuedEvent_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_ThreadContinuedEvent_descriptor,
        new java.lang.String[] { "ThreadId", });
    internal_static_starlark_debugging_Breakpoint_descriptor =
      getDescriptor().getMessageTypes().get(19);
    internal_static_starlark_debugging_Breakpoint_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_Breakpoint_descriptor,
        new java.lang.String[] { "Location", "Expression", "Condition", });
    internal_static_starlark_debugging_Frame_descriptor =
      getDescriptor().getMessageTypes().get(20);
    internal_static_starlark_debugging_Frame_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_Frame_descriptor,
        new java.lang.String[] { "FunctionName", "Scope", "Location", });
    internal_static_starlark_debugging_Location_descriptor =
      getDescriptor().getMessageTypes().get(21);
    internal_static_starlark_debugging_Location_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_Location_descriptor,
        new java.lang.String[] { "Path", "LineNumber", "ColumnNumber", });
    internal_static_starlark_debugging_Scope_descriptor =
      getDescriptor().getMessageTypes().get(22);
    internal_static_starlark_debugging_Scope_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_Scope_descriptor,
        new java.lang.String[] { "Name", "Binding", });
    internal_static_starlark_debugging_PausedThread_descriptor =
      getDescriptor().getMessageTypes().get(23);
    internal_static_starlark_debugging_PausedThread_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_PausedThread_descriptor,
        new java.lang.String[] { "Id", "Name", "PauseReason", "Location", "ConditionalBreakpointError", });
    internal_static_starlark_debugging_Value_descriptor =
      getDescriptor().getMessageTypes().get(24);
    internal_static_starlark_debugging_Value_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_starlark_debugging_Value_descriptor,
        new java.lang.String[] { "Label", "Description", "Type", "HasChildren", "Id", });
  }

  // @@protoc_insertion_point(outer_class_scope)
}
